(******************************************************************************
Editeur d'objets 3D
Copyright (C) 2003 Pascal Peter

http://pascal.peter.free.fr/
pascal.peter@free.fr

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile,
mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
voir la Licence Publique Gnrale GNU.

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas,
crivez  la Free Software Foundation Inc.,
675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
-------------------------------------------------------------------------------

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************)

program Edob3D;

uses
  Forms,
  SysUtils,
  Windows,
  UObjet in 'UObjet.pas' {FObjet},
  U_Perspective in 'U_Perspective.pas' {Form_Perspective},
  U_VueFace in 'U_VueFace.pas' {Form_VueFace},
  U_VueDroite in 'U_VueDroite.pas' {Form_VueDroite},
  U_VueGauche in 'U_VueGauche.pas' {Form_VueGauche},
  U_VueDessus in 'U_VueDessus.pas' {Form_VueDessus},
  U_Anim in 'U_Anim.pas' {Form_Anim},


  Utils in '..\commun\Utils.pas',
  UtilsSelect in '..\commun\UtilsSelect.pas',

  Animations in '..\commun\Animations.pas',
  GmXml in '..\commun\GmXml.pas',
  object2xml in '..\commun\object2xml.pas',

  glObjet3ds in '..\commun\glObjet3ds.pas',
  glMyFreeForm in '..\commun\glMyFreeForm.pas',
  GLMeshBuilderx in '..\commun\GLMeshBuilderx.pas',
  glRepere in '..\commun\glRepere.pas',

  UPBar in '..\commun\UPBar.pas',
  UTrackBar in '..\commun\UTrackBar.pas',
  USpinEdit in '..\commun\USpinEdit.pas',
  UProperties in '..\commun\UProperties.pas',
  UAPropos in '..\commun\UAPropos.pas';



{$R *.RES}



var
  NumMessageEdob3D: THandle;
  texte: atom;
  h: THandle;
begin
  SetLastError(NO_ERROR);
  CreateMutex(nil, False, PChar(ExtractFileName(application.ExeName)));
  if (GetLastError = ERROR_ALREADY_EXISTS)
    then begin
      if paramstr(1) <> '' then begin
        texte:= GlobalAddAtom(Pchar(paramstr(1)));
        h:= FindWindow(PChar('TFObjet'), nil);
        NumMessageEdob3D:= RegisterWindowMessage('Message perso Edob3D');
        PostMessage(h, NumMessageEdob3D, 0, texte);
        end;
      end
    else begin
      Keybd_event(VK_LWIN, 0, 0, 0);
      Keybd_event(Byte('M'), 0, 0, 0);
      Keybd_event(Byte('M'), 0, KEYEVENTF_KEYUP, 0);
      Keybd_event(VK_LWIN, 0, KEYEVENTF_KEYUP, 0);

      Application.Initialize;
      Application.CreateForm(TFObjet, FObjet);
      Application.CreateForm(TForm_Anim, Form_Anim);
      Application.Run;
      end;
end.
