unit Simulations;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  MMSystem,
  ShellAPI,
  Menus;

const
  //la touche pour fermer les dialogues;
  //si on en veut une autre, il suffit de changer ici
  TouchePourContinuer = VK_F5;

  SimulId_ProgHandle              =  0;
  SimulId_NomFichier              =  1;
  SimulId_Continuer               = -2;

  ProgId_StopperSimul             =  0;
  ProgId_OrigineClient            =  1;
  ProgId_FormHandle               =  2;

  ProgId_ModifierDossierCourant   = 10;

  ProgId_DansControl              = 20;
  ProgId_DansControlPrecis        = 21;
  ProgId_DansMenu                 = 22;
  ProgId_DansMenuItem             = 23;
  ProgId_DansPopupMenu            = 24;
  ProgId_DansPopupMenuPrecis      = 25;



type
  TPData = ^TData;
  TData = Packed record
    Id: integer;
    Chaine1, Chaine2, Chaine3: string[255];
    Entier1, Entier2: integer;
    P1, P2: TPoint;
  end;

var
  Prog_Handle, Simul_Handle, NumMessageSimul: THandle;

  Prog_DossierCourant: string;

  Simul_Recu: boolean;

  Simul_SonClic, Simul_SonClicDroit, Simul_SonDoubleClic, Simul_SonMouseDown, Simul_SonMouseUp: TMemoryStream;

  //pour bloquer clavier et souris :
  Simul_Bloquer, Simul_BlocageOK: boolean;
  Simul_FonctionBloquer: function (Block: BOOL): BOOL; stdcall;

  Simul_VitesseSimulation: integer;

  PositionSouris, PositionDialogs: TPoint;
  PositionSourisEnMemoire: array[1..10] of TPoint;




procedure Envoyer(HandleOrigine, HandleDestination: THandle; DataAEnvoyer: TData);

procedure Prog_LancerSimul(Handle: THandle; CheminDidacticiel: string);
procedure Prog_StopperSimul;
procedure Prog_OuvrirSimulation(FileName: string);
procedure Prog_Continuer;
procedure Prog_TraiteQuestion(msg: TMessage);
procedure Prog_EnvoyerReponse(P: TPoint);
function Prog_DansRect(Rect: TRect): TPoint;
function Prog_DansRectPrecis(Rect: TRect; X, Y: integer): TPoint;
function Prog_RetourneRect(Control: TControl): TRect;
function Prog_DansControl(Control: TControl): TPoint;
function Prog_DansControlPrecis(Control: TControl; X, Y: integer): TPoint;
function Prog_DansPopupMenu(Form: TForm; PopupMenu: TPopupMenu; MenuItem: TMenuItem; X, Y: integer): TPoint;
function Prog_PositionMenuItem(MenuItem: TMenuItem): integer;


procedure Simul_initialization;
procedure Simul_finalization;
function Simul_FunctionDetect (LibName, FuncName: String; var LibPointer: Pointer): boolean;
procedure Simul_EnvoyerQuestion(DataAEnvoyer: TData);
procedure Simul_Attendre(Duree: single);
function Simul_Distance(P1, P2: TPoint): single;
procedure Simul_BougeSouris(P1, P2: TPoint; Duree: single);
procedure Simul_DeplaceSourisEn(P: TPoint);
procedure Simul_DeplaceSouris(P: TPoint);
function Simul_DansDialogue(ClasseFen, TexteFen, ClasseCtrl, TexteCtrl: string): TRect;
procedure Simul_MouseDown(BoutonDroit: boolean);
procedure Simul_MouseUp(BoutonDroit: boolean);
procedure Simul_Clic;
procedure Simul_ClicDroit;
procedure Simul_DoubleClic;
procedure Simul_DragDrop(P1, P2: TPoint; BoutonDroit: boolean);
procedure Simul_KeyDown(Touche: string);
procedure Simul_KeyUp(Touche: string);






















implementation

procedure Envoyer(HandleOrigine, HandleDestination: THandle; DataAEnvoyer: TData);
var
  CopyDataStruct: TCopyDataStruct;
begin
  CopyDataStruct.cbData:= SizeOf(DataAEnvoyer);
  CopyDataStruct.lpData:= @DataAEnvoyer;
  SendMessage(HandleDestination, WM_COPYDATA, HandleOrigine, LongInt(@CopyDataStruct));
end;











{Lance le programme de simulation
puis lui envoie le handle pour qu'il puisse dialoguer}
procedure Prog_LancerSimul(Handle: THandle; CheminDidacticiel: string);
var
  NomProgDidacticiel: string;
  DataAEnvoyer: TData;
begin
  if Simul_Handle > 0 then exit;
  Prog_Handle:= Handle;
  NomProgDidacticiel:= 'Simul.exe';
  ShellExecute(Application.Handle,
               PChar('open'),
               PChar(NomProgDidacticiel),
               #0,
               PChar(CheminDidacticiel),
               SW_SHOW);
  sleep(1000);
  Simul_Handle:= FindWindow(PChar('TFSimul'), nil);
  DataAEnvoyer.Id:= SimulId_ProgHandle;
  DataAEnvoyer.Entier1:= Prog_Handle;
  Envoyer(Prog_Handle, Simul_Handle, DataAEnvoyer);
end;

procedure Prog_StopperSimul;
begin
  SendMessage(Simul_Handle, WM_CLOSE, 0, 0);
  Simul_Handle:= 0;
end;

procedure Prog_OuvrirSimulation(FileName: string);
var
  DataAEnvoyer: TData;
begin
  DataAEnvoyer.Id:= SimulId_NomFichier;
  DataAEnvoyer.Chaine1:= FileName;
  Envoyer(Prog_Handle, Simul_Handle, DataAEnvoyer);
end;

procedure Prog_Continuer;
begin
  Prog_EnvoyerReponse(Point(SimulId_Continuer, 0));
end;

//pour rpondre aux questions reues :
procedure Prog_TraiteQuestion(msg: TMessage);
type
  TPCopyDataStruct = ^TCopyDataStruct;
  TPDataRecus = ^TData;
var
  DataRecus: TData;
  PDataRecus: TPDataRecus;
  PCopyDataStruct: TPCopyDataStruct;
  a, b, c: string;
  P: TPoint;
  Control: TControl;
  Menu: TMenu;
  PopupMenu: TPopupMenu;
  MenuItem: TMenuItem;
  Form: TForm;
begin
  PCopyDataStruct:= TPCopyDataStruct(msg.LParam);
  PDataRecus:= PCopyDataStruct^.lpData;
  DataRecus:= PDataRecus^;
  case DataRecus.Id of
    ProgId_StopperSimul: begin
        Prog_StopperSimul;
        Prog_DossierCourant:= '';
        end;
    ProgId_OrigineClient: begin
        a:= DataRecus.Chaine1;
        Form:= TForm(Application.findcomponent(a));
        Prog_EnvoyerReponse(Form.ClientOrigin);
        end;
    ProgId_FormHandle: begin
        a:= DataRecus.Chaine1;
        Form:= TForm(Application.findcomponent(a));
        Prog_EnvoyerReponse(point(Form.Handle, 0));
        end;

    ProgId_ModifierDossierCourant: begin
        a:= DataRecus.Chaine1;
        Prog_DossierCourant:= ExtractFilePath(Application.ExeName) + a;
        a:= GetCurrentDir;
        SetCurrentDir(Prog_DossierCourant);
        Prog_DossierCourant:= GetCurrentDir + '\';
        SetCurrentDir(a);
        end;

    ProgId_DansControl: begin
        a:= DataRecus.Chaine1;
        Form:= TForm(Application.findcomponent(a));
        b:= DataRecus.Chaine2;
        if b <> a
          then Control:= TControl(Form.findcomponent(b))
          else Control:= TControl(Form);
        Prog_EnvoyerReponse(Prog_DansControl(Control));
        end;
    ProgId_DansControlPrecis: begin
        a:= DataRecus.Chaine1;
        Form:= TForm(Application.findcomponent(a));
        b:= DataRecus.Chaine2;
        if b <> a
          then Control:= TControl(Form.findcomponent(b))
          else Control:= TControl(Form);
        P:= DataRecus.P1;
        Prog_EnvoyerReponse(Prog_DansControlPrecis(Control, P.X, P.Y));
        end;
    ProgId_DansPopupMenu: begin
        a:= DataRecus.Chaine1;
        Form:= TForm(Application.findcomponent(a));
        b:= DataRecus.Chaine2;
        PopupMenu:= TPopupMenu(Form.findcomponent(b));
        c:= DataRecus.Chaine3;
        MenuItem:= TMenuItem(Form.findcomponent(c));
        Prog_EnvoyerReponse(Prog_DansPopupMenu(Form, PopupMenu, MenuItem, 50, 50));
        end;
    ProgId_DansPopupMenuPrecis: begin
        a:= DataRecus.Chaine1;
        Form:= TForm(Application.findcomponent(a));
        b:= DataRecus.Chaine2;
        PopupMenu:= TPopupMenu(Form.findcomponent(b));
        c:= DataRecus.Chaine3;
        MenuItem:= TMenuItem(Form.findcomponent(c));
        P:= DataRecus.P1;
        Prog_EnvoyerReponse(Prog_DansPopupMenu(Form, PopupMenu, MenuItem, P.X, P.Y));
        end;
    ProgId_DansMenu: begin
        a:= DataRecus.Chaine1;
        Form:= TForm(Application.findcomponent(a));
        b:= DataRecus.Chaine2;
        Menu:= TMenu(Form.findcomponent(b));
        c:= DataRecus.Chaine3;
        MenuItem:= TMenuItem(Form.findcomponent(c));
        Prog_EnvoyerReponse(point(Menu.Handle, Prog_PositionMenuItem(MenuItem)));
        end;
    ProgId_DansMenuItem: begin
        a:= DataRecus.Chaine1;
        Form:= TForm(Application.findcomponent(a));
        b:= DataRecus.Chaine2;
        MenuItem:= TMenuItem(Form.findcomponent(b));
        P.X:= MenuItem.Handle;
        c:= DataRecus.Chaine3;
        MenuItem:= TMenuItem(Form.findcomponent(c));
        P.Y:= Prog_PositionMenuItem(MenuItem);
        Prog_EnvoyerReponse(P);
        end;


    end;
end;

//Rponse  Simul; on utilise un PostMessage car le focus peut tre ailleurs :
procedure Prog_EnvoyerReponse(P: TPoint);
var
  WParam1: WPARAM;
  LParam1: LPARAM;
begin
  WParam1:= P.X;
  LParam1:= P.Y;
  PostMessage(Simul_Handle, NumMessageSimul, WParam1, LParam1);
end;

//Trouver Rect ou Point :
function Prog_DansRect(Rect: TRect): TPoint;
begin
  result:= Point((Rect.Right + Rect.Left) div 2,
                 (Rect.Bottom + Rect.Top) div 2);
end;

function Prog_DansRectPrecis(Rect: TRect; X, Y: integer): TPoint;
var
  P1, P2: TPoint;
begin
  P1:= Rect.TopLeft;
  P2:= Rect.BottomRight;
  Result:= Point(Trunc(P1.X + X * (P2.X - P1.X) / 100), Trunc(P1.Y + Y * (P2.Y - P1.Y) / 100));
end;

function Prog_RetourneRect(Control: TControl): TRect;
var
  P1, P2: TPoint;
begin
  P1:= Point(0, 0);
  P1:= Control.ClientToScreen(P1);
  P2:= Point(Control.ClientWidth, Control.ClientHeight);
  P2:= Control.ClientToScreen(P2);
  Result:= Rect(P1.X, P1.Y, P2.X, P2.Y);
end;

function Prog_DansControl(Control: TControl): TPoint; 
begin
  Result:= Prog_DansRect(Prog_RetourneRect(Control));
end;

function Prog_DansControlPrecis(Control: TControl; X, Y: integer): TPoint;
begin
  Result:= Prog_DansRectPrecis(Prog_RetourneRect(Control), X, Y);
end;

function Prog_DansPopupMenu(Form: TForm; PopupMenu: TPopupMenu; MenuItem: TMenuItem; X, Y: integer): TPoint;
var
  R: TRect;
  PR, PO, PP: TPoint;
  h: array[0..4] of integer;
begin
  //on teste 4 points autour de la souris pour savoir o surgit le popup
  //PP sera le coin du popup :
  GetCursorPos(PP);
  if (PP.X = PopupMenu.PopupPoint.X) and (PP.Y = PopupMenu.PopupPoint.Y)
    then begin
      PO.X:= PP.X + 1; PO.Y:= PP.Y + 1;
      h[1]:= WindowFromPoint(PO);
      PO.X:= PP.X + 1; PO.Y:= PP.Y - 1;
      h[2]:= WindowFromPoint(PO);
      PO.X:= PP.X - 1; PO.Y:= PP.Y - 1;
      h[3]:= WindowFromPoint(PO);
      PO.X:= PP.X - 1; PO.Y:= PP.Y + 1;
      h[4]:= WindowFromPoint(PO);
      if h[1] = h[2]
        then begin
          if h[1] = h[3] then h[0]:= h[4] else h[0]:= h[3];
          end
        else begin
          if h[1] = h[3] then h[0]:= h[2] else h[0]:= h[1];
          end;
      getwindowrect(h[0], R);
      PP:= R.TopLeft;
      end
    else PP:= PopupMenu.PopupPoint;

  //PO sera le coin de la Form :
  R:= Form.ClientRect;
  PO:= Form.ClientToScreen(R.TopLeft);
  //PR le point du MenuItem, mais d'aprs PO :
  GetMenuItemRect(Form.handle,
                  PopupMenu.handle,
                  Prog_PositionMenuItem(MenuItem),
                  R);
  PR:= Prog_DansRectPrecis(R, X, Y);
  //On rectifie pour avoir le vrai PR :
  PR.X:= PR.X - PO.X + PP.X;
  PR.Y:= PR.Y - PO.Y + PP.Y;
  Result:= PR;

end;

function Prog_PositionMenuItem(MenuItem: TMenuItem): integer;
var
  i, j: integer;
begin
  i:= MenuItem.MenuIndex;
  if i > 0 then
    for j:= 0 to MenuItem.MenuIndex - 1 do
      if TMenuItem(MenuItem.Parent)[j].Visible = False then
        i:= i - 1;
  Result:= i;
end;















//initialisation etc :
procedure Simul_initialization;
var
  Chemin: string;
begin
  getCursorPos(PositionSouris);
  PositionDialogs:= Prog_DansRect(Screen.WorkAreaRect);
  {
  if Simul_FunctionDetect('USER32.DLL', 'BlockInput', @Simul_FonctionBloquer) = False
    then begin
      //showmessage('Blocage impossible');
      Simul_BlocageOK:= False;
      end
    else Simul_BlocageOK:= True;
  }  
  Simul_VitesseSimulation:= 100;
  Chemin:= ExtractFilePath(Application.ExeName);
  Simul_SonClic:= TMemoryStream.create;
  Simul_SonClic.LoadFromFile(Chemin + 'Clic.wav');
  Simul_SonClicDroit:= TMemoryStream.create;
  Simul_SonClicDroit.LoadFromFile(Chemin + 'ClicDroit.wav');
  Simul_SonDoubleClic:= TMemoryStream.create;
  Simul_SonDoubleClic.LoadFromFile(Chemin + 'DoubleClic.wav');
  Simul_SonMouseDown:= TMemoryStream.create;
  Simul_SonMouseDown.LoadFromFile(Chemin + 'MouseDown.wav');
  Simul_SonMouseUp:= TMemoryStream.create;
  Simul_SonMouseUp.LoadFromFile(Chemin + 'MouseUp.wav');
end;

procedure Simul_finalization;
begin
  Simul_SonClic.free;
  Simul_SonClicDroit.free;
  Simul_SonDoubleClic.free;
  Simul_SonMouseDown.free;
  Simul_SonMouseUp.free;
end;


//pour bloquer clavier et souris :
function Simul_FunctionDetect (LibName, FuncName: String; var LibPointer: Pointer): boolean;
var
  LibHandle: tHandle;
begin
  Result:= false;
  LibPointer:= nil;
  if LoadLibrary(PChar(LibName)) = 0 then exit;
  LibHandle:= GetModuleHandle(PChar(LibName));
  if LibHandle <> 0 then begin
    LibPointer:= GetProcAddress(LibHandle, PChar(FuncName));
    if LibPointer <> nil then Result:= true;
    end;
end;

//pour poser une question  Prog :
procedure Simul_EnvoyerQuestion(DataAEnvoyer: TData);
begin
  Simul_Recu:= False;
  Envoyer(Simul_Handle, Prog_Handle, DataAEnvoyer);
  while Simul_Recu = False do Application.ProcessMessages;
end;

//Attendre :
procedure Simul_Attendre(Duree: single);
var
  TimeDebut, TimeActuel: single;
  Fini: boolean;
begin
  TimeDebut:= TimeGetTime;
  Fini:= False;
  while Fini = False do begin
    Application.ProcessMessages;
    TimeActuel:= TimeGetTime - TimeDebut;
    if TimeActuel >= Duree then Fini:= True;
    if Simul_Bloquer then SetCursorPos(PositionSouris.X, PositionSouris.Y);
    end;
end;

//Dplacements :
function Simul_Distance(P1, P2: TPoint): single;
begin
  Result:= sqrt(sqr(P2.X - P1.X) + sqr(P2.Y - P1.Y));
end;

procedure Simul_BougeSouris(P1, P2: TPoint; Duree: single);
var
  t: single;
  TimeDebut, TimeActuel: single;
  Fini: boolean;
begin
  TimeDebut:= TimeGetTime;
  Fini:= False;
  while Fini = False do begin
    TimeActuel:= TimeGetTime - TimeDebut;
    if TimeActuel < Duree
      then begin
        t:= TimeActuel / Duree;
        PositionSouris.X:= round(t * P2.X + (1 - t) * P1.X);
        PositionSouris.Y:= round(t * P2.Y + (1 - t) * P1.Y);
        setcursorpos(PositionSouris.X, PositionSouris.Y);
        end
      else begin
        PositionSouris:= P2;
        setcursorpos(PositionSouris.X, PositionSouris.Y);
        Fini:= True;
        end;
    end;
end;

procedure Simul_DeplaceSourisEn(P: TPoint);
var
  P0: TPoint;
  d, r, t: single;
  i: integer;
  Duree: single;
  NbPointsIntermediaires: integer;
  PointsIntermediaires: array[1..12] of TPoint;
begin
  getCursorPos(P0);
  d:= Simul_Distance(P0, P);
  Duree:= 10000 / Simul_VitesseSimulation;
  NbPointsIntermediaires:= round(10 * d / Screen.Width);
  if NbPointsIntermediaires > 0
    then begin
      r:= d / (10 * NbPointsIntermediaires);
      for i:= 1 to NbPointsIntermediaires do begin
        t:= i / (NbPointsIntermediaires + 1);
        PointsIntermediaires[i].X:= round(t * P.X + (1 - t) * P0.X - r + 2 * r * random);
        PointsIntermediaires[i].Y:= round(t * P.Y + (1 - t) * P0.Y - r + 2 * r * random);
        end;
      Simul_BougeSouris(P0, PointsIntermediaires[1], Duree);
      Application.ProcessMessages;
      if NbPointsIntermediaires > 1 then
        for i:= 1 to NbPointsIntermediaires - 1 do begin
          Simul_BougeSouris(PointsIntermediaires[i], PointsIntermediaires[i + 1], Duree);
          Application.ProcessMessages;
          end;
      Simul_BougeSouris(PointsIntermediaires[NbPointsIntermediaires], P, Duree);
      Application.ProcessMessages;
      end
    else Simul_BougeSouris(P0, P, Duree);
end;

procedure Simul_DeplaceSouris(P: TPoint);
var
  P0, P1: TPoint;
begin
  getCursorPos(P0);
  P1.X:= P0.X + P.X;
  P1.Y:= P0.Y + P.Y;
  Simul_DeplaceSourisEn(P1);
end;

//pour manipuler une bote de dialogue :
function Simul_DansDialogue(ClasseFen, TexteFen, ClasseCtrl, TexteCtrl: string): TRect;
var
  HFen, HCtrl: THandle;
begin
  Application.ProcessMessages;
  if TexteFen <> ''
    then HFen:= FindWindow(PChar(ClasseFen), PChar(TexteFen))
    else HFen:= FindWindow(PChar(ClasseFen), nil);
  if TexteCtrl <> ''
    then HCtrl:= FindWindowEx(HFen, 0, PChar(ClasseCtrl), PChar(TexteCtrl))
    else HCtrl:= FindWindowEx(HFen, 0, PChar(ClasseCtrl), nil);
  GetWindowRect(HCtrl, Result);
end;

//Clics etc :
procedure Simul_MouseDown(BoutonDroit: boolean);
begin
  PlaySound(Simul_SonMouseDown.Memory, 0, SND_ASYNC or SND_MEMORY);
  if BoutonDroit
    then begin
      mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
      end
    else begin
      mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
      end;
  Simul_Attendre(500);
end;

procedure Simul_MouseUp(BoutonDroit: boolean);
begin
  PlaySound(Simul_SonMouseUp.Memory, 0, SND_ASYNC or SND_MEMORY);
  if BoutonDroit
    then begin
      mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
      end
    else begin
      mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
      end;
  Simul_Attendre(500);
end;

procedure Simul_Clic;
var
  Simul_BloquerEx: boolean;
begin
  Simul_BloquerEx:= Simul_Bloquer;
  Simul_Bloquer:= False;
  Simul_Attendre(500);
  mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
  PlaySound(Simul_SonClic.Memory, 0, SND_ASYNC or SND_MEMORY);
  Simul_Attendre(200);
  mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
  Simul_Bloquer:= Simul_BloquerEx;
end;

procedure Simul_ClicDroit;
var
  Simul_BloquerEx: boolean;
begin
  Simul_BloquerEx:= Simul_Bloquer;
  Simul_Bloquer:= False;
  Simul_Attendre(500);
  mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
  PlaySound(Simul_SonClicDroit.Memory, 0, SND_ASYNC or SND_MEMORY);
  Simul_Attendre(200);
  mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
  Simul_Bloquer:= Simul_BloquerEx;
end;

/////
procedure Simul_DoubleClic;
var
  P: TPoint;
  h: Thandle;
  Mpos: TMessage;
  rect: Trect;
begin
  getCursorPos(P);
  h:= WindowFromPoint(P);
  GetWindowRect(h, rect);
  Mpos.LParamLo := P.X - rect.Left;
  Mpos.LParamHI := P.Y - rect.top;
  postMessage(h, WM_LBUTTONDBLCLK, HTCLIENT, Mpos.LParam);
  PlaySound(Simul_SonDoubleClic.Memory, 0, SND_ASYNC or SND_MEMORY);
  postMessage(h, WM_CAPTURECHANGED, 0, 0);
end;

procedure Simul_DragDrop(P1, P2: TPoint; BoutonDroit: boolean);
begin
  if BoutonDroit
    then begin
      Simul_DeplaceSourisEn(P1);
      mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
      PlaySound(Simul_SonMouseDown.Memory, 0, SND_ASYNC or SND_MEMORY);
      Simul_Attendre(200);
      Simul_DeplaceSourisEn(P2);
      mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
      PlaySound(Simul_SonMouseUp.Memory, 0, SND_ASYNC or SND_MEMORY);
      end
    else begin
      Simul_DeplaceSourisEn(P1);
      mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
      PlaySound(Simul_SonMouseDown.Memory, 0, SND_ASYNC or SND_MEMORY);
      Simul_Attendre(200);
      Simul_DeplaceSourisEn(P2);
      PlaySound(Simul_SonMouseUp.Memory, 0, SND_ASYNC or SND_MEMORY);
      mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
      end;
end;


procedure Simul_KeyDown(Touche: string);
begin
  if Touche = 'Shift' then keybd_event(VK_SHIFT, 0, 0, 0)
  else if Touche = 'Ctrl' then keybd_event(VK_CONTROL, 0, 0, 0)
  else if Touche = 'Alt' then keybd_event(VK_MENU, 0, 0, 0)
  else if Touche = 'Enter' then keybd_event(VK_RETURN, 0, 0, 0)
  else if Touche = 'Del' then keybd_event(VK_DELETE, 0, 0, 0)
  else if Touche = 'Bas' then keybd_event(VK_DOWN, 0, 0, 0)
  else if Touche = 'A' then keybd_event(Byte(char('A')), 0, 0, 0)
  else if Touche = 'C' then keybd_event(Byte(char('C')), 0, 0, 0)
  else if Touche = 'V' then keybd_event(Byte(char('V')), 0, 0, 0)
//  else if Touche = 'aaa' then keybd_event(VK_, 0, 0, 0)
  else;
  Application.ProcessMessages;
end;

procedure Simul_KeyUp(Touche: string);
begin
  if Touche = 'Shift' then keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0)
  else if Touche = 'Ctrl' then keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0)
  else if Touche = 'Alt' then keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP, 0)
  else if Touche = 'Enter' then keybd_event(VK_RETURN, 0, KEYEVENTF_KEYUP, 0)
  else if Touche = 'Del' then keybd_event(VK_DELETE, 0, KEYEVENTF_KEYUP, 0)
  else if Touche = 'Bas' then keybd_event(VK_DOWN, 0, KEYEVENTF_KEYUP, 0)
  else if Touche = 'A' then keybd_event(Byte(char('A')), 0, KEYEVENTF_KEYUP, 0)
  else if Touche = 'C' then keybd_event(Byte(char('C')), 0, KEYEVENTF_KEYUP, 0)
  else if Touche = 'V' then keybd_event(Byte(char('V')), 0, KEYEVENTF_KEYUP, 0)
//  else if Touche = 'aaa' then keybd_event(VK_, 0, KEYEVENTF_KEYUP, 0)
  else;
  Application.ProcessMessages;
end;



end.

