unit UConfiguration;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons{,
  JvBaseDlg, JvBrowseFolder};

type
  TFConfiguration = class(TForm)
    RadioGroup1: TRadioGroup;
    CheckBoxAssociation: TCheckBox;
    LabelLangue: TLabel;
    ButtonOK: TButton;
    ButtonLangue: TButton;
    LabelCheminFichiers: TLabel;
    ButtonCheminFichiers: TButton;
    EditCheminFichiers: TEdit;
    procedure RadioGroup1Click(Sender: TObject);
    procedure CheckBoxAssociationClick(Sender: TObject);
    procedure ButtonLangueClick(Sender: TObject);
    procedure ButtonCheminFichiersClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FConfiguration: TFConfiguration;

implementation

{$R *.dfm}

uses
  UObjet, Utils;

procedure TFConfiguration.RadioGroup1Click(Sender: TObject);
var
  i: integer;
begin
  if FObjet.PetitsBoutons
    then i:= 1
    else i:= 0;
  if i = RadioGroup1.ItemIndex then exit;
  FObjet.PetitsBoutons:= (i = 0);
  FObjet.TailleBoutons;
end;

procedure TFConfiguration.CheckBoxAssociationClick(Sender: TObject);
begin
  FObjet.AssociationFichiers:= CheckBoxAssociation.Checked;
  if FObjet.AssociationFichiers
    then FObjet.VerifBDR
    else FObjet.SupprimeBDR;
  CheckBoxAssociation.Checked:= FObjet.AssociationFichiers;
end;

procedure TFConfiguration.ButtonLangueClick(Sender: TObject);
begin
  FObjet.ChoisirLangue;

  caption:= GmXMLLangue.GetStringByPath('Hints\Setting');
  LabelLangue.Caption:= GmXMLLangue.GetStringByPath('Hints\Language') + ' :   ' + ChangeFileExt(FObjet.FichierLangue, '');
  CheckBoxAssociation.caption:= GmXMLLangue.GetStringByPath('Hints\FileAssociation');
  RadioGroup1.Items[0]:= GmXMLLangue.GetStringByPath('Hints\BigButtons');
  RadioGroup1.Items[1]:= GmXMLLangue.GetStringByPath('Hints\SmallButtons');
  ButtonLangue.caption:= GmXMLLangue.GetStringByPath('Hints\Choose');
  ButtonOK.caption:= GmXMLLangue.GetStringByPath('Hints\OK');

end;

procedure TFConfiguration.ButtonCheminFichiersClick(Sender: TObject);
var
  dir: String;
begin
  //SelectDirectory('Ton Titre', CheminFichiers, dir);
  Dir:= EditCheminFichiers.Text;
  if not DirectoryExists(Dir) then Dir:= CheminFichiers;


 { JvBrowseForFolderDialog1.Options:= [];
  JvBrowseForFolderDialog1.Options:= JvBrowseForFolderDialog1.Options
                                     + [odNewDialogStyle]
                                     + [odOnlyDirectory];

  JvBrowseForFolderDialog1.Rootdirectory:= fdRootFolder;
  JvBrowseForFolderDialog1.Directory:= CheminFichiers;

  if JvBrowseForFolderDialog1.Execute then
    CheminFichiers:= JvBrowseForFolderDialog1.Directory;
  EditCheminFichiers.Text:= CheminFichiers;  }
end;

end.
