(******************************************************************************
Editeur d'objets 3D
Copyright (C) 2003 Pascal Peter

http://pascal.peter.free.fr/
pascal.peter@free.fr

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile,
mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
voir la Licence Publique Gnrale GNU.

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas,
crivez  la Free Software Foundation Inc.,
675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
-------------------------------------------------------------------------------

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************)
unit UObjet;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtDlgs, ToolWin, ComCtrls, ExtCtrls, StdCtrls, ImgList, Menus,

  GLScene, GLObjects, GLGeomObjects, GLPolyhedron, GLTeapot,
  GLCadencer, GLMisc, GLWin32Viewer, GLTexture, GLGraph,
  VectorGeometry,
  Keyboard,

  GLVectorFileObjects,
  OpenGL1x,

  glMyFreeForm,

  Utils, UtilsSelect,
  UAPropos, Animations,
  Simulations,
  UOptions, UConfiguration, GmXML,


  jpeg, {GraphicEx, }ShellApi, Registry, MMSystem, GLAVIRecorder, GLGraphics;


type

  TFObjet = class(TForm)
    GLScene1: TGLScene;
    GLCadencer1: TGLCadencer;
    GLCamera_Perspective: TGLCamera;
    World: TGLDummyCube;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ColorDialog1: TColorDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    Panel1: TPanel;
    GLLightSource1: TGLLightSource;
    GLCamera_VueFace: TGLCamera;
    GLCamera_VueDroite: TGLCamera;
    GLCamera_VueGauche: TGLCamera;
    GLCamera_VueDessus: TGLCamera;
    XYZGrid1: TGLXYZGrid;
    Panel3: TPanel;
    ComboBox1: TComboBox;
    Panel2: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Target: TGLDummyCube;

    PanelBarreDOutils:          TPanel;
    ImageListBoutons: TImageList;

    ToolBar1:                   TToolBar;
    ToolButton_Didacticiel:     TToolButton;
    ToolButton_Aide:            TToolButton;
    ToolButton_APropos:         TToolButton;

    ToolBar3:                   TToolBar;
    ToolButton_Quitter:         TToolButton;
    ToolButton6:                TToolButton;
    ToolButton_Nouveau:         TToolButton;
    ToolButton_Ouvrir:          TToolButton;
    ToolButton_Enregistrer:     TToolButton;
    ToolButton5:                TToolButton;
    ToolButton_Objet:           TToolButton;
    ToolButton4:                TToolButton;
    ToolButton_Perspective:     TToolButton;
    ToolButton_VueFace:         TToolButton;
    ToolButton_VueGauche:       TToolButton;
    ToolButton_VueDroite:       TToolButton;
    ToolButton_VueDessus:       TToolButton;
    ToolButton2:                TToolButton;
    ToolButton_Anim:            TToolButton;

    PopupMenu_Objet:    TPopupMenu;
    mo_Cube:            TMenuItem;
    mo_Sphere:          TMenuItem;
    mo_Cylindre:        TMenuItem;
    mo_Cone:            TMenuItem;
    mo_Tore:            TMenuItem;
    mo_Dodecahedre:     TMenuItem;
    mo_Octahedron:      TMenuItem;
    mo_Teapot:          TMenuItem;
    mo_N1:              TMenuItem;
    mo_ImporterObjet:   TMenuItem;
    mo_ImporterFichier: TMenuItem;
    N1:                 TMenuItem;
    mo_CSG:             TMenuItem;

    PopupMenu_Scene:    TPopupMenu;
    mnCouleurFond:      TMenuItem;
    mnGrille:           TMenuItem;

    PopupMenu_Ouvrir:   TPopupMenu;
    mnouvrirobjet1:     TMenuItem;
    mnouvriranim1:      TMenuItem;
    mnouvrirtout1:      TMenuItem;

    PopupMenu_Enregistrer:      TPopupMenu;
    mnEnregistrer:              TMenuItem;
    mnEnregistrerSous:          TMenuItem;
    mnEnregistrerMesh:          TMenuItem;
    mnEnregistrerVRML:          TMenuItem;
    mnEnregistrerAvi:           TMenuItem;
    mnEnregistrerBmps:          TMenuItem;

    PopupMenu_Didacticiel: TPopupMenu;

    ToolButton_Config: TToolButton;
    ToolButton1: TToolButton;
    AVIRecorder1: TAVIRecorder;

    GLMaterialLibrary1: TGLMaterialLibrary;
    Panel4: TPanel;
    Label_X: TLabel;
    Label_Y: TLabel;
    Label_Z: TLabel;
    CheckBox_X: TCheckBox;
    CheckBox_Y: TCheckBox;
    CheckBox_Z: TCheckBox;
    mnEnregistrerPOV: TMenuItem;

    procedure FormCreate(Sender: TObject);
    procedure ToolButton_QuitterClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);

    procedure ToolButton_AideClick(Sender: TObject);
    procedure ToolButton_AProposClick(Sender: TObject);

    procedure GLCadencer1Progress(Sender: TObject; const deltaTime,
      newTime: Double);





    procedure GLSceneViewerMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewerMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure GLSceneViewerMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    procedure ToolButton_NouveauClick(Sender: TObject);

    procedure NouvelObjet(Sender: TObject);
    procedure mo_ImporterObjetClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox1Enter(Sender: TObject);
    procedure ComboBox1Exit(Sender: TObject);
    procedure ToolButton_EnregistrerClick(Sender: TObject);
    procedure ToolButton_PerspectiveClick(Sender: TObject);
    procedure ToolButton_VueFaceClick(Sender: TObject);
    procedure ToolButton_VueDroiteClick(Sender: TObject);
    procedure ToolButton_VueGaucheClick(Sender: TObject);
    procedure ToolButton_VueDessusClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ToolButton_AnimClick(Sender: TObject);
    procedure ToolButton_ObjetClick(Sender: TObject);
    procedure ToolButton_DidacticielClick(Sender: TObject);
    procedure LanceDidacticiel(Sender: TObject);
    procedure mnouvrirobjet1Click(Sender: TObject);
    procedure mnouvriranim1Click(Sender: TObject);
    procedure mnouvrirtout1Click(Sender: TObject);
    procedure ToolButton_OuvrirClick(Sender: TObject);
    procedure mnCouleurFondClick(Sender: TObject);
    procedure mnGrilleClick(Sender: TObject);
    procedure ToolButton_ConfigClick(Sender: TObject);
    procedure mnEnregistrerClick(Sender: TObject);
    procedure mnEnregistrerSousClick(Sender: TObject);
    procedure mnEnregistrerVRMLClick(Sender: TObject);
    procedure mnEnregistrerAviClick(Sender: TObject);
    procedure mnEnregistrerBmpsClick(Sender: TObject);
    procedure mo_ImporterFichierClick(Sender: TObject);
    procedure mnEnregistrerMeshClick(Sender: TObject);
    procedure mnEnregistrerPOVClick(Sender: TObject);
  private
    { Dclarations prives }
    CheminDidacticiel, NomFichierAide: string;
    StringListDidacticiels: TStringList;

    Indice_Trucs, NbTrucs: integer;
    NumMessageEdob3D: THandle;
    FichierAOuvrir: string;

    procedure ChargerBoutons(NomFichier: string);

    procedure MiseEnPlaceDesTextes;
    procedure ChangeTexteTrucs;
    procedure HandleKeys;

    procedure RecupereConfig;
    procedure SauveConfig;

    procedure Ouvrir(NomDuFichier: string);


    procedure AppActivate(Sender: TObject);
    procedure AppDeactivate(Sender: TObject);

    procedure AddBmpFrame;

    procedure mnPopupMenu_UtilsSelectClick(Sender: TObject);
    procedure AMyProcedure_OnShow(Sender: TObject);
    procedure AMyProcedure_OnChange(Sender: TObject);



  public
    { Dclarations publiques }

    Window_Perspective,
    Window_VueDessus,
    Window_VueDroite,
    Window_VueFace,
    Window_VueGauche,
    Window_Anim: TWindowPosition;

    CouleurFond: TColor;

    PetitsBoutons: boolean;
    FichierLangue: string;
    AssociationFichiers: boolean;

    NomFichier: string;
    AviEnCours, BmpsEnCours: boolean;
    NomFichierBaseBmp: string;
    IndexBmp: integer;

    procedure RemplirPopupDidacticiel;
    function ArrangeCaption(CaptionAArranger: string): string;

    //pour empcher 2 lancements :
    procedure DefaultHandler(var Message); override;
    //pour rpondre aux questions :
    procedure OnWmCopyData(var msg:TMessage); message WM_COPYDATA;


    procedure TailleBoutons;
    procedure VerifBDR;
    procedure SupprimeBDR;
    procedure ChoisirLangue;

    // voir si besoin :
    procedure Change2Couleurs;
  end;


var
  FObjet: TFObjet;

implementation

uses
    U_Perspective,
    U_VueFace,
    U_VueDroite,
    U_VueGauche,
    U_VueDessus,
    U_Anim;

{$R *.DFM}


////////////////////////////////////////////////
//                  Cration
////////////////////////////////////////////////

procedure TFObjet.FormCreate(Sender: TObject);
begin
  //Debug:= True;
  AppVersion:= '0.9 - ' + DateToStr(FileDateToDateTime(FileAge(Application.ExeName)));
  SaveSeparator:= DecimalSeparator;
  DecimalSeparator:= '.';

  Attendre:= True;
  Lancement:= True;
  Screen.Cursor:= crHourGlass;

  Application.OnActivate:= AppActivate;
  Application.OnDeactivate:= AppDeactivate;

  NumMessageEdob3D:= RegisterWindowMessage('Message perso Edob3D');
  NumMessageSimul:= RegisterWindowMessage('Message perso Simulations');

  with FObjet do begin
    Top:= 0;
    Left:= 0;
    Width:= Screen.Width;
    end;

  //On rcupre le fichier pass en paramtre :
  if ParamCount > 0 then FichierAOuvrir:= ParamStr(1);

  GLCamera_Perspective.Position.AsVector:= PointMake(1, 2, 15);
  GLCamera_VueFace.Position.AsVector:= PointMake(0, 0, 100);
  GLCamera_VueGauche.Position.AsVector:= PointMake(100, 0, 0);
  GLCamera_VueDroite.Position.AsVector:= PointMake(-100, 0, 0);
  GLCamera_VueDessus.Position.AsVector:= PointMake(0, 100, 0);
  GLCamera_Perspective.SceneScale:= 1;
  GLCamera_VueFace.SceneScale:= 0.3;
  GLCamera_VueGauche.SceneScale:= 0.3;
  GLCamera_VueDroite.SceneScale:= 0.3;
  GLCamera_VueDessus.SceneScale:= 0.3;

  Chemin:= ExtractFilePath(Application.ExeName);
  CheminFichiers:= Chemin + 'Fichiers\';
  CheminDidacticiel:= Chemin + 'Didacticiel\';
  StringListDidacticiels:= TStringList.Create;

  GmXMLLangue:= TGmXml.create(self);
  RecupereConfig;
  GmXMLLangue.LoadFromFile(Chemin + 'Langues\' + FichierLangue);
  MiseEnPlaceDesTextes;

  DossierDansTemp:= GetTempDossier + Application.Title + '\';
  CreateDir(DossierDansTemp);

  if Screen.Width < 800 then PetitsBoutons:= True;

  NbTrucs:= strtoint(GmXMLLangue.GetStringByPath('Tips\Count'));

  MyMaterialLibrary:= GLMaterialLibrary1;

  PopupMenu_UtilsSelect:= PopupMenu_Scene;
  ComboBox_UtilsSelect:= ComboBox1;
  TheWorld:= World;

  ExTime:= 0;
  MemoryStreamAColler:= TMemoryStream.create;
  ListObjetsCourants:= TList.create;
  ListNoPick:= TList.Create;
  ListNoPick.Add(XYZGrid1);
  ListNoPick.Add(Target);

  GroupeCourant:= World;
end;

procedure TFObjet.RecupereConfig;
begin
  Options:= TOptions.Create(nil);
  try
    Attendre:= True;

    if fileexists(DossierAppData + '\ConfigEdob3D.xml')
      then Options.FichierXml:= DossierAppData + '\ConfigEdob3D.xml'
      else if fileexists(Chemin + '\ConfigEdob3D.xml')
        then Options.FichierXml:= Chemin + '\ConfigEdob3D.xml'
        else PremierLancement:= True;


    with Options do begin
      ReadConfigXml;
      if DirectoryExists(optCheminFichiers) then
        CheminFichiers:= optCheminFichiers;
      FichierLangue:= optLangage;
      CouleurFond:= optCouleurFond;
      PetitsBoutons:= optPetitsBoutons;
      AssociationFichiers:= optAssociationFichiers;
      if AssociationFichiers then VerifBDR;
      StrToWindowPosition(optWindow_Perspective, Window_Perspective);
      StrToWindowPosition(optWindow_VueDessus, Window_VueDessus);
      StrToWindowPosition(optWindow_VueDroite, Window_VueDroite);
      StrToWindowPosition(optWindow_VueFace, Window_VueFace);
      StrToWindowPosition(optWindow_VueGauche, Window_VueGauche);
      StrToWindowPosition(optWindow_Anim, Window_Anim);
      Window_Anim.WindowOuvert:= False;
      end;
  finally
    Options.free;
    end;
end;

procedure TFObjet.MiseEnPlaceDesTextes;
begin

  //la base :
  Application.Title:=             GmXMLLangue.GetStringByPath('Title');

  FObjet.Caption:=                Application.Title;
  //les hint :
  ToolButton_Aide.Hint:=          GmXMLLangue.GetStringByPath('Hints\Help');
  ToolButton_APropos.Hint:=       GmXMLLangue.GetStringByPath('Hints\About');
  ToolButton_Didacticiel.Hint:=   GmXMLLangue.GetStringByPath('Hints\Tutorials');

  ToolButton_Quitter.Hint:=       GmXMLLangue.GetStringByPath('Hints\Exit');
  ToolButton_Nouveau.Hint:=       GmXMLLangue.GetStringByPath('Hints\New');
  ToolButton_Ouvrir.Hint:=        GmXMLLangue.GetStringByPath('Hints\Open');
  ToolButton_Enregistrer.Hint:=   GmXMLLangue.GetStringByPath('Hints\Save');
  ToolButton_Objet.Hint:=         GmXMLLangue.GetStringByPath('Hints\AddObject');

  ToolButton_Perspective.Hint:=   GmXMLLangue.GetStringByPath('Hints\PerspectiveView');
  ToolButton_VueFace.Hint:=       GmXMLLangue.GetStringByPath('Hints\FrontView');
  ToolButton_VueDroite.Hint:=     GmXMLLangue.GetStringByPath('Hints\RightView');
  ToolButton_VueGauche.Hint:=     GmXMLLangue.GetStringByPath('Hints\LeftView');
  ToolButton_VueDessus.Hint:=     GmXMLLangue.GetStringByPath('Hints\TopView');
  ToolButton_Anim.Hint:=          GmXMLLangue.GetStringByPath('Hints\Animations');
  ToolButton_Config.Hint:=        GmXMLLangue.GetStringByPath('Hints\Setting');



  //les menus :

  mnouvrirobjet1.caption:=        GmXMLLangue.GetStringByPath('Hints\OpenObject');
  mnouvriranim1.caption:=         GmXMLLangue.GetStringByPath('Hints\OpenAnimation');
  mnouvrirtout1.caption:=         GmXMLLangue.GetStringByPath('Hints\OpenEither');

  mnEnregistrer.caption:=         GmXMLLangue.GetStringByPath('Hints\Save');
  mnEnregistrerSous.caption:=     GmXMLLangue.GetStringByPath('Hints\SaveAs');
  mnEnregistrerMesh.caption:=     GmXMLLangue.GetStringByPath('Hints\ExportAsMesh');
  mnEnregistrerVRML.caption:=     GmXMLLangue.GetStringByPath('Hints\ExportAsVRML');
  mnEnregistrerPOV.caption:=      GmXMLLangue.GetStringByPath('Hints\ExportAsPOV');
  mnEnregistrerAvi.caption:=      GmXMLLangue.GetStringByPath('Hints\ExportAsAVI');
  mnEnregistrerBmps.caption:=     GmXMLLangue.GetStringByPath('Hints\ExportAsBMP');

  //le popup :
  mnCouleurFond.caption:=           GmXMLLangue.GetStringByPath('Hints\ChooseBackColor');
  mnGrille.caption:=                GmXMLLangue.GetStringByPath('Hints\ShowHideGrid');

  //le bouton objets :
  mo_Cube.caption:=                  GmXMLLangue.GetStringByPath('MenuObjet\Cube');
  mo_Sphere.caption:=                GmXMLLangue.GetStringByPath('MenuObjet\Sphere');
  mo_Cylindre.caption:=              GmXMLLangue.GetStringByPath('MenuObjet\Cylindre');
  mo_Cone.caption:=                  GmXMLLangue.GetStringByPath('MenuObjet\Cone');
  mo_Tore.caption:=                  GmXMLLangue.GetStringByPath('MenuObjet\Tore');
  mo_Dodecahedre.caption:=           GmXMLLangue.GetStringByPath('MenuObjet\Dodecahedre');
  mo_Octahedron.caption:=            GmXMLLangue.GetStringByPath('MenuObjet\Octahedron');
  mo_Teapot.caption:=                GmXMLLangue.GetStringByPath('MenuObjet\Teapot');
  mo_ImporterObjet.caption:=         GmXMLLangue.GetStringByPath('MenuObjet\ImportObject');
  mo_ImporterFichier.caption:=       GmXMLLangue.GetStringByPath('MenuObjet\ImportFile');

  Texte_PbFichier:=                  GmXMLLangue.GetStringByPath('Divers\IDontFindTheFile');
  glMyFreeForm.IDontFindTheFile:=    GmXMLLangue.GetStringByPath('Divers\IDontFindTheFile');
  glMyFreeForm.MustBeInSameDir:=    GmXMLLangue.GetStringByPath('Divers\MustBeInSameDir');


  //Aide et didacticiels :
  NomFichierAide:=                  GmXMLLangue.GetStringByPath('Help\HelpFile');
  CheminDidacticiel:=               Chemin + GmXMLLangue.GetStringByPath('Help\DidacticielDir');

end;

procedure TFObjet.FormShow(Sender: TObject);
begin
  if PremierLancement then ChoisirLangue;
  if Window_Perspective.WindowOuvert = True then
    Application.CreateForm(TForm_Perspective, Form_Perspective);
  if Window_VueFace.WindowOuvert = True then
    Application.CreateForm(TForm_VueFace, Form_VueFace);
  if Window_VueDroite.WindowOuvert = True then
    Application.CreateForm(TForm_VueDroite, Form_VueDroite);
  if Window_VueGauche.WindowOuvert = True then
    Application.CreateForm(TForm_VueGauche, Form_VueGauche);
  if Window_VueDessus.WindowOuvert = True then
    Application.CreateForm(TForm_VueDessus, Form_VueDessus);

  ObjetCourant:= nil;
  ChangeTexteTrucs;
  Screen.Cursor:= crDefault;
  Attendre:= True;
  TailleBoutons;
  Lancement:= False;
  CreerPopupMenu_UtilsSelect(mnPopupMenu_UtilsSelectClick,
                             AMyProcedure_OnShow,
                             AMyProcedure_OnChange);
  MetAJourInterface;
end;

procedure TFObjet.DefaultHandler(var Message);
var
  numatom: atom;
  texte: Pchar;
  a: string;
begin
  inherited DefaultHandler(Message);
  if TMessage(Message).Msg = NumMessageEdob3D then begin
    numatom:= TMessage(Message).LParam;
    GetMem(texte, 256);
    GlobalGetAtomName(numatom, texte, 256);
    GlobalDeleteAtom(numatom);
    Application.Restore;
    Application.BringToFront;
    a:= texte;
    if FileExists(a) then Ouvrir(a);
    FreeMem(texte);
    end;
end;





procedure TFObjet.ToolButton_QuitterClick(Sender: TObject);
begin
  close;
end;

procedure TFObjet.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  i: integer;
begin
  Prog_StopperSimul;
  if AviEnCours then begin
    AviEnCours:= False;
    AVIRecorder1.CloseAVIFile(False);
    end;
  BmpsEnCours:= False;
  Lancement:= True;
  Attendre:= True;
  GLCadencer1.Enabled:= False;
  Screen.Cursor:= crHourGlass;
  for i:= 1 to 10 do Application.ProcessMessages;

  if Window_Perspective.WindowOuvert then Form_Perspective.SauvePosition;
  if Window_VueFace.WindowOuvert then Form_VueFace.SauvePosition;
  if Window_VueDroite.WindowOuvert then Form_VueDroite.SauvePosition;
  if Window_VueGauche.WindowOuvert then Form_VueGauche.SauvePosition;
  if Window_VueDessus.WindowOuvert then Form_VueDessus.SauvePosition;
  if Window_Anim.WindowOuvert then Form_Anim.SauvePosition;
  SauveConfig;
  if Window_Perspective.WindowOuvert then Form_Perspective.close;
  if Window_VueFace.WindowOuvert then Form_VueFace.close;
  if Window_VueDroite.WindowOuvert then Form_VueDroite.close;
  if Window_VueGauche.WindowOuvert then Form_VueGauche.close;
  if Window_VueDessus.WindowOuvert then Form_VueDessus.close;

  //if Window_Anim.WindowOuvert then begin
    Form_Anim.Initialiser;
    Form_Anim.ObjAnimations.Free;
    //Form_Anim.close;
    //end;

  //On vide le Monde :
  DeSelectionne;
  ObjetCourant:= nil;
  GroupeCourant:= nil;
  World.DeleteChildren;
  //et a :
  MemoryStreamAColler.free;
  ListObjetsCourants.Free;
  ListNoPick.Free;

  GmXMLLangue.Nodes.Clear;
  GmXMLLangue.free;
  StringListDidacticiels.Free;
  PopupMenu_Didacticiel.Items.Clear;
  RemoveDir(DossierDansTemp);
  DecimalSeparator:= SaveSeparator;
  for i:= 1 to 10 do Application.ProcessMessages;
end;

procedure TFObjet.SauveConfig;
begin
  Options:= TOptions.Create(nil);
  try
    Options.FichierXml:= DossierAppData + '\ConfigEdob3D.xml';
    with Options do begin
      optCheminFichiers:= CheminFichiers;
      optLangage:= FichierLangue;
      optCouleurFond:= CouleurFond;
      optPetitsBoutons:= PetitsBoutons;
      optAssociationFichiers:= AssociationFichiers;
      optWindow_Perspective:= WindowPositionToStr(Window_Perspective);
      optWindow_VueDessus:= WindowPositionToStr(Window_VueDessus);
      optWindow_VueDroite:= WindowPositionToStr(Window_VueDroite);
      optWindow_VueFace:= WindowPositionToStr(Window_VueFace);
      optWindow_VueGauche:= WindowPositionToStr(Window_VueGauche);
      optWindow_Anim:= WindowPositionToStr(Window_Anim);

      SaveConfigXml;
      end;
  finally
    Options.free;
    end;
end;


////////////////////////////////////////////////
//                Dplacements
////////////////////////////////////////////////

procedure TFObjet.GLCadencer1Progress(Sender: TObject; const deltaTime,
  newTime: Double);
var
  ExIndexAnimation: integer;
begin
  if Attendre then exit;
  if Lancement then exit;
  if PopupMenu_Didacticiel.Items.Count < 1 then RemplirPopupDidacticiel;
  //On rcupre le fichier pass en paramtre :
  if FichierAOuvrir <> '' then begin
    if FileExists(FichierAOuvrir) then Ouvrir(FichierAOuvrir);
    FichierAOuvrir:= '';
    end;


  HandleKeys;
  Application.ProcessMessages;

  if Window_Perspective.WindowOuvert then Form_Perspective.GLSceneViewer_Perspective.Invalidate;
  //if Window_VueDessus.WindowOuvert then Form_VueDessus.GLSceneViewer_VueDessus.Invalidate;
  //if Window_VueDroite.WindowOuvert then Form_VueDroite.GLSceneViewer_VueDroite.Invalidate;
  //if Window_VueFace.WindowOuvert then Form_VueFace.GLSceneViewer_VueFace.Invalidate;
  //if Window_VueGauche.WindowOuvert then Form_VueGauche.GLSceneViewer_VueGauche.Invalidate;

  if Window_Anim.WindowOuvert then
    with Form_Anim do
      if Lecture then begin
        ExIndexAnimation:= Actuel.IndexAnimation;
        ObjAnimations.Progress(deltaTime, newTime);
        Actuel:= ObjAnimations.RetourneActuel;
        if Actuel.IndexAnimation <> ExIndexAnimation then
          SelectionneNodeAnimation(Actuel.IndexAnimation);
        MetAJourStatusBar;
        end;

  fDelta:= newTime - ExTime;
  ExTime:= newTime;
  if ExTime - TimeTrucs > 10 then ChangeTexteTrucs;

  if ExTime - TimeDivers > 1 then begin
    if Window_Perspective.WindowOuvert then begin
      FObjet.Caption:= GmXMLLangue.GetStringByPath('Title') +
                       Format('          (%.0f FPS)', [Form_Perspective.GLSceneViewer_Perspective.FramesPerSecond]);
      Form_Perspective.GLSceneViewer_Perspective.ResetPerformanceMonitor;
      end;
    TimeDivers:= GLCadencer1.GetCurrentTime;
    end;

  if AviEnCours then begin
    AVIRecorder1.AddAVIFrame;
    Application.ProcessMessages;
    if IsKeyDown(VK_ESCAPE) then begin
      AviEnCours:= False;
      AVIRecorder1.CloseAVIFile(False);
      showmessage(GmXMLLangue.GetStringByPath('Hints\RecordFinish'));
      end;
    end;
  if BmpsEnCours then begin
    AddBmpFrame;
    Application.ProcessMessages;
    if IsKeyDown(VK_ESCAPE) then begin
      BmpsEnCours:= False;
      showmessage(GmXMLLangue.GetStringByPath('Hints\RecordFinish'));
      end;
    end;

  //ToolButton_Didacticiel.Enabled:= (Simul_Handle = 0);
end;

procedure TFObjet.ChangeTexteTrucs;
begin
  Indice_Trucs:= Indice_Trucs + 1;
  if Indice_Trucs > NbTrucs then Indice_Trucs:= 1;
  Label1.Font.Color:= clWindowText;
  Label1.Caption:= GmXMLLangue.GetStringByPath('Tips\' + inttostr(Indice_Trucs));
  TimeTrucs:= GLCadencer1.GetCurrentTime;
end;

procedure TFObjet.HandleKeys;
var
  Touche_Ctrl, Touche_Maj, Touche_Alt, Touche_C: boolean;
  a, b: string;
begin
  //Cas spciaux :
  if IsKeyDown(TouchePourContinuer) then Prog_Continuer;
  if IsKeyDown(VK_DELETE) then begin
    mnSupprimerClick(FObjet);
    exit;
    end;
  if IsKeyDown(VK_F1) then begin
    ToolButton_AideClick(FObjet);
    exit;
    end;
  Touche_Ctrl:= (IsKeyDown(VK_CONTROL));
  if Touche_Ctrl then begin
    if IsKeyDown('C') then mnCopierClick(self)
    else if IsKeyDown('V') then mnCollerClick(self)
    else if IsKeyDown('A') then mnToutSelectionnerClick(self);
    end;
  BougeCamera:= (IsKeyDown('C'));
  SelectionMultiple:= (IsKeyDown(VK_SHIFT));

  Touche_C:= BougeCamera;
  Touche_Maj:= SelectionMultiple;
  Touche_Alt:= IsKeyDown(VK_MENU);
  if Touche_C or Touche_Ctrl or Touche_Maj or Touche_Alt
    then begin
      a:= '';
      if Touche_C then begin
        b:= GmXMLLangue.GetStringByPath('Clavier\Key') + GmXMLLangue.GetStringByPath('Clavier\C') + GmXMLLangue.GetStringByPath('Clavier\KeyIsDown');
        if a = ''
          then a:= b
          else a:= a + #13 + b;
        end;
      if Touche_Ctrl then begin
        b:= GmXMLLangue.GetStringByPath('Clavier\Key') + GmXMLLangue.GetStringByPath('Clavier\Ctrl') + GmXMLLangue.GetStringByPath('Clavier\KeyIsDown');
        if a = ''
          then a:= b
          else a:= a + #13 + b;
        end;
      if Touche_Maj then begin
        b:= GmXMLLangue.GetStringByPath('Clavier\Key') + GmXMLLangue.GetStringByPath('Clavier\Shift') + GmXMLLangue.GetStringByPath('Clavier\KeyIsDown');
        if a = ''
          then a:= b
          else a:= a + #13 + b;
        end;
      if Touche_Alt then begin
        b:= GmXMLLangue.GetStringByPath('Clavier\Key') + GmXMLLangue.GetStringByPath('Clavier\Alt') + GmXMLLangue.GetStringByPath('Clavier\KeyIsDown');
        if a = ''
          then a:= b
          else a:= a + #13 + b;
        end;

      if a <> Label1.Caption then begin
        Label1.Font.Color:= clRed;
        Label1.Font.Style:= [fsBold];
        Label1.Caption:= a;
        end;
      end
    else if Label1.Font.Color = clRed then begin
      Label1.Font.Color:= clWindowText;
      Label1.Font.Style:= [];
      Label1.Caption:= '';
      ChangeTexteTrucs;
      end;


end;







////////////////////////////////////////////////
//                  Manipulations
////////////////////////////////////////////////


procedure TFObjet.mnPopupMenu_UtilsSelectClick(Sender: TObject);
begin
  PopupMenu_UtilsSelectClick(Sender);
end;

procedure TFObjet.AMyProcedure_OnShow(Sender: TObject);
begin
  MyProcedure_DoShow(Sender);
end;

procedure TFObjet.AMyProcedure_OnChange(Sender: TObject);
begin
  MyProcedure_DoChange(Sender);
end;


procedure TFObjet.GLSceneViewerMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MyGLSceneViewerMouseDown(Sender, Button, Shift, X, Y);
  PopupMenu_Scene.AutoPopUp:= True;
end;

procedure TFObjet.GLSceneViewerMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  dx, dy, s: single;
  newPos, v, w: TVector;
  GLSceneViewer: TGLSceneViewer;
  i: integer;
begin
  if Attendre then exit;
  if not(ssLeft in Shift) then
    if not(ssRight in Shift) then
      if not(ssMiddle in Shift) then
        exit;
  GLSceneViewer:= TGLSceneViewer(Sender);

  Clic:= False;
  PopupMenu_Scene.AutoPopUp:= False;
  dx:= (mx - x) / 5;   dy:= (my - y) / 5;
  mx:= x;              my:= y;

  //Zoom :
  if Shift = [ssRight] then begin
    s:= GLSceneViewer.Camera.FocalLength;  //SceneScale
    s:= s * (Power(1.1, (dy - dx) / 10));
    GLSceneViewer.Camera.FocalLength:= s;
    exit;
    end;
  //Dplacement de la camera :
  if BougeCamera then begin
    newPos:= MouseWorldPos(GLSceneViewer, x, y);
    if VectorNorm(lastMouseWorldPos) <> 0 then begin
      v:= VectorSubtract(lastMouseWorldPos, newPos);
      GLSceneViewer.Camera.Position.Translate(v);
      end;
    lastMouseWorldPos:= newPos;
    exit;
    end;

  if ObjetCourant = nil then exit;
  //Rotations :
  if ssCtrl in Shift then begin
    if ssLeft in Shift
      then begin
        if CheckBox_X.Checked then ObjetCourant.Pitch(dx);
        if CheckBox_Y.Checked then ObjetCourant.Turn(dy);
        end
      else if CheckBox_Z.Checked then ObjetCourant.Roll(dx + dy);
    exit;
    end;
  //Agrandissements :
  if ssShift in Shift then begin
    if ssAlt in Shift then with ObjetCourant.Scale do begin
      s:= Power(1.1, dy);
      X:= X * s;
      Y:= Y * s;
      Z:= Z * s;
      exit;
      end;
    if ssLeft in Shift
      then begin
        ObjetCourant.Scale.X:= ObjetCourant.Scale.X * Power(1.1, -dx);
        ObjetCourant.Scale.Y:= ObjetCourant.Scale.Y * Power(1.1, dy);
        end
      else ObjetCourant.Scale.Z:= ObjetCourant.Scale.Z * Power(1.1, dy);
    exit;
    end;
  //Translations :
  if ssLeft in Shift then begin
    newPos:= MouseWorldPos(GLSceneViewer, x, y);
    if VectorNorm(lastMouseWorldPos) <> 0 then begin
      v:= VectorSubtract(newPos, lastMouseWorldPos);
      if ListObjetsCourants.Count > 0 then
        for i:= 0 to ListObjetsCourants.count - 1 do begin
          w:= TGLBaseSceneObject(ListObjetsCourants[i]).AbsolutePosition;
          AddVector(w, v);
          TGLBaseSceneObject(ListObjetsCourants[i]).AbsolutePosition:= w;
          //TGLBaseSceneObject(ListObjetsCourants[i]).Position.Translate(v);
          end;
      end;
    lastMouseWorldPos:= newPos;
    exit;
    end;
end;

procedure TFObjet.GLSceneViewerMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  PopupMenu_Scene.AutoPopUp:= False;
  MyGLSceneViewerMouseUp(Sender, Button, Shift, X, Y);
end;

procedure TFObjet.ComboBox1Change(Sender: TObject);
var
  NewObjet: TGLBaseSceneObject;
  i: integer;
begin
  Attendre:= False;
  i:= ComboBox1.ItemIndex;
  NewObjet:= TGLBaseSceneObject(ComboBox1.Items.Objects[i]);
  if NewObjet <> ObjetCourant then begin
    if Assigned(ObjetCourant) then Deselectionne;
    ComboBox1.ItemIndex:= i;
    ObjetCourant:= NewObjet;
    if Assigned(ObjetCourant) then ObjetCourant.ShowAxes:= True;
    ListObjetsCourants.Add(ObjetCourant);
    MetAJourMenuPopUp;
    end;
end;

procedure TFObjet.ComboBox1Enter(Sender: TObject);
begin
  Attendre:= True;
end;

procedure TFObjet.ComboBox1Exit(Sender: TObject);
begin
  Attendre:= False;
end;



////////////////////////////////////////////////
//                  Configuration
////////////////////////////////////////////////

////////////////////////////////////////////////
//                  Objets
////////////////////////////////////////////////

procedure TFObjet.ToolButton_ObjetClick(Sender: TObject);
var
  P: TPoint;
begin
  getCursorPos(P);
  PopupMenu_Objet.Popup(P.X, P.Y);
end;

procedure TFObjet.NouvelObjet(Sender: TObject);
var
  a, b: string;
  i: integer;
begin
  Attendre:= True;
  Screen.Cursor:= crHourGlass;
  DeSelectionne;
  a:= TMenuItem(Sender).Name;
  if      a = 'mo_Cube' then ObjetCourant:= TGLBaseSceneObject(TGLBaseSceneObject(GroupeCourant).AddNewChild(TGLCube))
  else if a = 'mo_Sphere' then ObjetCourant:= TGLBaseSceneObject(TGLBaseSceneObject(GroupeCourant).AddNewChild(TGLSphere))
  else if a = 'mo_Cylindre' then ObjetCourant:= TGLBaseSceneObject(TGLBaseSceneObject(GroupeCourant).AddNewChild(TGLCylinder))
  else if a = 'mo_Cone' then ObjetCourant:= TGLBaseSceneObject(TGLBaseSceneObject(GroupeCourant).AddNewChild(TGLCone))
  else if a = 'mo_Tore' then ObjetCourant:= TGLBaseSceneObject(TGLBaseSceneObject(GroupeCourant).AddNewChild(TGLTorus))
  else if a = 'mo_Dodecahedre' then ObjetCourant:= TGLBaseSceneObject(TGLBaseSceneObject(GroupeCourant).AddNewChild(TGLDodecahedron))
  else if a = 'mo_Teapot' then ObjetCourant:= TGLBaseSceneObject(TGLBaseSceneObject(GroupeCourant).AddNewChild(TGLTeapot))
  else if a = 'mo_Octahedron' then begin
    ObjetCourant:= TGLBaseSceneObject(TGLBaseSceneObject(GroupeCourant).AddNewChild(TGLSphere));
    TGLSphere(ObjetCourant).Slices:= 4;
    TGLSphere(ObjetCourant).Stacks:= 2;
    end
  else begin
    a:= 'mo_Cube';
    ObjetCourant:= TGLBaseSceneObject(TGLBaseSceneObject(GroupeCourant).AddNewChild(TGLCube));
    end;

  for i:= 4 to length(a) do b:= b + a[i];
  with ObjetCourant do begin
    CreeNomUnique(World, ObjetCourant, b);
    ShowAxes:= True;
    Tag:= -1;
    end;
  ListObjetsCourants.Add(ObjetCourant);
  MetAJourInterface;
  Attendre:= False;
  Screen.Cursor:= crDefault;
end;

procedure TFObjet.mo_ImporterFichierClick(Sender: TObject);
begin
  Attendre:= True;
  DeSelectionne;
  OpenDialog1.Filter:= VectorFileFormatsFilter;
  //OpenDialog1.DefaultExt:= '.obj';
  OpenDialog1.InitialDir:= CheminFichiers;
  OpenDialog1.FileName:= '';
  OpenDialog1.Title:= ArrangeCaption(mo_ImporterFichier.caption);
  if OpenDialog1.Execute then begin
    Screen.Cursor:= crHourGlass;
    try
      ObjetCourant:= TGLBaseSceneObject(TGLBaseSceneObject(GroupeCourant).AddNewChild(TMyFreeForm));
      with TMyFreeForm(ObjetCourant) do begin
        CreeNomUnique(World, ObjetCourant, 'File');
        ShowAxes:= True;
        MaterialLibrary:= MyMaterialLibrary;
        LoadFromFile(OpenDialog1.FileName);
        end;
      ListObjetsCourants.Add(ObjetCourant);
      Application.ProcessMessages;
      VerifierNoms(World);
      Application.ProcessMessages;
      MetAJourInterface;
    finally
      Screen.Cursor:= crDefault;
      Attendre:= False;
      end;
    end;
  Attendre:= False;
end;

procedure TFObjet.mo_ImporterObjetClick(Sender: TObject);
var
  DummyCube: TGLDummyCube;
begin
  DeSelectionne;
  OpenDialog1.Filter:= GmXMLLangue.GetStringByPath('Boites\Objects') + ' (*.bjt)|*.bjt';
  OpenDialog1.DefaultExt:= '.bjt';
  if Prog_DossierCourant <> ''
    then OpenDialog1.InitialDir:= Prog_DossierCourant
    else OpenDialog1.InitialDir:= CheminFichiers;
  OpenDialog1.FileName:= '';
  OpenDialog1.Title:= ArrangeCaption(mo_ImporterObjet.caption);
  if OpenDialog1.Execute then begin
    Screen.Cursor:= crHourGlass;
    Attendre:= True;
    try
    DummyCube:= TGLDummyCube(World.AddNewChild(TGLDummyCube));
    CreeNomUnique(World, DummyCube, 'Objet');
    OuvreFichier(World, nil, nil, False, OpenDialog1.FileName, TGLBaseSceneObject(DummyCube), nil, True);
    VerifierNoms(World);
    MetAJourInterface;
    if Prog_DossierCourant = '' then CheminFichiers:= ExtractFilePath(OpenDialog1.FileName);
    finally
      Screen.Cursor:= crDefault;
      Attendre:= False;
      end;
    end;
end;



////////////////////////////////////////////////
//                  Boutons
////////////////////////////////////////////////

procedure TFObjet.ToolButton_NouveauClick(Sender: TObject);
begin
  Attendre:= True;
  Screen.Cursor:= crHourGlass;
  DeSelectionne;
  ObjetCourant:= nil;
  GroupeCourant:= World;
  World.DeleteChildren;

  GLCamera_Perspective.Position.AsVector:= PointMake(1, 2, 15);
  GLCamera_VueFace.Position.AsVector:= PointMake(0, 0, 100);
  GLCamera_VueGauche.Position.AsVector:= PointMake(100, 0, 0);
  GLCamera_VueDroite.Position.AsVector:= PointMake(-100, 0, 0);
  GLCamera_VueDessus.Position.AsVector:= PointMake(0, 100, 0);
  GLCamera_Perspective.SceneScale:= 1;
  GLCamera_VueFace.SceneScale:= 0.3;
  GLCamera_VueGauche.SceneScale:= 0.3;
  GLCamera_VueDroite.SceneScale:= 0.3;
  GLCamera_VueDessus.SceneScale:= 0.3;

  Form_Anim.ObjAnimations.Initialiser;
  Form_Anim.Initialiser;
  if Window_Anim.WindowOuvert then
    ToolButton_AnimClick(Sender);

  MetAJourInterface;
  GLScene1.NotifyChange(nil);
  Attendre:= False;
  Screen.Cursor:= crDefault;
end;

procedure TFObjet.ToolButton_OuvrirClick(Sender: TObject);
begin
  mnouvrirtout1Click(Sender);
end;

procedure TFObjet.mnouvrirobjet1Click(Sender: TObject);
begin
  OpenDialog1.Filter:= GmXMLLangue.GetStringByPath('Boites\Objects') + ' (*.bjt)|*.bjt';
  if Prog_DossierCourant <> ''
    then OpenDialog1.InitialDir:= Prog_DossierCourant
    else OpenDialog1.InitialDir:= CheminFichiers;
  OpenDialog1.FileName:= '';
  OpenDialog1.Title:= ArrangeCaption(mnouvrirobjet1.caption);
  if OpenDialog1.Execute then Ouvrir(OpenDialog1.FileName);
end;

procedure TFObjet.mnouvriranim1Click(Sender: TObject);
begin
  OpenDialog1.Filter:= GmXMLLangue.GetStringByPath('Boites\Animations') + ' (*.anm)|*.anm';
  if Prog_DossierCourant <> ''
    then OpenDialog1.InitialDir:= Prog_DossierCourant
    else OpenDialog1.InitialDir:= CheminFichiers;
  OpenDialog1.FileName:= '';
  OpenDialog1.Title:= ArrangeCaption(mnouvriranim1.caption);
  if OpenDialog1.Execute then Ouvrir(OpenDialog1.FileName);
end;

procedure TFObjet.mnouvrirtout1Click(Sender: TObject);
begin
  OpenDialog1.Filter:= GmXMLLangue.GetStringByPath('Boites\All') + ' (*.bjt;*.anm)|*.bjt;*.anm|'
                     + GmXMLLangue.GetStringByPath('Boites\Objects') + ' (*.bjt)|*.bjt|'
                     + GmXMLLangue.GetStringByPath('Boites\Animations') + ' (*.anm)|*.anm';
  if Prog_DossierCourant <> ''
    then OpenDialog1.InitialDir:= Prog_DossierCourant
    else OpenDialog1.InitialDir:= CheminFichiers;
  OpenDialog1.FileName:= '';
  OpenDialog1.Title:= ArrangeCaption(mnouvrirtout1.caption);
  if OpenDialog1.Execute then Ouvrir(OpenDialog1.FileName);
end;

procedure TFObjet.Ouvrir(NomDuFichier: string);
begin
  DeSelectionne;
  Attendre:= True;
  Screen.Cursor:= crHourGlass;
  GroupeCourant:= World;
  World.DeleteChildren;
  Form_Anim.ObjAnimations.Initialiser;
  if ExtractFileExt(NomDuFichier) = '.anm'
    then OuvreFichier(World, nil, nil, False, NomDuFichier, World, Form_Anim.ObjAnimations, True)
    else OuvreFichier(World, nil, nil, False, NomDuFichier, World, nil, True);
  VerifierNoms(World);
  Form_Anim.Initialiser;

  if ExtractFileExt(NomDuFichier) = '.anm' then
    if Window_Anim.WindowOuvert = False then
      ToolButton_AnimClick(self);
  if ExtractFileExt(NomDuFichier) = '.bjt' then
    if Window_Anim.WindowOuvert = True then
      ToolButton_AnimClick(self);

  MetAJourInterface;
  if Prog_DossierCourant = '' then CheminFichiers:= ExtractFilePath(NomDuFichier);
  Attendre:= False;
  Screen.Cursor:= crDefault;
end;

procedure TFObjet.ToolButton_EnregistrerClick(Sender: TObject);
begin
  mnEnregistrerSousClick(Sender);
end;

procedure TFObjet.mnEnregistrerClick(Sender: TObject);
var
  a: string;
begin
  if NomFichier = '' then begin
    mnEnregistrerSousClick(Sender);
    exit;
    end;
  a:= ExtractFileExt(NomFichier);
  if Form_Anim.ObjAnimations.Animations.count > 0
    then begin
      if a <> '.anm' then begin
        mnEnregistrerSousClick(Sender);
        exit;
        end;
      end
    else begin
      if a <> '.bjt' then begin
        mnEnregistrerSousClick(Sender);
        exit;
        end;
      end;


  DeSelectionne;
  Screen.Cursor:= crHourGlass;
  Attendre:= True;
  SauveFichier(World, nil, nil, False, NomFichier, Form_Anim.ObjAnimations);
  Attendre:= False;
  Screen.Cursor:= crDefault;
end;

procedure TFObjet.mnEnregistrerSousClick(Sender: TObject);
begin
  DeSelectionne;

  if Form_Anim.ObjAnimations.Animations.count > 0
    then begin
      SaveDialog1.Filter:= GmXMLLangue.GetStringByPath('Boites\Animations') + ' (*.anm)|*.anm|'
                         + GmXMLLangue.GetStringByPath('Boites\Objects') + ' (*.bjt)|*.bjt|'
                         + GmXMLLangue.GetStringByPath('Boites\All') + ' (*.bjt;*.anm)|*.bjt;*.anm';
      SaveDialog1.DefaultExt:= '.anm';
      end
    else begin
      SaveDialog1.Filter:= GmXMLLangue.GetStringByPath('Boites\Objects') + ' (*.bjt)|*.bjt|'
                         + GmXMLLangue.GetStringByPath('Boites\Animations') + ' (*.anm)|*.anm|'
                         + GmXMLLangue.GetStringByPath('Boites\All') + ' (*.bjt;*.anm)|*.bjt;*.anm';
      SaveDialog1.DefaultExt:= '.bjt';
      end;

  SaveDialog1.InitialDir:= CheminFichiers;
  SaveDialog1.FileName:= '';
  if SaveDialog1.Execute then begin
    Screen.Cursor:= crHourGlass;
    Attendre:= True;
    SauveFichier(World, nil, nil, False, SaveDialog1.FileName, Form_Anim.ObjAnimations);
    CheminFichiers:= ExtractFilePath(SaveDialog1.FileName);
    end;
  Attendre:= False;
  Screen.Cursor:= crDefault;
end;

procedure TFObjet.mnEnregistrerMeshClick(Sender: TObject);
var
  FreeForm: TGLFreeForm;
begin
  DeSelectionne;
  SaveDialog1.Filter:= VectorFileFormatsFilter;
  SaveDialog1.DefaultExt:= '.glsm';

  SaveDialog1.InitialDir:= CheminFichiers;
  SaveDialog1.FileName:= '';
  if SaveDialog1.Execute then begin
    Screen.Cursor:= crHourGlass;
    Attendre:= True;
    FreeForm:= TGLFreeForm(GLScene1.Objects.AddNewChild(TGLFreeForm));
    try
      ExportMesh(World, FreeForm, SaveDialog1.FileName);
      CheminFichiers:= ExtractFilePath(SaveDialog1.FileName);
    finally
      FreeForm.free;
      end;
    end;
  Attendre:= False;
  Screen.Cursor:= crDefault;
end;

procedure TFObjet.mnEnregistrerPOVClick(Sender: TObject);
begin
  DeSelectionne;

  SaveDialog1.Filter:= 'aaaaa' + ' (*.pov)|*.pov|';
  SaveDialog1.DefaultExt:= '.pov';

  SaveDialog1.InitialDir:= CheminFichiers;
  SaveDialog1.FileName:= '';
  if SaveDialog1.Execute then begin
    Screen.Cursor:= crHourGlass;
    Attendre:= True;
    ExportPOV(World,
              GLCamera_Perspective, GLLightSource1, CouleurFond,
              False, SaveDialog1.FileName);
    CheminFichiers:= ExtractFilePath(SaveDialog1.FileName);
    end;
  Attendre:= False;
  Screen.Cursor:= crDefault;
end;

procedure TFObjet.mnEnregistrerVRMLClick(Sender: TObject);
begin
showmessage('pas fait'); exit;

  DeSelectionne;
  {
  if Form_Anim.ObjAnimations.Animations.count > 0
    then begin
      SaveDialog1.Filter:= GmXMLLangue.GetStringByPath('Boites\Animations') + ' (*.anm)|*.anm|'
                         + GmXMLLangue.GetStringByPath('Boites\Objects') + ' (*.bjt)|*.bjt|'
                         + GmXMLLangue.GetStringByPath('Boites\All') + ' (*.bjt;*.anm)|*.bjt;*.anm';
      SaveDialog1.DefaultExt:= '.anm';
      end
    else begin
      SaveDialog1.Filter:= GmXMLLangue.GetStringByPath('Boites\Objects') + ' (*.bjt)|*.bjt|'
                         + GmXMLLangue.GetStringByPath('Boites\Animations') + ' (*.anm)|*.anm|'
                         + GmXMLLangue.GetStringByPath('Boites\All') + ' (*.bjt;*.anm)|*.bjt;*.anm';
      SaveDialog1.DefaultExt:= '.bjt';
      end;
      }
  SaveDialog1.Filter:= 'aaaaa' + ' (*.wrl)|*.wrl|';
  SaveDialog1.DefaultExt:= '.wrl';

  SaveDialog1.InitialDir:= CheminFichiers;
  SaveDialog1.FileName:= '';
  if SaveDialog1.Execute then begin
    Screen.Cursor:= crHourGlass;
    Attendre:= True;
    ExportVRML(World, nil, nil, False, SaveDialog1.FileName, Form_Anim.ObjAnimations);
    CheminFichiers:= ExtractFilePath(SaveDialog1.FileName);
    end;
  Attendre:= False;
  Screen.Cursor:= crDefault;
end;

procedure TFObjet.mnEnregistrerAviClick(Sender: TObject);
var
  SavedCap: string;
begin
  if AviEnCours = False then begin
    if not AVIRecorder1.CreateAVIFile then Exit;
    showmessage(GmXMLLangue.GetStringByPath('Hints\PressEscapeToStopRecord'));
    //AVIRecorder1.Width:= Form_Perspective.GLSceneViewer_Perspective.Width;
    //AVIRecorder1.Height:= Form_Perspective.GLSceneViewer_Perspective.Height;
    AviEnCours:= True;
    end;
end;

procedure TFObjet.mnEnregistrerBmpsClick(Sender: TObject);
var
a:string;
begin
  if BmpsEnCours = False then begin
    SaveDialog1.Filter:= 'aaaaa' + ' (*.bmp)|*.bmp|';
    SaveDialog1.DefaultExt:= '.bmp';
    SaveDialog1.InitialDir:= CheminFichiers;
    SaveDialog1.FileName:= '';
    if SaveDialog1.Execute then begin
      NomFichierBaseBmp:= SaveDialog1.FileName;
      NomFichierBaseBmp:= ChangeFileExt(NomFichierBaseBmp, '');
      IndexBmp:= 0;
      showmessage(GmXMLLangue.GetStringByPath('Hints\PressEscapeToStopRecord'));
      BmpsEnCours:= True;
      end;
    Attendre:= False;
    Screen.Cursor:= crDefault;
    end;
end;

procedure TFObjet.AddBmpFrame;
var
   bmp32 : TGLBitmap32;
   bmp : TBitmap;
   a: string;
begin
  IndexBmp:= IndexBmp + 1;
  a:= NomFichierBaseBmp + Format('%.5d', [IndexBmp]) + '.bmp';
  bmp32:= Form_Perspective.GLSceneViewer_Perspective.Buffer.CreateSnapShot;
  bmp:= bmp32.Create32BitsBitmap;
  bmp.SaveToFile(a);
  bmp.Free;
  bmp32.Free;
end;


procedure TFObjet.mnCouleurFondClick(Sender: TObject);
begin
  ColorDialog1.Color:= CouleurFond;
  if ColorDialog1.Execute then CouleurFond:= ColorDialog1.Color;

  if Window_Perspective.WindowOuvert then
    Form_Perspective.GLSceneViewer_Perspective.Buffer.BackGroundColor:= CouleurFond;
  if Window_VueFace.WindowOuvert then
    Form_VueFace.GLSceneViewer_VueFace.Buffer.BackGroundColor:= CouleurFond;
  if Window_VueDroite.WindowOuvert then
    Form_VueDroite.GLSceneViewer_VueDroite.Buffer.BackGroundColor:= CouleurFond;
  if Window_VueGauche.WindowOuvert then
    Form_VueGauche.GLSceneViewer_VueGauche.Buffer.BackGroundColor:= CouleurFond;
  if Window_VueDessus.WindowOuvert then
    Form_VueDessus.GLSceneViewer_VueDessus.Buffer.BackGroundColor:= CouleurFond;
end;

procedure TFObjet.mnGrilleClick(Sender: TObject);
begin
  mnGrille.Checked:= not(mnGrille.Checked);
  XYZGrid1.Visible:= mnGrille.Checked;
end;

procedure TFObjet.ToolButton_PerspectiveClick(Sender: TObject);
begin
  Window_Perspective.WindowOuvert:= not(Window_Perspective.WindowOuvert);
  if Window_Perspective.WindowOuvert
    then Application.CreateForm(TForm_Perspective, Form_Perspective)
    else Form_Perspective.close;
end;

procedure TFObjet.ToolButton_VueFaceClick(Sender: TObject);
begin
  Window_VueFace.WindowOuvert:= not(Window_VueFace.WindowOuvert);
  if Window_VueFace.WindowOuvert
    then Application.CreateForm(TForm_VueFace, Form_VueFace)
    else Form_VueFace.close;
end;

procedure TFObjet.ToolButton_VueDroiteClick(Sender: TObject);
begin
  Window_VueDroite.WindowOuvert:= not(Window_VueDroite.WindowOuvert);
  if Window_VueDroite.WindowOuvert
    then Application.CreateForm(TForm_VueDroite, Form_VueDroite)
    else Form_VueDroite.close;
end;

procedure TFObjet.ToolButton_VueGaucheClick(Sender: TObject);
begin
  Window_VueGauche.WindowOuvert:= not(Window_VueGauche.WindowOuvert);
  if Window_VueGauche.WindowOuvert
    then Application.CreateForm(TForm_VueGauche, Form_VueGauche)
    else Form_VueGauche.close;
end;

procedure TFObjet.ToolButton_VueDessusClick(Sender: TObject);
begin
  Window_VueDessus.WindowOuvert:= not(Window_VueDessus.WindowOuvert);
  if Window_VueDessus.WindowOuvert
    then Application.CreateForm(TForm_VueDessus, Form_VueDessus)
    else Form_VueDessus.close;
end;

procedure TFObjet.ToolButton_AnimClick(Sender: TObject);
begin
  Window_Anim.WindowOuvert:= not(Window_Anim.WindowOuvert);
  if Window_Anim.WindowOuvert = False then begin
    Form_Anim.ToolButton_Stop.Down:= True;
    Form_Anim.ToolButton_LectureClick(Sender);
    Form_Anim.close;
    end;
  Form_Anim.Visible:= Window_Anim.WindowOuvert;
end;

procedure TFObjet.TailleBoutons;
var
  h, d: integer;
  FichierBoutons: string;
  WindowAnimOuvert: boolean;
begin
  Attendre:= True;

  FObjet.ClientHeight:= 200;
  Panel1.align:= alNone;
  Panel1.Top:= 70;
  ToolButton_Ouvrir.Style:= tbsButton;
  ToolButton_Enregistrer.Style:= tbsButton;
  ToolButton_Objet.Style:= tbsButton;
  //ToolButton_Config.Style:= tbsButton;
  ToolButton_Didacticiel.Style:= tbsButton;

  if PetitsBoutons
    then begin
      FichierBoutons:= Chemin + 'ToolBar_Small.bmp';
      d:= 32;
      end
    else begin
      FichierBoutons:= Chemin + 'ToolBar_Big.bmp';
      d:= 46;
      end;

  PanelBarreDOutils.Height:= d + 2;
  h:= d + 36 + 3;
  ChargerBoutons(FichierBoutons);

  WindowAnimOuvert:= Window_Anim.WindowOuvert;
  if WindowAnimOuvert = False then
    ToolButton_AnimClick(self);
  with Form_Anim do begin
    TreeView1.align:= alNone;
    TreeView1.Top:= 60;
    TreeView1.Visible:= False;
    PanelBarreDOutils.Visible:= False;
    ToolBar3.ButtonHeight:= d;
    ToolBar3.ButtonWidth := d;
    ToolBar3.Height:= d;
    PanelBarreDOutils.Height:= d + 2;
    PanelBarreDOutils.Visible:= True;
    TreeView1.align:= alClient;
    TreeView1.Visible:= True;
    end;
  if WindowAnimOuvert = False then
    ToolButton_AnimClick(self);


  ToolBar1.ButtonHeight:= d;
  ToolBar1.ButtonWidth := d;
  ToolBar1.Width:= 3 * d + 14;
  ToolBar3.ButtonHeight:= d;
  ToolBar3.ButtonWidth := d;

  Panel1.align:= alTop;
  Panel1.Visible:= True;
  FObjet.ClientHeight:= h;
  ToolButton_Ouvrir.Style:= tbsDropDown;
  ToolButton_Enregistrer.Style:= tbsDropDown;
  ToolButton_Objet.Style:= tbsDropDown;
  //ToolButton_Config.Style:= tbsDropDown;
  ToolButton_Didacticiel.Style:= tbsDropDown;
  Attendre:= False;
end;

procedure TFObjet.ChargerBoutons(NomFichier: string);
var
  Image: TImage;
  Bmp, BmpMask: TBitmap;
begin
  Screen.Cursor := crHourGlass;
  Bmp:= TBitmap.Create;
  BmpMask:= TBitmap.Create;
  Image:= TImage.Create(application);
  try
    ImageListBoutons.Clear;
    Image.picture.LoadFromFile(NomFichier);
    Image.AutoSize:= True;
    ImageListBoutons.Height:= Image.Height;
    ImageListBoutons.Width:= Image.Height;
    Bmp.Width:= Image.Width;
    Bmp.Height:= Image.Height;
    Bmp.Canvas.Draw(0, 0, Image.Picture.Graphic);
    BmpMask.width := Bmp.width;
    BmpMask.height:= Bmp.height;
    BmpMask.canvas.draw(0, 0, Bmp);
    BmpMask.Mask(BmpMask.Canvas.Pixels[1,1]);
  finally
    ImageListBoutons.Add(Bmp, BmpMask);
    Bmp.Free;
    BmpMask.Free;
    Image.Free;
    Screen.Cursor := crDefault;
    end;
end;

procedure TFObjet.ChoisirLangue;
begin
  OpenDialog1.Filter:= GmXMLLangue.GetStringByPath('Hints\Language') + ' (*.xml)|*.xml';
  OpenDialog1.InitialDir:= Chemin + 'Langues\';
  OpenDialog1.FileName:= '';
  OpenDialog1.Title:= ArrangeCaption(GmXMLLangue.GetStringByPath('Hints\Language'));
  if OpenDialog1.Execute then begin
    Screen.Cursor:= crHourGlass;
    Attendre:= True;
    FichierLangue:= ExtractFileName(OpenDialog1.FileName);
    GmXMLLangue.LoadFromFile(Chemin + 'Langues\' + FichierLangue);
    MiseEnPlaceDesTextes;
    Form_Anim.MiseEnPlaceDesTextes;
    Form_Perspective.Caption:= GmXMLLangue.GetStringByPath('Hints\PerspectiveView');
    Form_VueDessus.Caption:= GmXMLLangue.GetStringByPath('Hints\TopView');
    Form_VueDroite.Caption:= GmXMLLangue.GetStringByPath('Hints\RightView');
    Form_VueFace.Caption:= GmXMLLangue.GetStringByPath('Hints\FrontView');
    Form_VueGauche.Caption:= GmXMLLangue.GetStringByPath('Hints\LeftView');

    NbTrucs:= strtoint(GmXMLLangue.GetStringByPath('Tips\Count'));
    RemplirPopupDidacticiel;
    end;
  Attendre:= False;
  Screen.Cursor:= crDefault;
end;

procedure TFObjet.Change2Couleurs;
var
  ColorEx, ColorNew: TColor;
begin
  if ColorDialog1.Execute then
    ColorEx:= ColorDialog1.Color;
  if ColorDialog1.Execute then
    ColorNew:= ColorDialog1.Color;
  ChangeCouleur(GroupeCourant, ColorEx, ColorNew);
end;
































////////////////////////////////////////////////
//                  Aide
////////////////////////////////////////////////

procedure TFObjet.ToolButton_DidacticielClick(Sender: TObject);
var
  P: TPoint;
begin
  getCursorPos(P);
  PopupMenu_Didacticiel.Popup(P.X, P.Y);
end;

procedure TFObjet.RemplirPopupDidacticiel;
var
  i, j: integer;
  a, NomCourt, NomLong: string;
  MenuItem: TMenuItem;
begin
  StringListDidacticiels.Clear;
  PopupMenu_Didacticiel.Items.Clear;
  i:= strtoint(GmXMLLangue.GetStringByPath('Help\Count'));
  if i > 0 then for j:= 1 to i do begin
    a:= GmXMLLangue.GetStringByPath('Help\' + inttostr(j));
    NomCourt:= ChangeFileExt(ExtractFileName(a), '');
    NomLong:= CheminDidacticiel + a;
    StringListDidacticiels.Add(NomCourt);
    StringListDidacticiels.Add(NomLong);
    MenuItem:= TMenuItem.Create(self);
    with MenuItem do begin
      caption:= NomCourt;
      OnClick:= LanceDidacticiel;
      end;
    PopupMenu_Didacticiel.Items.Add(MenuItem);
    end;
  //ToolButton_Didacticiel.Enabled:= True;
end;

function ProgAssocie(NomFichier: string): string;
var
  Executable: array [0..255] of Char;
begin
  FindExecutable(PChar(ExtractFileName(NomFichier)),
                 PChar(ExtractFilePath(NomFichier)),
                 Executable);
  result:= string(Executable);
end;

procedure LanceEtAttendFin(NomFichier: string);
var
  Executable: string;
  StartInfo: TStartupInfo;
  ProcessInformation: TProcessInformation;
  PCharFichier: PChar;
begin
  Executable:= ProgAssocie(NomFichier);
  if Uppercase(ExtractFileName(Executable))
    <> Uppercase(ExtractFileName(NomFichier))
    then PCharFichier:= PChar( ' "' + NomFichier + '"')
    else PCharFichier:= nil;
  ZeroMemory(@StartInfo,
             sizeof(StartInfo));
  StartInfo.cb:= sizeof(StartInfo);
  if CreateProcess(PChar(Executable),
                   PCharFichier,
                   nil,
                   nil,
                   true,
                   0,
                   nil,
                   nil,
                   StartInfo,
                   ProcessInformation)
    then WaitForSingleObject(ProcessInformation.hProcess, INFINITE);
end;

procedure TFObjet.LanceDidacticiel(Sender: TObject);
var
  NomCourt, NomDidacticiel: string;
  i: integer;
begin
  NomCourt:= ArrangeCaption(TMenuItem(Sender).caption);
  i:= StringListDidacticiels.IndexOf(NomCourt);
  NomDidacticiel:= StringListDidacticiels[i + 1];
  if ExtractFileExt(NomDidacticiel) <> '.sim'
    then begin
      Application.Minimize;
      LanceEtAttendFin(NomDidacticiel);
      Application.Restore;
      end
    else begin
      Screen.Cursor:= crHourGlass;
      try
        Prog_DossierCourant:= '';
        Prog_LancerSimul(Handle, Chemin);
      finally
        Screen.Cursor:= crDefault;
        end;
      Prog_OuvrirSimulation(NomDidacticiel);
      end;
end;

function TFObjet.ArrangeCaption(CaptionAArranger: string): string;
var
  NewCaption: string;
begin
  NewCaption:= CaptionAArranger;
  while Pos('&', NewCaption) > 0 do delete(NewCaption, Pos('&', NewCaption), 1);
  Result:= NewCaption;
end;

//pour rpondre aux questions reues :
procedure TFObjet.OnWmCopyData(var msg: TMessage);
begin
  Prog_TraiteQuestion(msg);
end;

procedure TFObjet.ToolButton_AideClick(Sender: TObject);
begin
  Application.Minimize;
  LanceEtAttendFin(Chemin + NomFichierAide);
  Application.Restore;
end;

procedure TFObjet.ToolButton_AProposClick(Sender: TObject);
begin
if Debug then Form_Anim.ObjAnimations.gloups;
  Application.CreateForm(TAboutBox, AboutBox);
  try
    with AboutBox do begin
      ProductName.Caption:= GmXMLLangue.GetStringByPath('Title');
      LabelVersion.Caption:= AppVersion;
      LabelAnnee.caption:= '2004';
      ProgramIcon.Picture.assign(Application.Icon);
      end;
    AboutBox.showmodal;
  finally
    AboutBox.free;
    end;
end;


procedure TFObjet.ToolButton_ConfigClick(Sender: TObject);
begin
  Application.CreateForm(TFConfiguration, FConfiguration);
  try
    with FConfiguration do begin
      caption:= GmXMLLangue.GetStringByPath('Hints\Setting');
      LabelLangue.Caption:= GmXMLLangue.GetStringByPath('Hints\Language') + ' :   ' + ChangeFileExt(FichierLangue, '');
      CheckBoxAssociation.caption:= GmXMLLangue.GetStringByPath('Hints\FileAssociation');
      CheckBoxAssociation.Checked:= AssociationFichiers;
      RadioGroup1.Items[0]:= GmXMLLangue.GetStringByPath('Hints\BigButtons');
      RadioGroup1.Items[1]:= GmXMLLangue.GetStringByPath('Hints\SmallButtons');
      if PetitsBoutons
        then RadioGroup1.ItemIndex:= 1
        else RadioGroup1.ItemIndex:= 0;
      ButtonLangue.caption:= GmXMLLangue.GetStringByPath('Hints\Choose');
      ButtonOK.caption:= GmXMLLangue.GetStringByPath('Hints\OK');


      LabelCheminFichiers.Caption:= GmXMLLangue.GetStringByPath('Hints\FilesDir');
      ButtonCheminFichiers.caption:= GmXMLLangue.GetStringByPath('Hints\Modify');
      EditCheminFichiers.Text:= CheminFichiers;
      end;
    FConfiguration.showmodal;
    if DirectoryExists(FConfiguration.EditCheminFichiers.Text) then
      CheminFichiers:= FConfiguration.EditCheminFichiers.Text;
  finally
    FConfiguration.free;
    end;
end;


procedure TFObjet.AppActivate(Sender: TObject);
begin
  if Lancement then exit;
  Attendre:= False;
  //Application.Title:= 'a';
end;

procedure TFObjet.AppDeactivate(Sender: TObject);
begin
  Attendre:= True;
  //Application.Title:= 'd';
  //Application.Minimize;
end;

procedure TFObjet.VerifBDR;
var
  Registre: TRegistry;
  a, b: string;
begin
  //On vrifie la base de registre :
  Registre:= TRegistry.Create;
  try
    Registre.RootKey:= HKEY_CLASSES_ROOT;

    Registre.OpenKey('.bjt', True);
    a:= Registre.ReadString('');
    b:= 'Edob3D Fichier';
    if a <> b then Registre.WriteString('', b);
    Registre.CloseKey;

    Registre.OpenKey('.anm', True);
    a:= Registre.ReadString('');
    b:= 'Edob3D Fichier';
    if a <> b then Registre.WriteString('', b);
    Registre.CloseKey;

    Registre.OpenKey('Edob3D Fichier', True);
    a:= Registre.ReadString('');
    b:= 'Fichier Edob3D';
    if a <> b then Registre.WriteString('', b);
    Registre.CloseKey;

    Registre.OpenKey('Edob3D Fichier\shell\open\command', True);
    a:= Registre.ReadString('');
    b:= '"' + Application.ExeName + '" "%1"';
    if a <> b then Registre.WriteString('', b);
    Registre.CloseKey;


    Registre.OpenKey('Edob3D Fichier\DefaultIcon', True);
    a:= Registre.ReadString('');
    b:= Application.ExeName + ',1';
    if a <> b then Registre.WriteString('', b);
    Registre.CloseKey;
    Registre.Free;
  except
    Registre.Free;
    end;
end;

procedure TFObjet.SupprimeBDR;
var
  Registre:  TRegistry;
  a: string;
begin
  if MessageDlg(GmXMLLangue.GetStringByPath('Divers\NoFileAssociationFor'),
                mtConfirmation, [mbYes, mbNo], 0) = mrYes
    then begin
      AssociationFichiers:= False;
      Registre:= TRegistry.Create;
      try

        Registre.RootKey:= HKEY_CLASSES_ROOT;

        a:= '.bjt';
        Registre.DeleteKey(a);
        a:= '.anm';
        Registre.DeleteKey(a);
        a:= 'Edob3D Fichier';
        Registre.DeleteKey(a);

        Registre.Free;
      except
        Registre.Free;
        end;
      end
    else AssociationFichiers:= True;
end;





end.
