(******************************************************************************
Copyright (C) 2003 Pascal Peter

http://pascal.peter.free.fr/
pascal.peter@free.fr

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile,
mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
voir la Licence Publique Gnrale GNU.

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas,
crivez  la Free Software Foundation Inc.,
675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
-------------------------------------------------------------------------------

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************)

unit U_Anim;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,

  GLScene, VectorGeometry,
  
  Utils, UtilsSelect,
  UObjet, Animations, USuiv, UDuree,

  ExtCtrls, ComCtrls, ToolWin, ImgList, Menus;

type

  TForm_Anim = class(TForm)
    TreeView1: TTreeView;
    PanelBarreDOutils: TPanel;
    ToolBar3: TToolBar;
    ToolButton_Quitter: TToolButton;
    ToolButton6: TToolButton;
    ToolButton_Lecture: TToolButton;
    ToolButton_Stop: TToolButton;
    ToolButton2: TToolButton;
    StatusBar1: TStatusBar;
    Panel3: TPanel;
    TrackBar1: TTrackBar;
    ImageList_TreeView: TImageList;
    ToolButton_AjouteFrame: TToolButton;
    OpenDialog1: TOpenDialog;
    ToolButton_MetAJourFrame: TToolButton;





    PopupMenu_TreeView:         TPopupMenu;
    PMTV_NouvelleAnimation:     TMenuItem;
    PMTV_AjouteFrame:           TMenuItem;
    PMTV_MetAJourFrame:         TMenuItem;
    PMTV_N1:                    TMenuItem;
    PMTV_Suivante:              TMenuItem;
    PMTV_Enboucle:              TMenuItem;
    PMTV_N2:                    TMenuItem;
    PMTV_ChoisirUnSon:          TMenuItem;
    PMTV_SupprimerLeSon:        TMenuItem;
    PMTV_N3:                    TMenuItem;
    PMTV_Duree:                 TMenuItem;
    PMTV_N4:                    TMenuItem;
    PMTV_Supprimer:             TMenuItem;
    PMTV_SupprimeTout:          TMenuItem;
    PMTV_N5:                    TMenuItem;
    PMTV_DvelopperTout:         TMenuItem;
    PMTV_RduitTout:             TMenuItem;

    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ToolButton_LectureClick(Sender: TObject);
    procedure PMTV_NouvelleAnimationClick(Sender: TObject);
    procedure PMTV_SuivanteClick(Sender: TObject);
    procedure PMTV_EnboucleClick(Sender: TObject);
    procedure PMTV_ChoisirUnSonClick(Sender: TObject);
    procedure PMTV_SupprimerLeSonClick(Sender: TObject);
    procedure PMTV_DvelopperToutClick(Sender: TObject);
    procedure PMTV_RduitToutClick(Sender: TObject);
    procedure PMTV_AjouteFrameClick(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TreeView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TreeView1Edited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure PMTV_SupprimeToutClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PMTV_SupprimerClick(Sender: TObject);
    procedure PMTV_DureeClick(Sender: TObject);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure PMTV_MetAJourFrameClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ToolButton_QuitterClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Lecture: boolean;
    TreeNodeEx: TTreeNode;
    Actuel: TObjActuel;
    ObjAnimations: TObjAnimations;

    procedure SauvePosition;
    procedure MiseEnPlaceDesTextes;
    procedure Initialiser;
    procedure ChargerAnimations;

    procedure MetAJourTreeView(IndexAnimation: integer);
    procedure AppliqueImageIndex(TreeNode: TTreeNode; ImageIndex: integer);
    procedure SelectionneNodeAnimation(Index: integer);
    procedure MetAJourStatusBar;
    procedure Supprimer;

  end;

var
  Form_Anim: TForm_Anim;

implementation

{$R *.dfm}

//////////////////////////////////////////
//         Create etc... :
//////////////////////////////////////////

procedure TForm_Anim.FormCreate(Sender: TObject);
begin
  ObjAnimations:= TObjAnimations.create;
  ObjAnimations.GLParent:= TGLBaseSceneObject(FObjet.World);
  TrackBar1Change(Sender);
  MiseEnPlaceDesTextes;
  with FObjet.Window_Anim do begin
    Form_Anim.Top:= WindowTop;
    Form_Anim.Left:= WindowLeft;
    Form_Anim.Width:= WindowWidth;
    Form_Anim.Height:= WindowHeight;
    end;
  UtilsSelect_ObjAnimations:= ObjAnimations;
end;

procedure TForm_Anim.MiseEnPlaceDesTextes;
begin
  Caption:=                       GmXMLLangue.GetStringByPath('Hints\Animations');
  //les hint :
  ToolButton_Quitter.Hint:=       GmXMLLangue.GetStringByPath('Animations\Close');
  ToolButton_Lecture.Hint:=       GmXMLLangue.GetStringByPath('Animations\Read');
  ToolButton_Stop.Hint:=          GmXMLLangue.GetStringByPath('Animations\Stop');
  ToolButton_AjouteFrame.Hint:=   GmXMLLangue.GetStringByPath('Animations\AddFrame');
  ToolButton_MetAJourFrame.Hint:= GmXMLLangue.GetStringByPath('Animations\UpdateFrame');
  TrackBar1.Hint:=                GmXMLLangue.GetStringByPath('Animations\Speed');

  //le menu :
  PMTV_NouvelleAnimation.caption:=    GmXMLLangue.GetStringByPath('Animations\NewAnimation');
  PMTV_AjouteFrame.caption:=          GmXMLLangue.GetStringByPath('Animations\AddFrame');
  PMTV_MetAJourFrame.caption:=        GmXMLLangue.GetStringByPath('Animations\UpdateFrame');
  PMTV_Suivante.caption:=             GmXMLLangue.GetStringByPath('Animations\ChooseNextAnimation');
  PMTV_Enboucle.caption:=             GmXMLLangue.GetStringByPath('Animations\Loop');
  PMTV_ChoisirUnSon.caption:=         GmXMLLangue.GetStringByPath('Animations\ChooseSound');
  PMTV_SupprimerLeSon.caption:=       GmXMLLangue.GetStringByPath('Animations\DeleteSound');
  PMTV_Duree.caption:=                GmXMLLangue.GetStringByPath('Animations\FramesLength');
  PMTV_Supprimer.caption:=            GmXMLLangue.GetStringByPath('Animations\Delete');
  PMTV_SupprimeTout.caption:=         GmXMLLangue.GetStringByPath('Animations\DeleteAll');
  PMTV_DvelopperTout.caption:=        GmXMLLangue.GetStringByPath('Animations\ExpandAll');
  PMTV_RduitTout.caption:=            GmXMLLangue.GetStringByPath('Animations\CollapseAll');

end;

procedure TForm_Anim.FormShow(Sender: TObject);
begin
  FObjet.ToolButton_Anim.Down:= True;
end;

procedure TForm_Anim.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin          
  Form_Anim.WindowState:= wsNormal;
  FObjet.ToolButton_Anim.Down:= False;
  ToolButton_Stop.Down:= True;
  ToolButton_LectureClick(Sender);
  SauvePosition;
end;

procedure TForm_Anim.ToolButton_QuitterClick(Sender: TObject);
begin
  FObjet.ToolButton_AnimClick(Sender);
end;

procedure TForm_Anim.SauvePosition;
begin
  with FObjet.Window_Anim do begin
    WindowTop:= Form_Anim.Top;
    WindowLeft:= Form_Anim.Left;
    WindowWidth:= Form_Anim.Width;
    WindowHeight:= Form_Anim.Height;
    end;
end;

//////////////////////////////////////////
//         Charger Sauver :
//////////////////////////////////////////

procedure TForm_Anim.Initialiser;
var
  i: integer;
begin
  AttendreEx:= Attendre;
  Attendre:= True;
  ToolButton_Stop.Down:= True;
  ToolButton_LectureClick(self);
  TreeNodeEx:= nil;
  TreeView1.Items.Clear;
  ChargerAnimations;
  i:= round(Log2(ObjAnimations.Vitesse));
  if i < -5 then i:= -5;
  if i > 5 then i:= 5;
  TrackBar1.Position:= i;
  TrackBar1Change(self);
  Attendre:= AttendreEx;
end;

procedure TForm_Anim.ChargerAnimations;
var
  i, j: integer;
  NewTreeNodeAnimation, NewTreeNode: TTreeNode;
  ObjAnimation: TObjAnimation;
begin
  //if ObjAnimations.Simple then
  ObjAnimations.Compliquer;
  if ObjAnimations.Animations.count > 0 then begin
    for i:= 0 to ObjAnimations.Animations.count - 1 do begin
      ObjAnimation:= TObjAnimation(ObjAnimations.Animations[i]);
      NewTreeNodeAnimation:= TreeView1.Items.add(nil, ObjAnimation.Nom);
      if ObjAnimation.NumFrameSon < 0
        then AppliqueImageIndex(NewTreeNodeAnimation, 0)
        else AppliqueImageIndex(NewTreeNodeAnimation, 2);
      if ObjAnimation.Frames.count > 0 then
        for j:= 0 to ObjAnimation.Frames.count - 1 do begin
          NewTreeNode:= TreeView1.Items.AddChild(NewTreeNodeAnimation, inttostr(j));
          if j = ObjAnimation.NumFrameSon
            then AppliqueImageIndex(NewTreeNode, 3)
            else AppliqueImageIndex(NewTreeNode, 1);
          end;
      end;
    TreeView1.FullExpand;
    TreeView1.Selected:= TreeView1.Items[0];
    end;
end;


//////////////////////////////////////////
//               Divers :
//////////////////////////////////////////


procedure TForm_Anim.ToolButton_LectureClick(Sender: TObject);
var
  LectureEx: boolean;
begin
  AttendreEx:= Attendre;
  Attendre:= True;
  LectureEx:= Lecture;

  if Sender = ToolButton_Lecture
    then Lecture:= True
    else Lecture:= False;
  if Lecture = LectureEx then begin
    Attendre:= AttendreEx;
    exit;
    end;

  if Lecture
    then begin
      ToolButton_Lecture.Down:= True;
      ToolButton_Stop.Down:= False;
      end
    else begin
      ToolButton_Lecture.Down:= False;
      ToolButton_Stop.Down:= True;
      end;
  TreeView1.ReadOnly:= Lecture;
  PopupMenu_TreeView.AutoPopup:= not(Lecture);
  if Lecture
    then begin
      TreeView1.FullCollapse;
      ObjAnimations.Simplifier(False);
      ObjAnimations.ExTime:= -1;
      end
    else begin
      ObjAnimations.Compliquer;
      end;
  ToolButton_AjouteFrame.Enabled:= not(Lecture);
  ToolButton_MetAJourFrame.Enabled:= not(Lecture);
  Attendre:= AttendreEx;
end;

//////////////////////////////////////////
//         PopUp du TreeView :
//////////////////////////////////////////

procedure TForm_Anim.PMTV_NouvelleAnimationClick(Sender: TObject);
var
  NewTreeNodeAnimation: TTreeNode;
  a: string;


  NewObjFrame: TObjFrame;
  i: integer;

  NewTreeNodeFrame: TTreeNode;
begin
  a:= NouvelleAnimation;
  ObjAnimations.AjouteAnimation(a);
  NewTreeNodeAnimation:= TreeView1.Items.add(nil, a);
  NewTreeNodeAnimation.ImageIndex:= 0;
  NewTreeNodeAnimation.SelectedIndex:= 0;

  AfficheAxes(False);
  NewObjFrame:= TObjFrame.Create;
  with FObjet.World do
    if Count > 0 then
      for i:= 0 to Count - 1 do
        NewObjFrame.AjouteComponent(Children[i]);
  ObjAnimations.AnimationActuelle.Frames.Add(NewObjFrame);
  NewTreeNodeFrame:= TreeView1.Items.AddChild(NewTreeNodeAnimation,
                                         inttostr(NewTreeNodeAnimation.count));
  NewTreeNodeFrame.ImageIndex:= 1;
  NewTreeNodeFrame.SelectedIndex:= 1;
  TreeView1.Selected:= NewTreeNodeFrame;
  NewTreeNodeAnimation.Expand(True);
  AfficheAxes(True);

end;

procedure TForm_Anim.PMTV_AjouteFrameClick(Sender: TObject);
var
  NewObjFrame: TObjFrame;
  i: integer;
  a: string;
  TreeNodeAnimation, NewTreeNode: TTreeNode;
begin
  AfficheAxes(False);
  if TreeView1.Items.Count < 1
    then begin
      a:= NouvelleAnimation;
      ObjAnimations.AjouteAnimation(a);
      TreeNodeAnimation:= TreeView1.Items.add(nil, a);
      TreeNodeAnimation.ImageIndex:= 0;
      TreeNodeAnimation.SelectedIndex:= 0;
      end
    else begin
      TreeNodeAnimation:= TreeView1.Items[0];
      if Actuel.IndexAnimation > 0 then
        for i:= 1 to Actuel.IndexAnimation do
          TreeNodeAnimation:= TreeNodeAnimation.GetNextSibling;
      end;
  NewObjFrame:= TObjFrame.Create;
  with FObjet.World do
    if Count > 0 then
      for i:= 0 to Count - 1 do
        NewObjFrame.AjouteComponent(Children[i]);
  ObjAnimations.AnimationActuelle.Frames.Add(NewObjFrame);
  NewTreeNode:= TreeView1.Items.AddChild(TreeNodeAnimation,
                                         inttostr(TreeNodeAnimation.count));
  NewTreeNode.ImageIndex:= 1;
  NewTreeNode.SelectedIndex:= 1;
  TreeView1.Selected:= NewTreeNode;
  TreeNodeAnimation.Expand(True);
  AfficheAxes(True);
end;

procedure TForm_Anim.PMTV_MetAJourFrameClick(Sender: TObject);
var
  ObjFrame: TObjFrame;
  i, n, j: integer;
begin
  if Lecture then exit;
  if TreeView1.Items.Count < 2 then exit;
  AfficheAxes(False);
  { arranger
  if Actuel.TouteLAnimation
    then begin
      n:= ObjAnimations.AnimationActuelle.Frames.Count;
      for j:= 0 to n - 1 do begin
        //aaa
        end;
      end
    else begin
    }
      ObjFrame:= TObjFrame(ObjAnimations.AnimationActuelle.Frames[Actuel.IndexFrame]);
      if ObjFrame.Components.Count > 0 then
        for i:= ObjFrame.Components.Count - 1 downto 0 do
          TObjSimple(ObjFrame.Components[i]).free;
      ObjFrame.Components.Clear;
      with FObjet.World do
        if Count > 0 then
          for i:= 0 to Count - 1 do
            ObjFrame.AjouteComponent(Children[i]);
      //end;
  AfficheAxes(True);
end;

procedure TForm_Anim.PMTV_SuivanteClick(Sender: TObject);
var
  ObjAnimation: TObjAnimation;
  i: integer;
begin
  ObjAnimations.MetAJourNomsDesAnimations;
  ObjAnimation:= ObjAnimations.AnimationActuelle;
  Application.CreateForm(TFSuiv, FSuiv);
  with FSuiv do begin
    ChoixDeLAnimationSuivante:= ObjAnimation.Suivante;
    caption:= GmXMLLangue.GetStringByPath('Animations\ChooseNextAnimation');
    Button_OK.caption:= GmXMLLangue.GetStringByPath('Animations\OK');
    Button_Annuler.caption:= GmXMLLangue.GetStringByPath('Animations\Cancel');
    ListBox1.Items.Assign(ObjAnimations.NomsDesAnimations);
    i:= ChoixDeLAnimationSuivante;
    if i < 0 then i:= 0;
    ListBox1.ItemIndex:= i;
    end;
  if FSuiv.ShowModal = mrOK then
    ObjAnimation.Suivante:= FSuiv.ChoixDeLAnimationSuivante;
end;

procedure TForm_Anim.PMTV_EnboucleClick(Sender: TObject);
var
  ObjAnimation: TObjAnimation;
begin
  PMTV_Enboucle.Checked:= not(PMTV_Enboucle.Checked);
  ObjAnimation:= ObjAnimations.AnimationActuelle;
  ObjAnimation.Loop:= PMTV_Enboucle.Checked;
end;

procedure TForm_Anim.PMTV_ChoisirUnSonClick(Sender: TObject);
var
  ObjAnimation: TObjAnimation;
begin
  ObjAnimation:= ObjAnimations.AnimationActuelle;
  if ObjAnimation.NumFrameSon > -1 then
    if MessageDlg(GmXMLLangue.GetStringByPath('Animations\ReplaceSound'),
                  mtConfirmation,
                  [mbYes, mbNo],
                  0) = mrNo
      then exit;

  OpenDialog1.Filter:= GmXMLLangue.GetStringByPath('Animations\SoundFiles') + ' (*.wav)|*.wav';
  OpenDialog1.DefaultExt:= '.wav';
  OpenDialog1.InitialDir:= CheminFichiers;
  OpenDialog1.FileName:= '';
  OpenDialog1.Title:= FObjet.ArrangeCaption(PMTV_ChoisirUnSon.caption);
  if OpenDialog1.Execute then begin
    ObjAnimation.PlaceFichierSon(OpenDialog1.FileName, Actuel.IndexFrame);
    Application.Processmessages;
    MetAJourTreeView(Actuel.IndexAnimation);
    end;
end;

procedure TForm_Anim.PMTV_SupprimerLeSonClick(Sender: TObject);
var
  ObjAnimation: TObjAnimation;
begin
  ObjAnimation:= ObjAnimations.AnimationActuelle;
  if ObjAnimation.NumFrameSon > -1 then
    if MessageDlg(GmXMLLangue.GetStringByPath('Animations\DeleteSound'),
                  mtConfirmation,
                  [mbYes, mbNo],
                  0) = mrNo
      then exit;
  ObjAnimation.SupprimeSon;
  MetAJourTreeView(Actuel.IndexAnimation);
end;

procedure TForm_Anim.PMTV_DureeClick(Sender: TObject);
var
  ObjAnimation: TObjAnimation;
  ObjFrame: TObjFrame;
begin
  ObjAnimation:= TObjAnimation(ObjAnimations.Animations[Actuel.IndexAnimation]);
  ObjFrame:= TObjFrame(ObjAnimation.Frames[Actuel.IndexFrame]);
  Application.CreateForm(TFormDuree, FormDuree);
  try
    FormDuree.caption:= GmXMLLangue.GetStringByPath('Animations\FramesLength');
    FormDuree.SpinEdit1.Value:= ObjFrame.Duree;
    FormDuree.showmodal;
    ObjFrame.Duree:= FormDuree.SpinEdit1.Value;
  finally
    FormDuree.free;
    end;
end;

procedure TForm_Anim.PMTV_SupprimerClick(Sender: TObject);
begin
  Supprimer;
end;

procedure TForm_Anim.Supprimer;
var
  ObjAnimation: TObjAnimation;
begin
  if TreeView1.Selected.Level = 0
    then begin
      //supprimer l'animation
      if MessageDlg(GmXMLLangue.GetStringByPath('Animations\DeleteAnimation'),
                    mtConfirmation,
                    [mbYes, mbNo], 0) = mrYes then begin
        Attendre:= True;
        ObjAnimations.SupprimerAnimation(Actuel.IndexAnimation);
        Actuel:= ObjAnimations.RetourneActuel;
        Initialiser;
        Attendre:= False;
        end;
      end
    else begin
      //supprimer la frame
      if MessageDlg(GmXMLLangue.GetStringByPath('Animations\DeleteFrame'),
                    mtConfirmation,
                    [mbYes, mbNo], 0) = mrYes then begin
        Attendre:= True;
        ObjAnimation:= TObjAnimation(ObjAnimations.Animations[Actuel.IndexAnimation]);
        if ObjAnimation.Frames.Count > 1 then begin
          ObjAnimation.SupprimerFrame(Actuel.IndexFrame);
          Actuel:= ObjAnimations.RetourneActuel;
          Initialiser;
          end;
        Attendre:= False;
        end;
      end;
end;

procedure TForm_Anim.PMTV_SupprimeToutClick(Sender: TObject);
begin
  if MessageDlg(GmXMLLangue.GetStringByPath('Animations\DeleteAll'),
                mtConfirmation,
                [mbYes, mbNo], 0) = mrYes then begin
    ObjAnimations.Initialiser;
    Initialiser;
    end;
end;

procedure TForm_Anim.PMTV_DvelopperToutClick(Sender: TObject);
begin
  TreeView1.FullExpand;
end;

procedure TForm_Anim.PMTV_RduitToutClick(Sender: TObject);
begin
  TreeView1.FullCollapse;
end;









procedure TForm_Anim.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
  if Attendre then exit;
  if TreeView1.Items.Count < 2 then exit;
  //Si on est en mode Lecture :
  if Lecture = True
    then begin
      if Node.Level = 0 then ObjAnimations.JoueAnimationViaNom(Node.Text);
      end
    //Si on est en mode dition :
    else begin
      if Node.Level = 0
        then begin
          TreeView1.ReadOnly:= False;
          Actuel.IndexAnimation:= Node.Index;
          Actuel.IndexFrame:= 0;
          Actuel.TouteLAnimation:= True;
          end
        else begin
          TreeView1.ReadOnly:= True;
          Actuel.IndexAnimation:= Node.Parent.Index;
          Actuel.IndexFrame:= Node.Index;
          Actuel.TouteLAnimation:= False;
          end;
      ObjAnimations.Affiche(Actuel.IndexAnimation, Actuel.IndexFrame);
      end;
  MetAJourStatusBar;
end;

procedure TForm_Anim.MetAJourStatusBar;
begin
  StatusBar1.Panels[1].Text:= Format(GmXMLLangue.GetStringByPath('Animations\Animation') + ' : %d  ' + #13 + GmXMLLangue.GetStringByPath('Animations\Frame') + ' : %d',
                                     [Actuel.IndexAnimation,
                                     Actuel.IndexFrame]);
end;

procedure TForm_Anim.MetAJourTreeView(IndexAnimation: integer);
var
  TreeNodeA: TTreeNode;
  i: integer;
  ObjAnimation: TObjAnimation;
begin
  if IndexAnimation < 0 then exit;
  TreeNodeA:= TreeView1.Items[0];
  if IndexAnimation > 0 then for i:= 1 to IndexAnimation do
    TreeNodeA:= TreeNodeA.GetNextSibling;
  ObjAnimation:= TObjAnimation(ObjAnimations.Animations[IndexAnimation]);
  if ObjAnimation.NumFrameSon < 0
    then AppliqueImageIndex(TreeNodeA, 0)
    else AppliqueImageIndex(TreeNodeA, 2);
  for i:= 0 to TreeNodeA.count - 1 do
    AppliqueImageIndex(TreeNodeA.item[i], 1);
  if ObjAnimation.NumFrameSon > -1
    then AppliqueImageIndex(TreeNodeA.item[ObjAnimation.NumFrameSon], 3);
  TreeView1.refresh;
end;

procedure TForm_Anim.AppliqueImageIndex(TreeNode: TTreeNode; ImageIndex: integer);
begin
  TreeNode.ImageIndex:= ImageIndex;
  TreeNode.SelectedIndex:= ImageIndex;
end;

procedure TForm_Anim.TreeView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  MyHitTest: THitTests;
  TreeNode: TTreeNode;
begin
  //A priori :
  PMTV_NouvelleAnimation.enabled:= False;
  PMTV_AjouteFrame.enabled:= False;
  PMTV_MetAJourFrame.enabled:= False;
  PMTV_Suivante.enabled:= False;
  PMTV_Enboucle.enabled:= False;
  PMTV_ChoisirUnSon.enabled:= False;
  PMTV_SupprimerLeSon.enabled:= False;
  PMTV_Duree.enabled:= False;
  PMTV_Supprimer.enabled:= False;


  MyHitTest := TreeView1.GetHitTestInfoAt(X,Y);
  TreeNode:= TreeView1.GetNodeAt(X, Y);

  //Si on a cliqu hors de la slection :
  if (htNowhere in MyHitTest) or (htOnRight in MyHitTest) then begin
    PMTV_NouvelleAnimation.enabled:= True;
    Exit;
    end;
  if TreeNode <> TreeView1.Selected then begin
    PMTV_NouvelleAnimation.enabled:= True;
    Exit;
    end;

  //Si on a cliqu dans la slection :
  if (htOnItem in MyHitTest) then begin
    //Si on a cliqu sur une Animation :
    if TreeView1.Selected.Level = 0 then begin
      PMTV_AjouteFrame.enabled:= True;
      PMTV_Suivante.enabled:= True;
      PMTV_Enboucle.enabled:= True;
      PMTV_Enboucle.Checked:= TObjAnimation(ObjAnimations.Animations[Actuel.IndexAnimation]).Loop;
      PMTV_Supprimer.enabled:= True;
      end;
    //Si on a cliqu sur une Frame :
    if TreeView1.Selected.Level > 0 then begin
      PMTV_MetAJourFrame.enabled:= True;
      PMTV_ChoisirUnSon.enabled:= True;
      if TreeView1.Selected.ImageIndex = 3 then
        PMTV_SupprimerLeSon.enabled:= True;
      PMTV_Duree.enabled:= True;
      PMTV_Supprimer.enabled:= True;
      end;
    end;
end;

procedure TForm_Anim.TreeView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then Supprimer;
end;

procedure TForm_Anim.TreeView1Edited(Sender: TObject; Node: TTreeNode;
  var S: String);
var
  ObjAnimation: TObjAnimation;
begin
  if TreeView1.Selected.Level > 0 then Exit;
  ObjAnimation:= ObjAnimations.AnimationActuelle;
  if ObjAnimation <> nil then begin
    Attendre:= True;
    ObjAnimation.Nom:= S;
    ObjAnimations.MetAJourNomsDesAnimations;
    Attendre:= False;
    end;
end;

procedure TForm_Anim.TrackBar1Change(Sender: TObject);
begin
  ObjAnimations.Vitesse:= IntPower(2, TrackBar1.Position);
  StatusBar1.Panels[0].Text:= Format(GmXMLLangue.GetStringByPath('Animations\Speed') + ' : ' + '%.2f', [ObjAnimations.Vitesse]);
end;

procedure TForm_Anim.SelectionneNodeAnimation(Index: integer);
var
  TreeNode: TTreeNode;
  i: integer;
begin
  if TreeView1.Items.Count < 1 then exit;
  TreeNode:= TreeView1.Items[0];
  if Index > 0 then for i:= 1 to Index do
    TreeNode:= TreeNode.GetNextSibling;
  TreeView1.Selected:= TreeNode;
end;



procedure TForm_Anim.TreeView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if not(Lecture) then Accept:= True;
end;

procedure TForm_Anim.TreeView1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  AnItem: TTreeNode;
  HT: THitTests;
  NewIndexAnimation, NewIndexFrame: integer;
begin
  if Lecture then exit;
  if TreeView1.Selected = nil then Exit;
  HT:= TreeView1.GetHitTestInfoAt(X, Y);
  AnItem:= TreeView1.GetNodeAt(X, Y);
  if (HT - [htOnItem, htOnIcon, htNowhere, htOnIndent] <> HT) then begin
    if AnItem.Level = 0
      then begin
        NewIndexAnimation:= AnItem.Index;
        NewIndexFrame:= AnItem.count;
        end
      else begin
        NewIndexAnimation:= AnItem.Parent.Index;
        NewIndexFrame:= AnItem.Index;
        end;
     if TreeView1.Selected.Level = 0 then NewIndexFrame:= -1;
     ObjAnimations.Deplace(Actuel.IndexAnimation, Actuel.IndexFrame,
                           NewIndexAnimation, NewIndexFrame);
     Initialiser;
     Attendre:= False;                 
    end;
end;

end.
