(******************************************************************************
Copyright (C) 2003 Pascal Peter

http://pascal.peter.free.fr/
pascal.peter@free.fr

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile,
mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
voir la Licence Publique Gnrale GNU.

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas,
crivez  la Free Software Foundation Inc.,
675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
-------------------------------------------------------------------------------

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************)

unit U_Perspective;

interface

uses
  Classes, Controls, Forms, ExtCtrls,

  GLWin32Viewer, VectorGeometry,

  Utils, UtilsSelect,

  UObjet;

type
  TForm_Perspective = class(TForm)
    Panel2: TPanel;
    GLSceneViewer_Perspective: TGLSceneViewer;
    procedure GLSceneViewer_PerspectiveMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer_PerspectiveMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure GLSceneViewer_PerspectiveBeforeRender(Sender: TObject);
    procedure GLSceneViewer_PerspectivePostRender(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure SauvePosition;
  end;

var
  Form_Perspective: TForm_Perspective;

implementation


{$R *.DFM}


procedure TForm_Perspective.FormCreate(Sender: TObject);
begin
  Form_Perspective.Caption:= GmXMLLangue.GetStringByPath('Hints\PerspectiveView');
  with FObjet.Window_Perspective do begin
    Form_Perspective.Top:= WindowTop;
    Form_Perspective.Left:= WindowLeft;
    Form_Perspective.Width:= WindowWidth;
    Form_Perspective.Height:= WindowHeight;
    end;
  Form_Perspective.GLSceneViewer_Perspective.Buffer.BackGroundColor:= FObjet.CouleurFond;
  FObjet.ToolButton_Perspective.Down:= True;
end;

procedure TForm_Perspective.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  Form_Perspective.WindowState:= wsNormal;
  FObjet.ToolButton_Perspective.Down:= False;
  SauvePosition;
end;

procedure TForm_Perspective.SauvePosition;
begin
  with FObjet.Window_Perspective do begin
    WindowOuvert:= FObjet.ToolButton_Perspective.Down;
    WindowTop:= Form_Perspective.Top;
    WindowLeft:= Form_Perspective.Left;
    WindowWidth:= Form_Perspective.Width;
    WindowHeight:= Form_Perspective.Height;
    end;
end;





procedure TForm_Perspective.GLSceneViewer_PerspectiveMouseDown(
  Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if Attendre then exit;
  mx:= x;
  my:= y;
end;

procedure TForm_Perspective.GLSceneViewer_PerspectiveMouseMove(
  Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  dx, dy, s: single;
  v: TVector;
begin
  if Attendre then exit;
  if not(ssLeft in Shift) then
    if not(ssRight in Shift) then
      if not(ssMiddle in Shift) then
        exit;
  dx:= mx - x;
  dy:= my - y;
  mx:= x;
  my:= y;
  if ssLeft in Shift
    then FObjet.GLCamera_Perspective.MoveAroundTarget(dy, dx)
    else if ssRight in Shift
      then begin
        s:= Power(0.9, (dy - dx) / 10);
        v:= FObjet.GLCamera_Perspective.Position.AsVector;
        ScaleVector(v, s);
        FObjet.GLCamera_Perspective.Position.AsVector:= v;
        end
    else if ssMiddle in Shift
      then begin
        s:= Power(0.9, (dy - dx) / 10);
        FObjet.GLCamera_Perspective.Position.Y:= s * FObjet.GLCamera_Perspective.Position.Y;
        end;
end;

procedure TForm_Perspective.FormResize(Sender: TObject);
begin
  FObjet.AVIRecorder1.Width:= GLSceneViewer_Perspective.Width;
  FObjet.AVIRecorder1.Height:= GLSceneViewer_Perspective.Height;
end;

procedure TForm_Perspective.GLSceneViewer_PerspectiveBeforeRender(
  Sender: TObject);
begin
  //FObjet.GLLightSource2.Shining:= False;
end;

procedure TForm_Perspective.GLSceneViewer_PerspectivePostRender(
  Sender: TObject);
begin
  //FObjet.GLLightSource2.Shining:= True;
end;

end.
