(******************************************************************************
Copyright (C) 2003 Pascal Peter

http://pascal.peter.free.fr/
pascal.peter@free.fr

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile,
mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
voir la Licence Publique Gnrale GNU.

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas,
crivez  la Free Software Foundation Inc.,
675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
-------------------------------------------------------------------------------

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************)

unit U_VueDroite;

interface

uses
  Classes, Controls, Forms, ExtCtrls,

  GLWin32Viewer,

  Utils, 

  UObjet;

type
  TForm_VueDroite = class(TForm)
    Panel5: TPanel;
    GLSceneViewer_VueDroite: TGLSceneViewer;
    procedure GLSceneViewer_VueDroiteMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer_VueDroiteMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer_VueDroiteMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure SauvePosition;
  end;

var
  Form_VueDroite: TForm_VueDroite;

implementation

{$R *.DFM}


procedure TForm_VueDroite.FormCreate(Sender: TObject);
begin
  Form_VueDroite.Caption:= GmXMLLangue.GetStringByPath('Hints\RightView');
  with FObjet.Window_VueDroite do begin
    Form_VueDroite.Top:= WindowTop;
    Form_VueDroite.Left:= WindowLeft;
    Form_VueDroite.Width:= WindowWidth;
    Form_VueDroite.Height:= WindowHeight;
    end;
  Form_VueDroite.GLSceneViewer_VueDroite.Buffer.BackGroundColor:= FObjet.CouleurFond;
  FObjet.ToolButton_VueDroite.Down:= True;
end;

procedure TForm_VueDroite.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  Form_VueDroite.WindowState:= wsNormal;
  FObjet.ToolButton_VueDroite.Down:= False;
  SauvePosition;
end;

procedure TForm_VueDroite.SauvePosition;
begin
  with FObjet.Window_VueDroite do begin
    WindowOuvert:= FObjet.ToolButton_VueDroite.Down;
    WindowTop:= Form_VueDroite.Top;
    WindowLeft:= Form_VueDroite.Left;
    WindowWidth:= Form_VueDroite.Width;
    WindowHeight:= Form_VueDroite.Height;
    end;
end;







procedure TForm_VueDroite.GLSceneViewer_VueDroiteMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FObjet.GLSceneViewerMouseDown(Sender, Button, Shift, X, Y);
end;

procedure TForm_VueDroite.GLSceneViewer_VueDroiteMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  FObjet.GLSceneViewerMouseMove(Sender, Shift, X, Y);
end;

procedure TForm_VueDroite.GLSceneViewer_VueDroiteMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FObjet.GLSceneViewerMouseUp(Sender, Button, Shift, X, Y);
end;

end.
