(******************************************************************************
Copyright (C) 2003 Pascal Peter

http://pascal.peter.free.fr/
pascal.peter@free.fr

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile,
mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
voir la Licence Publique Gnrale GNU.

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas,
crivez  la Free Software Foundation Inc.,
675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
-------------------------------------------------------------------------------

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************)

unit U_VueFace;

interface

uses
  Classes, Controls, Forms, ExtCtrls,

  GLWin32Viewer, OpenGL1x,

  Utils,

  UObjet;

type
  TForm_VueFace = class(TForm)
    Panel4: TPanel;
    GLSceneViewer_VueFace: TGLSceneViewer;
    procedure GLSceneViewer_VueFaceMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer_VueFaceMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer_VueFaceMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure GLSceneViewer_VueFaceBeforeRender(Sender: TObject);
    procedure GLSceneViewer_VueFacePostRender(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure SauvePosition;
  end;

var
  Form_VueFace: TForm_VueFace;

implementation

{$R *.DFM}


procedure TForm_VueFace.FormCreate(Sender: TObject);
begin
  Form_VueFace.Caption:= GmXMLLangue.GetStringByPath('Hints\FrontView');
  with FObjet.Window_VueFace do begin
    Form_VueFace.Top:= WindowTop;
    Form_VueFace.Left:= WindowLeft;
    Form_VueFace.Width:= WindowWidth;
    Form_VueFace.Height:= WindowHeight;
    end;
  Form_VueFace.GLSceneViewer_VueFace.Buffer.BackGroundColor:= FObjet.CouleurFond;
  FObjet.ToolButton_VueFace.Down:= True;
end;

procedure TForm_VueFace.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  Form_VueFace.WindowState:= wsNormal;
  FObjet.ToolButton_VueFace.Down:= False;
  SauvePosition;
end;

procedure TForm_VueFace.SauvePosition;
begin
  with FObjet.Window_VueFace do begin
    WindowOuvert:= FObjet.ToolButton_VueFace.Down;
    WindowTop:= Form_VueFace.Top;
    WindowLeft:= Form_VueFace.Left;
    WindowWidth:= Form_VueFace.Width;
    WindowHeight:= Form_VueFace.Height;
    end;
end;







procedure TForm_VueFace.GLSceneViewer_VueFaceMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FObjet.GLSceneViewerMouseDown(Sender, Button, Shift, X, Y);
end;

procedure TForm_VueFace.GLSceneViewer_VueFaceMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  FObjet.GLSceneViewerMouseMove(Sender, Shift, X, Y);
end;

procedure TForm_VueFace.GLSceneViewer_VueFaceMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FObjet.GLSceneViewerMouseUp(Sender, Button, Shift, X, Y);
end;

procedure TForm_VueFace.GLSceneViewer_VueFaceBeforeRender(Sender: TObject);
begin
  //FObjet.GLLightSource1.Shining:= False;
end;

procedure TForm_VueFace.GLSceneViewer_VueFacePostRender(Sender: TObject);
begin
  //FObjet.GLLightSource1.Shining:= True;
end;

end.
