unit UProperties;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,

  GLScene, GeometryBB, VectorGeometry,




  Utils,

  ComCtrls, Mask, Buttons{, FloatSpinEdit};


type
  TFProperties = class(TForm)
    TrackBar1: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    TrackBar2: TTrackBar;
    Label3: TLabel;
    TrackBar3: TTrackBar;
    Label4: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    FloatSpinEdit1: TEdit;
    FloatSpinEdit2: TEdit;
    FloatSpinEdit3: TEdit;
    FloatSpinEdit4: TEdit;
    FloatSpinEdit5: TEdit;
    FloatSpinEdit6: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    ButtonResetRotations: TButton;
    procedure FormShow(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure FloatSpinEdit1Change(Sender: TObject);
    procedure FloatSpinEdit2Change(Sender: TObject);
    procedure FloatSpinEdit3Change(Sender: TObject);
    procedure FloatSpinEdit4Change(Sender: TObject);
    procedure FloatSpinEdit5Change(Sender: TObject);
    procedure FloatSpinEdit6Change(Sender: TObject);
    procedure ButtonResetRotationsClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure CalculeDimensions;
  public
    { Dclarations publiques }
    ValeursInitiales: array[1..9] of Single;
    Noms: array[1..3] of string;
  end;

var
  FProperties: TFProperties;

implementation

uses UtilsSelect;

{$R *.dfm}

procedure TFProperties.FormShow(Sender: TObject);
var
  i: integer;
begin
  ValeursInitiales[1]:= ObjetCourant.PitchAngle;
  ValeursInitiales[2]:= ObjetCourant.TurnAngle;
  ValeursInitiales[3]:= ObjetCourant.RollAngle;
  for i:= 1 to 3 do begin
    if ValeursInitiales[i] >= 360 then
      while ValeursInitiales[i] >= 360 do ValeursInitiales[i]:= ValeursInitiales[i] - 360;
    if ValeursInitiales[i] < 0 then
      while ValeursInitiales[i] < 0 do ValeursInitiales[i]:= ValeursInitiales[i] + 360;
    end;
  TrackBar1.Position:= trunc(ValeursInitiales[1]);
  TrackBar1Change(Sender);
  TrackBar2.Position:= trunc(ValeursInitiales[2]);
  TrackBar2Change(Sender);
  TrackBar3.Position:= trunc(ValeursInitiales[3]);
  TrackBar3Change(Sender);

  ValeursInitiales[4]:= ObjetCourant.Position.X;
  ValeursInitiales[5]:= ObjetCourant.Position.Y;
  ValeursInitiales[6]:= ObjetCourant.Position.Z;
  FloatSpinEdit1.text:= floattostr(round(ValeursInitiales[4] * 1000) / 1000);
  FloatSpinEdit2.text:= floattostr(round(ValeursInitiales[5] * 1000) / 1000);
  FloatSpinEdit3.text:=  floattostr(-round(ValeursInitiales[6] * 1000) / 1000);
  //FloatSpinEdit1.Increment:= 1/10;
 // FloatSpinEdit2.Increment:= 1/10;
 // FloatSpinEdit3.Increment:= 1/10;

  ValeursInitiales[7]:= ObjetCourant.Scale.X;
  ValeursInitiales[8]:= ObjetCourant.Scale.Y;
  ValeursInitiales[9]:= ObjetCourant.Scale.Z;
  FloatSpinEdit4.text:= floattostr(round(ValeursInitiales[7] * 1000) / 1000);
  FloatSpinEdit5.text:= floattostr(round(ValeursInitiales[8] * 1000) / 1000);
  FloatSpinEdit6.text:= floattostr(round(ValeursInitiales[9] * 1000) / 1000);
 // FloatSpinEdit4.Increment:= 1/10;
  //FloatSpinEdit5.Increment:= 1/10;
  //FloatSpinEdit6.Increment:= 1/10;

  CalculeDimensions;
end;

procedure TFProperties.CalculeDimensions;
var
  box1: TAABB;
  v: TAffineVector;
begin
  box1:=ObjetCourant.AxisAlignedBoundingBoxUnscaled;
  if box1.min[2] >= box1.max[2] then exit;
  AABBTransform(box1,ObjetCourant.AbsoluteMatrix);
  v:= VectorSubtract(box1.max, box1.min);

  Label13.caption:= Format('%.3f m', [v[0]]);
  Label14.caption:= Format('%.3f m', [v[1]]);
  Label15.caption:= Format('%.3f m', [v[2]]);
end;


procedure TFProperties.TrackBar1Change(Sender: TObject);
var
  s: single;
begin
  s:= TrackBar1.Position;
  Label1.caption:= Format(Noms[1] + ' : %.0f ', [s]);
  ObjetCourant.PitchAngle:= s;
  CalculeDimensions;
end;

procedure TFProperties.TrackBar2Change(Sender: TObject);
var
  s: single;
begin
  s:= TrackBar2.Position;
  Label2.caption:= Format(Noms[2] + ' : %.0f ', [s]);
  ObjetCourant.TurnAngle:= s;
  CalculeDimensions;
end;

procedure TFProperties.TrackBar3Change(Sender: TObject);
var
  s: single;
begin
  s:= TrackBar3.Position;
  Label3.caption:= Format(Noms[3] + ' : %.0f ', [s]);
  ObjetCourant.RollAngle:= s;
  CalculeDimensions;
end;

procedure TFProperties.FloatSpinEdit1Change(Sender: TObject);
begin
  ObjetCourant.Position.X:= strtofloatdef(FloatSpinEdit1.text,0);
  CalculeDimensions;
end;

procedure TFProperties.FloatSpinEdit2Change(Sender: TObject);
begin
  ObjetCourant.Position.Y:= strtofloatdef(FloatSpinEdit2.text,0);
end;

procedure TFProperties.FloatSpinEdit3Change(Sender: TObject);
begin
  ObjetCourant.Position.Z:= - strtofloatdef(FloatSpinEdit3.text,0);
end;

procedure TFProperties.FloatSpinEdit4Change(Sender: TObject);
begin
  ObjetCourant.Scale.X:= strtofloatdef(FloatSpinEdit4.text,0);
  CalculeDimensions;
end;

procedure TFProperties.FloatSpinEdit5Change(Sender: TObject);
begin
  ObjetCourant.Scale.Y:= strtofloatdef(FloatSpinEdit5.text,0);
  CalculeDimensions;
end;

procedure TFProperties.FloatSpinEdit6Change(Sender: TObject);
begin
  ObjetCourant.Scale.Z:= strtofloatdef(FloatSpinEdit6.text,0);
  CalculeDimensions;
end;

procedure TFProperties.ButtonResetRotationsClick(Sender: TObject);
var
  P, T, R : Single;
  D, U: TVector;
begin
  with ObjetCourant do begin
    P:= PitchAngle;
    T:= TurnAngle;
    R:= RollAngle;
    D:= Direction.AsVector;
    U:= Up.AsVector;
    ResetRotations;
    PitchAngle:= P;
    TurnAngle:= T;
    RollAngle:= R;
    end;
end;

end.
