(******************************************************************************
Copyright (C) 2003 Pascal Peter

http://pascal.peter.free.fr/
pascal.peter@free.fr

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile,
mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION
ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail,
voir la Licence Publique Gnrale GNU.

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas,
crivez  la Free Software Foundation Inc.,
675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
-------------------------------------------------------------------------------

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************)

unit Utils;

interface


uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs, ExtCtrls,
  MMSystem, ShellAPI, ShlObj, Graphics,


  GLScene, GLObjects, GLGraph, GLTexture, VectorGeometry,
  GLCollision, GLTerrainRenderer,

  GLMisc,
  //OpenGL1x,
  GLGeomObjects,
  GLPolyhedron,
  GLMeshBuilderx,

  glMyFreeForm, glObjet3ds, GLVectorFileObjects,
  Animations, glRepere,
  UPBar,

  GmXml, object2xml;

Const
  //VitesseAvance = 10;
  //VitesseRotation = 45;
  //VitesseDecalagePlateForme = 2;
  //HauteurSaut = 1;

  Etat_SurSol = 0;
  Etat_SurPlateForme = 1;
  Etat_Tombe = 2;

  Tag_Obstacle = -1;
  Tag_Traversable = 0;
  Tag_Cassable = -2;
  Tag_PassageAuHasard = 1000;  // > 0  pour les autres !!!


var
  Debug: boolean;
  
  Chemin, CheminFichiers, DossierDansTemp: string;
  AppVersion: string;
  SaveSeparator: Char;

  GmXMLLangue: TGmXML;
  Textes: TStringList;
  Texte_PbFichier: string;

  FichierTerrain: string;
  Largeur, DemiLargeur, Profondeur, DemiProfondeur: single;
  ExaggerationVerticale: single;
  DecalageVerticalTerrain: single;

  GenreCiel: integer;

  Echelle,
  VitesseAvance,
  VitesseAvanceActeur,
  VitesseRotation,
  VitesseDecalagePlateForme,
  HauteurSaut,
  HauteurCamera, DMiniCamera, DMaxiCamera,
  TailleActeur: single;


  VitesseDeplacements: integer;
  ExTime, TimeMessage, DureeMessage, TimeTouchesSpeciales, TimeTrucs, TimeDivers, TimeDuration, TimeDebut: Double;

  Attendre, AttendreEx, Lancement, PremierLancement, Fin: boolean;

  MyCollisionManager: TCollisionManager;
  CollisionDetected: boolean;
  ObstaclesActuels: TList;
  Saut: single;
  SautEnCours: boolean;
  Encadrement: TGLDummyCube;
  PlateForme, ObstacleActuel: TGLBaseSceneObject;
  Etat: integer;
  PositionEx, PositionNew, PositionInitiale: TVector;
  DirectionEx, DirectionNew, DirectionInitiale: TVector;
  UpEx, UpNew, UpInitial: TVector;
  Deplacement: boolean;
  Avance, Tourne, DecalagePlateForme: single;
  DecalageEncadrement: single;
  fDelta: Single;
  KeyState: TKeyboardState;

  Obstacles, FreeFormAvecOctree: TList;

  SonCollision, SonPassage, SonCassable, SonSaut, SonGagne: string;

  ComponentCopie: string;

  MyMaterialLibrary: TGLMaterialLibrary;



// fonctions utiles :
function DossierSpecial(VariableIdentifiantLeButDuGet: integer): string;
function DossierMesDocs: string;
function DossierAppData: string;
function GetTempDossier: String;

function Sup(s1, s2: single): single;
function Inf(s1, s2: single): single;

function copieFichier(source:string;cible:string;AnnuleSiExiste:Boolean):boolean;


// Terrain :
function CalculeHauteur(const x, y: Single; var z: Single; Picture: TPicture): boolean;
procedure CalculeDecalageVerticalTerrain(Picture: TPicture);

// Collision, etc... :
procedure MyCollisionManagerCollision(Sender: TObject;
                                      object1, object2: TGLBaseSceneObject);
procedure MettreEnPlaceTag(Depart: TGLBaseSceneObject; NewTag: integer);
procedure MettreEnPlaceCollisionsEx(Depart: TGLBaseSceneObject);
procedure MettreEnPlaceCollisions(Depart: TGLBaseSceneObject);
procedure CalculeEtat;
procedure PlaceEncadrement(Picture: TPicture);
procedure DecaleEncadrement(coeff: single);
procedure RePlaceEncadrement;
procedure CalculePlateForme;
procedure TrouveCollisions(var ObstacleTag: integer; var Texte: string; Details: boolean);
function TestCollision(Obj1, Obj2: TGLBaseSceneObject;
                             var p: TVector): boolean;
procedure PlaceCamera(XRef, ZRef, dmini, dmaxi: single;
                      GLCamera: TGLCamera;
                      Picture: TPicture);
procedure PlaceCameraTerrain(XRef, ZRef, dmini, dmaxi: single;
                             GLCamera: TGLCamera;
                             GLTerrainRenderer: TGLTerrainRenderer);

// Manipulation des fichiers :
function AjouteObjet(World: TGLDummyCube;
                     const FileName: String;
                     GLBaseSceneObject: TGLBaseSceneObject): TGLDummyCube;
procedure OuvreFichier(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                       IsMonde: boolean;
                       const FileName: String;
                       GLBaseSceneObject: TGLBaseSceneObject;
                       ObjAnimations: TObjAnimations;
                       AvecPBar: boolean);
procedure OuvreFichierEx(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                         IsMonde: boolean;
                         const FileName: String;
                         GLBaseSceneObject: TGLBaseSceneObject;
                         ObjAnimations: TObjAnimations);
procedure OuvreFichier1(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                        IsMonde: boolean;
                        const FileName: String;
                        GLBaseSceneObject: TGLBaseSceneObject;
                        ObjAnimations: TObjAnimations);
procedure OuvreFichier2(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                        IsMonde: boolean;
                        const FileName: String;
                        GLBaseSceneObject: TGLBaseSceneObject;
                        ObjAnimations: TObjAnimations;
                        AvecPBar: boolean);
procedure ListerFichiers(World: TGLBaseSceneObject; CheminRef: string);
procedure SauveFichier(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                       IsMonde: boolean;
                       const FileName : string;
                       ObjAnimations: TObjAnimations);
procedure SauveFichierEx(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                         IsMonde: boolean;
                         const FileName : string;
                         ObjAnimations: TObjAnimations);
procedure ExportMesh(World: TGLDummyCube; var FreeForm: TGLFreeForm; const FileName : string);
procedure ExportPOV(World: TGLDummyCube;// Picture: TPicture; Sol: TGLSceneObject;
                    GLCamera: TGLCamera; GLLightSource: TGLLightSource; CouleurFond: TColor;
                     IsMonde: boolean;
                     const FileName : string//;
                     //ObjAnimations: TObjAnimations
                     );
procedure ExportVRML(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                     IsMonde: boolean;
                     const FileName : string;
                     ObjAnimations: TObjAnimations);
procedure ChargeObjetFreeForm(GLBaseSceneObject: TGLBaseSceneObject);
procedure CreeNomUnique(World: TGLBaseSceneObject;
                        Objet: TComponent; Nom: string);
procedure VerifierNoms(World: TGLBaseSceneObject);
function ComponentToString(Component: TComponent): string;
function StringToComponent(Value: string): TComponent;
function Vector2String(Vector: TVector): string;
function String2Vector(MyString: string): TVector;

// Divers :
procedure SupprimerLignesVides(var StringList: TStringList);
procedure AfficheListe(Strings: TStrings);
procedure AfficheMemoryStream(Stream: TStream);
procedure ChangeCouleur(World: TGLBaseSceneObject;
                        ColorEx, ColorNew: TColor);
procedure ScaleAll(World: TGLBaseSceneObject; ScaleValue: single);


implementation


/////////////////////////////////////////////////
/////////////////////////////////////////////////
//         fonctions utiles
/////////////////////////////////////////////////
/////////////////////////////////////////////////

function DossierSpecial(VariableIdentifiantLeButDuGet: integer): string;
var
  IdList: PITEMIDLIST;
  Dossier: array[0..MAX_PATH] of Char;
begin
  if SHGetSpecialFolderLocation(0,
                                VariableIdentifiantLeButDuGet,
                                IdList) = NOERROR
    then begin
      SHGetPathFromIDList(IdList, Dossier);// pour rcuprer le dossier  partir de IdList
      result:= String(Dossier);
      end
    else result:= '';
end;

function DossierMesDocs: string;
begin
  Result:= DossierSpecial(CSIDL_PERSONAL);
end;

function DossierAppData: string;
begin
  Result:= DossierSpecial(CSIDL_APPDATA);
end;

function GetTempDossier: String;
{-----------------------------------------------------------------------------------}
{renvoie le dossier "temporaire de Windows"                                         }
{ cette fonction renvoie :le dossier temporaire en fonction des critres suivants:  }
{1.	le chemin spcifi par la variable d'environement TMP                       }
{2.	le chemin spcifi par la variable d'environement TEMP  si TMP non dfini   }
{3.	le dossier courant si aucune des deux variables TMP et TEMP ne sont dfinies}
{-----------------------------------------------------------------------------------}
var
  Dossier: array[0..MAX_PATH] of Char;
begin
  result:='';
  if GetTempPath(SizeOf(Dossier), Dossier)<>0 then Result := StrPas(Dossier);
end;

function Sup(s1, s2: single): single;
begin
  if s1 < s2
    then Result:= s2
    else Result:= s1;
end;

function Inf(s1, s2: single): single;
begin
  if s1 > s2
    then Result:= s2
    else Result:= s1;
end;

function copieFichier(source:string;cible:string;AnnuleSiExiste:Boolean):boolean;
{------------------------------------------------------------------------------}
{copie le fichier source vers le fichier cible. si le fichier cible existe dj}
{ la copie ne se fait que si AnnuleSiFichier est  true                        }
{------------------------------------------------------------------------------}
var NomSource,NomCible:array[0..255]of Char;
begin
  StrPCopy(NomSource,Source);
  StrPCopy(NomCible,Cible);
  result:=CopyFile(NomSource,NomCible,AnnuleSiExiste);
end;
//StrPCopy(NomSource,DossierDansTemp);
//DeleteFile(NomSource);


/////////////////////////////////////////////////
/////////////////////////////////////////////////
//                Terrain
/////////////////////////////////////////////////
/////////////////////////////////////////////////
function CalculeHauteur(const x, y: Single; var z: Single; Picture: TPicture): boolean;
var
  xi, yi: integer;
  zz: Single;
begin
  if Picture = nil then begin
    z:= 0;
    Result:= True;
    exit;
    end;
  if (abs(x) > DemiLargeur)
    or (abs(y) > DemiProfondeur) then begin
      Result:= False;
      exit;
      end;
  xi:= round(((x + DemiLargeur) / Largeur) * (Picture.Width - 1));
  yi:= round(((y + DemiProfondeur) / Profondeur) * (Picture.Height - 1));
  zz:= (Picture.Bitmap.Canvas.Pixels[xi, yi]) and $000000FF;
  z:= zz * ExaggerationVerticale - DecalageVerticalTerrain;
  Result:= zz <> 255;
end;

procedure CalculeDecalageVerticalTerrain(Picture: TPicture);
var
  xi, yi: integer;
  zz: Single;
begin
  xi:= round((DemiLargeur / Largeur) * (Picture.Width - 1));
  yi:= round((DemiProfondeur / Profondeur) * (Picture.Height - 1));
  zz:= (Picture.Bitmap.Canvas.Pixels[xi, yi]) and $000000FF;
  DecalageVerticalTerrain:= zz * ExaggerationVerticale;
end;


/////////////////////////////////////////////////
/////////////////////////////////////////////////
//         Collision, etc...
/////////////////////////////////////////////////
/////////////////////////////////////////////////
procedure MettreEnPlaceTag(Depart: TGLBaseSceneObject; NewTag: integer);
var
  i: Integer;
  Temp: TGLBaseSceneObject;
  Objet3ds: TObjet3ds;
begin
  if Depart is TObjet3ds
    then begin
      Objet3ds:= TObjet3ds(Depart);
      Temp:= Objet3ds.Encadrement;
      Temp.Tag:= NewTag;
      MettreEnPlaceTag(Temp, NewTag);
      end
    else begin
      Depart.Tag:= NewTag;
      if Depart.Count > 0 then
        for i:= Depart.Count - 1 downto 0 do begin
          Temp:= Depart.Children[i];
          MettreEnPlaceTag(Temp, NewTag);
          end;
      end;
end;

procedure MettreEnPlaceCollisionsEx(Depart: TGLBaseSceneObject);
  //Sous procedure rcursive :
  procedure CreeCollision(GLBaseSceneObject: TGLBaseSceneObject);
  var
    i: Integer;
    Temp: TGLBaseSceneObject;
    MyFreeForm: TMyFreeForm;
  begin
  if GLBaseSceneObject is TMyFreeForm
    then begin
      MyFreeForm:= TMyFreeForm(GLBaseSceneObject);
      if MyFreeForm.Tag <> 0 then begin
        Obstacles.add(MyFreeForm);
        //**
        MyFreeForm.BuildOctree;
        with GetOrCreateCollision(MyFreeForm) do begin
          Manager:= MyCollisionManager;
          GroupIndex:= Obstacles.Count;
          BoundingMode:= cbmFaces;
          end;
        //**

        end;
      end
    else begin
      if GLBaseSceneObject.Tag <> 0 then begin
        Obstacles.add(GLBaseSceneObject);
        //**
        if not(GLBaseSceneObject is TGLDummyCube) then
          with GetOrCreateCollision(GLBaseSceneObject) do begin
            Manager:= MyCollisionManager;
            GroupIndex:= Obstacles.Count;
            BoundingMode:= cbmCube;
            end;
        //**
        end;
      if GLBaseSceneObject.Count > 0 then
        for i:= GLBaseSceneObject.Count - 1 downto 0 do begin
          Temp:= GLBaseSceneObject.Children[i];
          CreeCollision(Temp);
          end;
      end;
  end;
//La procedure :
begin
  Obstacles.clear;
  CreeCollision(Depart);
end;

procedure MettreEnPlaceCollisions(Depart: TGLBaseSceneObject);
var
  NewGroupIndex: integer;

    //Sous procedure rcursive :
    procedure CreeCollision(GLBaseSceneObject: TGLBaseSceneObject);
    var
      i: Integer;
      Temp: TGLBaseSceneObject;
      MyFreeForm: TMyFreeForm;
    begin
      NewGroupIndex:= NewGroupIndex + 1;
      if GLBaseSceneObject is TMyFreeForm
        then begin
          MyFreeForm:= TMyFreeForm(GLBaseSceneObject);
          if MyFreeForm.Tag <> 0 then begin
            MyFreeForm.BuildOctree;
            with GetOrCreateCollision(MyFreeForm) do begin
              Manager:= MyCollisionManager;
              GroupIndex:= NewGroupIndex;
              BoundingMode:= cbmFaces;
              end;
            end;
          end
        else begin
          if GLBaseSceneObject.Tag <> 0 then begin
            if not(GLBaseSceneObject is TGLDummyCube) then
              with GetOrCreateCollision(GLBaseSceneObject) do begin
                Manager:= MyCollisionManager;
                GroupIndex:= NewGroupIndex;
                BoundingMode:= cbmCube;
                end;
            end;
          if GLBaseSceneObject.Count > 0 then
            for i:= GLBaseSceneObject.Count - 1 downto 0 do begin
              Temp:= GLBaseSceneObject.Children[i];
              CreeCollision(Temp);
              end;
          end;
    end;
//La procedure :
begin
  NewGroupIndex:= 0;
  CreeCollision(Depart);
end;

procedure CalculeEtat;
begin
  if PlateForme = nil
    then begin
      if Saut > 0
        then Etat:= Etat_Tombe
        else Etat:= Etat_SurSol;
      end
    else Etat:= Etat_SurPlateForme;
end;

procedure PlaceEncadrement(Picture: TPicture);
var
  yy: single;
  Dedans: boolean;
begin
  Encadrement.Turn(Tourne);
  Encadrement.Move(Avance);
  PositionNew:= Encadrement.AbsolutePosition;
  if Picture = nil then exit;
  Dedans:= CalculeHauteur(PositionNew[0], PositionNew[2], yy, Picture);
  if Dedans = False
    then begin
      Deplacement:= False;
      PlaySound(PChar(SonCollision), 0, SND_ASYNC and SND_NOSTOP);
      end
    else begin
      PositionNew[1]:= yy + DecalageEncadrement + Saut;
      Encadrement.AbsolutePosition:= PositionNew;
      end;
end;

procedure DecaleEncadrement(coeff: single);
var
  d: single;
begin
  d:= DecalagePlateForme * coeff;
  Saut:= Saut + d;
  PositionNew[1]:= PositionNew[1] + d;
  Encadrement.AbsolutePosition:= PositionNew;
end;

procedure RePlaceEncadrement;
var
  aPosition, aDirection: TVector;
begin
  //aPosition:= VectorLerp(PositionEx, PositionNew, 2);

  //aPosition:= VectorCombine(PositionEx, PositionNew, 10, -9);

  aDirection:= VectorSubtract(PositionEx, PositionNew);
  //aDirection[1]:= 0;
  NormalizeVector(aDirection);
  //Encadrement.Direction.AsVector:= aDirection;

  ScaleVector(aDirection, 2 * VitesseAvanceActeur * fDelta * VitesseDeplacements);
  aPosition:= VectorAdd(PositionEx, aDirection);

  //aPosition:= PositionEx;

  Encadrement.AbsolutePosition:= aPosition;
end;

procedure CalculePlateForme;
var
  M, N, MN: TMatrix;
  d: single;

  function TestCollisionPlateForme: boolean;
  var
    p: TVector;
    q: TVector;
  begin
    Result:= False;
    p[0]:= 0; p[1]:= -0.5; p[2]:= 0; p[3]:= 1;
    q:= vectortransform(p, MN);
    if abs(q[0]) < 0.5 then
      if abs(q[1]) < 0.5 then
        if abs(q[2]) < 0.5 then begin
          Result:= True;
          exit;
          end;

    p[0]:= 0; p[1]:= -0.3; p[2]:= -0.5; p[3]:= 1;
    q:= vectortransform(p, MN);
    if abs(q[0]) < 0.5 then
      if abs(q[1]) < 0.5 then
        if abs(q[2]) < 0.5 then begin
          Result:= True;
          exit;
          end;
    p[0]:= 0; p[1]:= -0.3; p[2]:= 0.5; p[3]:= 1;
    q:= vectortransform(p, MN);
    if abs(q[0]) < 0.5 then
      if abs(q[1]) < 0.5 then
        if abs(q[2]) < 0.5 then begin
          Result:= True;
          exit;
          end;
  end;

begin
  //pas besoin si on saute :
  if KeyState[VK_SPACE] > 100 then begin
    PlateForme:= nil;
    Etat:= Etat_Tombe;
    exit;
    end;
  PositionNew:= Encadrement.AbsolutePosition;
  M:= PlateForme.InvAbsoluteMatrix;
  N:= Encadrement.AbsoluteMatrix;
  MN:= MatrixMultiply(N, M);

  if TestCollisionPlateForme
    then begin
      repeat
        DecaleEncadrement(1);
        N:= Encadrement.AbsoluteMatrix;
        MN:= MatrixMultiply(N, M);
        until TestCollisionPlateForme = False;
      DecaleEncadrement(-1);
      end
    else begin
      d:= 0;
      repeat
        d:= d + 1;
        DecaleEncadrement(-1);
        N:= Encadrement.AbsoluteMatrix;
        MN:= MatrixMultiply(N, M);
        until (TestCollisionPlateForme = True) or (Saut < 0);
      if Saut > 0
        then DecaleEncadrement(1)
        else begin
          DecaleEncadrement(d);
          PlateForme:= nil;
          Etat:= Etat_Tombe;
          end;
      end;
end;

procedure MyCollisionManagerCollision(Sender: TObject; object1,
  object2: TGLBaseSceneObject);
begin
  if TGLBCollision(object1.Behaviours.GetByClass(TGLBCollision)).GroupIndex = 0 then
    ObstaclesActuels.Add(object2)
  else if TGLBCollision(object2.Behaviours.GetByClass(TGLBCollision)).GroupIndex = 0 then
    ObstaclesActuels.Add(object1);
end;

procedure TrouveCollisions(var ObstacleTag: integer; var Texte: string; Details: boolean);
var
  i, j: integer;
  p: TVector;
  PlateFormeEx: TGLBaseSceneObject;
begin
  ObstacleTag:= -5;
  Texte:= '';
  if Deplacement = False then exit;

  CollisionDetected:= False;
  ObstaclesActuels.Clear;
  PlateFormeEx:= PlateForme;
  PlateForme:= nil;
  if MyCollisionManager <> nil then begin
    ObstacleActuel:= nil;
    MyCollisionManager.CheckCollisions;
    if ObstaclesActuels.Count < 1 then exit;

    for i:= 0 to ObstaclesActuels.Count - 1 do begin
      ObstacleActuel:= ObstaclesActuels[i];

      //cas d'un passage :
      if ObstacleActuel.Tag > 0 then begin
        CollisionDetected:= True;
        ObstacleTag:= ObstacleActuel.Tag;
        ObstacleActuel.free;
        PlaySound(PChar(SonPassage), 0, SND_ASYNC);
        exit;
        end;

      //cas d'un Repere :
      if ObstacleActuel is TRepere then begin
        Texte:= TRepere(ObstacleActuel).Texte;
        continue;
        end;

      //cas d'un Traversable :
      if ObstacleActuel.Tag = Tag_Traversable then continue;

      //cas d'un cassable :
      if ObstacleActuel.Tag = Tag_Cassable then begin
        ObstacleActuel.free;
        PlaySound(PChar(SonCassable), 0, SND_ASYNC);
        continue;
        end;


      //PlateFormeEx
      if ObstacleActuel = PlateFormeEx then begin
        Etat:= Etat_SurPlateForme;
        PlateForme:= ObstacleActuel;
        CalculePlateForme;
        continue;
        end;

      //cas d'un obstacle :
      if ObstacleActuel.Tag = Tag_Obstacle then begin
        if Details
          then TestCollision(Encadrement, ObstacleActuel, p)
          else p[1] := 0;
        if p[1] < 0
          //collision sur une plateforme :
          then begin
            Etat:= Etat_SurPlateForme;
            PlateForme:= ObstacleActuel;
            CalculePlateForme;
            continue;
            end
          //collision normale :
          else begin
            ObstacleTag:= ObstacleActuel.Tag;
            PlaySound(PChar(SonCollision), 0, SND_ASYNC and SND_NOSTOP);
            CollisionDetected:= True;
            continue;
            end;
        end;

      end;
    end;
end;

function TestCollision(Obj1, Obj2: TGLBaseSceneObject;
                             var p: TVector): boolean;

        function TestPoint(x, y, z, t: single;
                           var pp: TVector;
                           MN: TMatrix;
                           var Retour: boolean): boolean;
        var
          qq: TVector;
        begin
          Result:= False;
          pp[0]:= x; pp[1]:= y; pp[2]:= z; pp[3]:= t;
          qq:= vectortransform(pp, MN);
          if abs(qq[0]) < 0.5 then
            if abs(qq[1]) < 0.5 then
              if abs(qq[2]) < 0.5 then
                Result:= True;
          Retour:= Result;
        end;

var
  D1, D2, D: Double;
  p1, p2: TVector;
  M, N, MN: TMatrix;
begin
  Result:= False;
  //Un test pour viter trop de calculs :
  p1:= Obj1.AbsolutePosition;
  p2:= Obj2.AbsolutePosition;
  D:= VectorDistance(p1, p2);
  p1:= Obj1.AxisAlignedDimensions;
  D1:= VectorLength(p1);
  p2:= Obj2.AxisAlignedDimensions;
  D2:= VectorLength(p2);
  if D > (D1 + D2) then exit;
  {p est un point de l'Obj1.
  On calcule sa position q dans la base de l'Obj2}
  M:= Obj2.InvAbsoluteMatrix;
  N:= Obj1.AbsoluteMatrix;
  MN:= MatrixMultiply(N, M);
  p[1]:= 0;
  
  //Les centres des faces sauf celle du bas :
  if TestPoint(-0.5,   0,    0, 1, p, MN, Result) then exit;
  if TestPoint( 0.5,   0,    0, 1, p, MN, Result) then exit;
  if TestPoint(   0, 0.5,    0, 1, p, MN, Result) then exit;
  if TestPoint(   0,   0, -0.5, 1, p, MN, Result) then exit;
  if TestPoint(   0,   0,  0.5, 1, p, MN, Result) then exit;
  //Les autres "quasi-sommets" :
  if TestPoint(-0.4,  0.4, -0.4, 1, p, MN, Result) then exit;
  if TestPoint(-0.4,  0.4,  0.4, 1, p, MN, Result) then exit;
  if TestPoint( 0.4,  0.4, -0.4, 1, p, MN, Result) then exit;
  if TestPoint( 0.4,  0.4,  0.4, 1, p, MN, Result) then exit;

  //Le centre de la face du dessous (utile pour plateformes) :
  if TestPoint(0, -0.5, 0, 1, p, MN, Result) then exit;
  //Les "quasi-centres" du bas (utiles pour plateformes) :
  if TestPoint(   0, -0.3, -0.5, 1, p, MN, Result) then exit;
  if TestPoint(   0, -0.3,  0.5, 1, p, MN, Result) then exit;
end;

procedure PlaceCamera(XRef, ZRef, dmini, dmaxi: single;
                      GLCamera: TGLCamera;
                      Picture: TPicture);
var
  d, t, xx, yy, zz: single;
begin
  xx:= GLCamera.Position.X; zz:= GLCamera.Position.Z;
  d:= sqrt(sqr(xx - XRef) + sqr(zz - ZRef));
  if d < dmini then t:= dmini / d
               else if d > dmaxi then t:= dmaxi / d
                                 else t:= 1;
  if t = 1
    then begin
      yy:= HauteurCamera;
      if Picture <> nil then begin
        if CalculeHauteur(xx, zz, yy, Picture) then yy:= yy + HauteurCamera;
        yy:= Sup(yy, PositionNew[1]);
        end;
      GLCamera.Position.Y:= yy;
      end
    else begin
      xx:= t * xx + (1 - t) * XRef;
      zz:= t * zz + (1 - t) * ZRef;
      yy:= HauteurCamera;
      if Picture <> nil then
        if CalculeHauteur(xx, zz, yy, Picture) then yy:= yy + HauteurCamera;
      yy:= Sup(yy, PositionNew[1]);
      with GLCamera.Position do begin
        X:= xx; Z:= zz; Y:= yy;
        end;
      end;
end;

procedure PlaceCameraTerrain(XRef, ZRef, dmini, dmaxi: single;
                             GLCamera: TGLCamera;
                             GLTerrainRenderer: TGLTerrainRenderer);
var
  d, t, xx, yy, zz: single;
begin
  xx:= GLCamera.Position.X; zz:= GLCamera.Position.Z;
  d:= sqrt(sqr(xx - XRef) + sqr(zz - ZRef));
  d:= Sup(d, dmini / 2);
  if d < dmini then t:= dmini / d
               else if d > dmaxi then t:= dmaxi / d
                                 else t:= 1;
  if t = 1
    then begin
      yy:= GLTerrainRenderer.InterpolatedHeight(GLCamera.Position.AsVector) + HauteurCamera;
      yy:= Sup(yy, PositionNew[1]);
      GLCamera.Position.Y:= yy;
      end
    else begin
      xx:= t * xx + (1 - t) * XRef;
      zz:= t * zz + (1 - t) * ZRef;
      yy:= GLTerrainRenderer.InterpolatedHeight(GLCamera.Position.AsVector) + HauteurCamera;
      yy:= Sup(yy, PositionNew[1]);
      with GLCamera.Position do begin
        X:= xx; Z:= zz; Y:= yy;
        end;
      end;
end;

/////////////////////////////////////////////////
/////////////////////////////////////////////////
//         Manipulation des fichiers
/////////////////////////////////////////////////
/////////////////////////////////////////////////

function AjouteObjet(World: TGLDummyCube;
                     const FileName: String;
                     GLBaseSceneObject: TGLBaseSceneObject): TGLDummyCube;
  //Sous procedures :
  //pour compatibilit :
  procedure RecreeObjet3dsEx(GLBaseSceneObject: TGLBaseSceneObject;
                             var LF3ds: TStringList);
  var
    i: Integer;
    Temp: TGLBaseSceneObject;
    Objet3ds: TObjet3ds;
    Remplacement: TGLDummyCube;
  begin
    if GLBaseSceneObject.Count > 0 then
      for i:= GLBaseSceneObject.Count - 1 downto 0 do begin
        Temp:= GLBaseSceneObject.Children[i];
        RecreeObjet3dsEx(Temp, LF3ds);
        end;
    if GLBaseSceneObject is TGLDummyCube then
      if GLBaseSceneObject.Tag < -99 then begin
        Remplacement:= TGLDummyCube(GLBaseSceneObject);
        Objet3ds:= TObjet3ds(Remplacement.parent.AddNewChild(TObjet3ds));
        with Objet3ds do begin
          Encadrement.Tag:= round(Remplacement.TagFloat);
          Position:= Remplacement.Position;
          Direction:= Remplacement.Direction;
          Up:= Remplacement.Up;
          Scale:= Remplacement.Scale;
          TurnAngle:= Remplacement.TurnAngle;
          RollAngle:= Remplacement.RollAngle;
          PitchAngle:= Remplacement.PitchAngle;
          LoadFromFile(LF3ds[-GLBaseSceneObject.Tag - 100]);
          end;
        Remplacement.Free;
        end;
  end;

  procedure EffaceNoms(GLBaseSceneObject: TGLBaseSceneObject);
  var
    j: Integer;
    Temp: TGLBaseSceneObject;
  begin
    if GLBaseSceneObject <> World then GLBaseSceneObject.Name:= '';
    if GLBaseSceneObject.Count > 0 then
      for j:= GLBaseSceneObject.Count - 1 downto 0 do begin
        Temp:= GLBaseSceneObject.Children[j];
        EffaceNoms(Temp);
        end;
  end;

//la procedure :
var
  FileStream: TFileStream;
  i, j: integer;
  MemoryStream: TMemoryStream;
  s: Longint;
  a: TNomFichier;
  Component: TComponent;
  ListeFichiers3ds: TStringList;
  DummyCube: TGLDummyCube;
  ScreenCursorEx: TCursor;
begin
  ScreenCursorEx:= Screen.Cursor;
  Screen.Cursor:= crHourGlass;
  FileStream:= TFileStream.Create(FileName, fmOpenRead);
  try
    DummyCube:= TGLDummyCube(GLBaseSceneObject.AddNewChild(TGLDummyCube));
    ChDir(ExtractFilePath(FileName));
    //Nombre d'objets : :
    FileStream.Read(i, SizeOf(i));
    //Les objets :
    if i > 0 then
      for j:= 0 to i - 1 do begin
        MemoryStream:= TMemoryStream.Create;
        try
          FileStream.Read(s, SizeOf(s));
          MemoryStream.CopyFrom(FileStream, s);
          MemoryStream.Position:= 0;
          try
            Component:= MemoryStream.ReadComponent(nil);
          except
            //on EComponentError do begin
              //EffaceNoms(World);
              //MemoryStream.Position:= 0;
              //Component:= MemoryStream.ReadComponent(nil);
              //end;
            end;
          CreeNomUnique(World, Component, Component.Name);
          DummyCube.AddChild(TGLBaseSceneObject(Component));
          Application.ProcessMessages;
        finally
          MemoryStream.Free
          end;
        end;
    //Les fichiers 3ds (compatibilit):
    FileStream.Read(i, SizeOf(i));
    if i > 0
      then begin
        ListeFichiers3ds:= TStringList.create;
        try
          for j:= 0 to i - 1 do begin
            FileStream.Read(a, SizeOf(a));
            ListeFichiers3ds.add(a);
            end;
          RecreeObjet3dsEx(DummyCube, ListeFichiers3ds);
        finally
          ListeFichiers3ds.free;
          end;
        end
      else ChargeObjetFreeForm(DummyCube);
  finally
    FileStream.Free;
    Screen.Cursor:= ScreenCursorEx;
    Result:= DummyCube;
    end;
end;

procedure OuvreFichier(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                       IsMonde: boolean;
                       const FileName: String;
                       GLBaseSceneObject: TGLBaseSceneObject;
                       ObjAnimations: TObjAnimations;
                       AvecPBar: boolean);
var
  FileStream: TFileStream;
  i: integer;
  VersionFonction: integer;
  AFileName: string;
  SaveSeparator: Char;
  ScreenCursorEx: TCursor;
begin
  //SaveSeparator:= DecimalSeparator;
  //DecimalSeparator:= '.';
  ScreenCursorEx:= Screen.Cursor;
  Screen.Cursor:= crHourGlass;

  if AvecPBar then begin
    Application.CreateForm(TFPBar, FPBar);
    if GmXMLLangue <> nil
      then FPBar.Label1.caption:= GmXMLLangue.GetStringByPath('Divers\Open')
      else FPBar.Label1.caption:= '';
    FPBar.ProgressBar1.Position:= 0;
    FPBar.Visible:= True;
    //Application.ProcessMessages;
    end;

  try
    //On dtermine la version :
    VersionFonction:= 2;
    FileStream:= TFileStream.Create(FileName, fmOpenRead);
    try
      FileStream.Read(i, SizeOf(i));
      if i < 0 then VersionFonction:= 1
      else if i < 1000 then VersionFonction:= 0;
    finally
      FileStream.Free;
      end;

    if VersionFonction = 0 then OuvreFichierEx(World, Picture, Sol, IsMonde, FileName, GLBaseSceneObject, ObjAnimations)
    else if VersionFonction = 1 then OuvreFichier1(World, Picture, Sol, IsMonde, FileName, GLBaseSceneObject, ObjAnimations)
    else OuvreFichier2(World, Picture, Sol, IsMonde, FileName, GLBaseSceneObject, ObjAnimations, AvecPBar);
  finally
    //DecimalSeparator:= SaveSeparator;
    if AvecPBar then begin
      if GmXMLLangue <> nil
        then FPBar.Label1.caption:= GmXMLLangue.GetStringByPath('Divers\End')
        else FPBar.Label1.caption:= '';
      FPBar.ProgressBar1.Position:= 100;
      FPBar.Visible:= False;
      FPBar.free;
      end;
    Screen.Cursor:= ScreenCursorEx;
    end;
end;

procedure OuvreFichierEx(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                         IsMonde: boolean;
                         const FileName: String;
                         GLBaseSceneObject: TGLBaseSceneObject;
                         ObjAnimations: TObjAnimations);

  //Sous procedures :
  //pour compatibilit :
  procedure RecreeObjet3dsEx(GLBaseSceneObject: TGLBaseSceneObject;
                             var LF3ds: TStringList);
  var
    i: Integer;
    Temp: TGLBaseSceneObject;
    Objet3ds: TObjet3ds;
    Remplacement: TGLDummyCube;
  begin
    if GLBaseSceneObject.Count > 0 then
      for i:= GLBaseSceneObject.Count - 1 downto 0 do begin
        Temp:= GLBaseSceneObject.Children[i];
        RecreeObjet3dsEx(Temp, LF3ds);
        end;
    if GLBaseSceneObject is TGLDummyCube then
      if GLBaseSceneObject.Tag < -99 then begin
        Remplacement:= TGLDummyCube(GLBaseSceneObject);
        Objet3ds:= TObjet3ds(Remplacement.parent.AddNewChild(TObjet3ds));
        with Objet3ds do begin
          Encadrement.Tag:= round(Remplacement.TagFloat);
          Position:= Remplacement.Position;
          Direction:= Remplacement.Direction;
          Up:= Remplacement.Up;
          Scale:= Remplacement.Scale;
          TurnAngle:= Remplacement.TurnAngle;
          RollAngle:= Remplacement.RollAngle;
          PitchAngle:= Remplacement.PitchAngle;
          LoadFromFile(LF3ds[-GLBaseSceneObject.Tag - 100]);
          end;
        Remplacement.Free;
        end;
  end;

  procedure EffaceNoms(GLBaseSceneObject: TGLBaseSceneObject);
  var
    j: Integer;
    Temp: TGLBaseSceneObject;
  begin
    if GLBaseSceneObject <> World then GLBaseSceneObject.Name:= '';
    if GLBaseSceneObject.Count > 0 then
      for j:= GLBaseSceneObject.Count - 1 downto 0 do begin
        Temp:= GLBaseSceneObject.Children[j];
        EffaceNoms(Temp);
        end;
  end;

//la procedure :
var
  FileStream: TFileStream;
  i, j: integer;
  MemoryStream: TMemoryStream;
  s: Longint;
  a: TNomFichier;
  Component: TComponent;
  Vector: TVector;
  ListeFichiers3ds: TStringList;
begin
if Debug then showmessage('OuvreFichierEx');
  FileStream:= TFileStream.Create(FileName, fmOpenRead);
  try
    ChDir(ExtractFilePath(FileName));
    //Nombre d'objets :
    FileStream.Read(i, SizeOf(i));
    //Les objets :
    if i > 0 then
      for j:= 0 to i - 1 do begin
        MemoryStream:= TMemoryStream.Create;
        try
          FileStream.Read(s, SizeOf(s));
          MemoryStream.CopyFrom(FileStream, s);
          MemoryStream.Position:= 0;
          try
            Component:= MemoryStream.ReadComponent(nil);
          except
            end;
          CreeNomUnique(World, Component, Component.Name);
          GLBaseSceneObject.AddChild(TGLBaseSceneObject(Component));
          Application.ProcessMessages;
        finally
          MemoryStream.Free
          end;
        end;
    //Les fichiers 3ds (compatibilit : "0" maintenant):
    FileStream.Read(i, SizeOf(i));
    if i > 0
      //Si ancien format :
      then begin
        ListeFichiers3ds:= TStringList.create;
        try
          for j:= 0 to i - 1 do begin
            FileStream.Read(a, SizeOf(a));
            ListeFichiers3ds.add(a);
            end;
          RecreeObjet3dsEx(GLBaseSceneObject, ListeFichiers3ds);
        finally
          ListeFichiers3ds.free;
          end;
        ChargeObjetFreeForm(GLBaseSceneObject);  
        end
      //Si format actuel :
      else ChargeObjetFreeForm(GLBaseSceneObject);
    //Pour un Monde :
    if IsMonde then begin
      //Le Terrain :
      FileStream.Read(a, SizeOf(a));
      if FileExists(a)
        then begin
          FichierTerrain:= a;
          if Sol is TGLHeightField
            then begin
              Picture.LoadFromFile(FichierTerrain);
              CalculeDecalageVerticalTerrain(Picture);
              end;
          end
        else showmessage(Texte_PbFichier + #13 + a);
      FileStream.Read(Vector, SizeOf(TVector));
      //if Sol is TGLHeightField then begin
        Sol.Material.Texture.disabled:= False;
        Sol.Material.FrontProperties.Ambient.Color:= clrGray20;
        Sol.Material.FrontProperties.Diffuse.Color:= Vector;
        Sol.Material.FrontProperties.Emission.Color:= clrBlack;
        //Sol.StructureChanged;
        MakeVector(Vector, 1, 1, 2/16);
        Sol.Scale.AsVector:= Vector;
        //end;
      end;
    //Si animations :
    if ObjAnimations <> nil then
      if FileStream.Size - FileStream.Position > 0 then
        ObjAnimations.LoadFromStream(FileStream);
  finally
    FileStream.Free;
    end;
end;

procedure OuvreFichier1(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                        IsMonde: boolean;
                        const FileName: String;
                        GLBaseSceneObject: TGLBaseSceneObject;
                        ObjAnimations: TObjAnimations);
var
  FileStream: TFileStream;
  i, j: integer;
  MemoryStream: TMemoryStream;
  s: Longint;
  a: TNomFichier;
  Component: TComponent;
  Vector: TVector;
begin
if Debug then showmessage('OuvreFichier1');
  FileStream:= TFileStream.Create(FileName, fmOpenRead);
  try
    ChDir(ExtractFilePath(FileName));
    //Version :
    FileStream.Read(i, SizeOf(i));
    //Nombre d'objets :
    FileStream.Read(i, SizeOf(i));
    //Les objets :
    if i > 0 then
      for j:= 0 to i - 1 do begin
        MemoryStream:= TMemoryStream.Create;
        try
          FileStream.Read(s, SizeOf(s));
          MemoryStream.CopyFrom(FileStream, s);
          MemoryStream.Position:= 0;
          try
            Component:= MemoryStream.ReadComponent(nil);
          except
            end;
          CreeNomUnique(World, Component, Component.Name);
          GLBaseSceneObject.AddChild(TGLBaseSceneObject(Component));
          Application.ProcessMessages;
        finally
          MemoryStream.Free
          end;
        end;
    //Les fichiers 3ds (compatibilit : "0" maintenant):
    FileStream.Read(i, SizeOf(i));
    ChargeObjetFreeForm(GLBaseSceneObject);
    //Pour un Monde :
    if IsMonde then begin
      //Le Terrain :
      FileStream.Read(a, SizeOf(a));
      if FileExists(a)
        then begin
          FichierTerrain:= a;
          if Sol is TGLHeightField
            then begin
              Picture.LoadFromFile(FichierTerrain);
              CalculeDecalageVerticalTerrain(Picture);
              end;
          end
        else showmessage(Texte_PbFichier + #13 + a);
      FileStream.Read(Vector, SizeOf(TVector));
      //if Sol is TGLHeightField then begin
        Sol.Material.Texture.disabled:= False;
        Sol.Material.FrontProperties.Ambient.Color:= clrGray20;
        Sol.Material.FrontProperties.Diffuse.Color:= Vector;
        Sol.Material.FrontProperties.Emission.Color:= clrBlack;
        Sol.StructureChanged;
        MakeVector(Vector, 2, 2, 1/16);
        Sol.Scale.AsVector:= Vector;
        //end;
      end;
    //Si animations :
    if ObjAnimations <> nil then
      if FileStream.Size - FileStream.Position > 0 then
        ObjAnimations.LoadFromStream(FileStream);
  finally
    FileStream.Free;
    end;
end;

procedure OuvreFichier2(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                        IsMonde: boolean;
                        const FileName: String;
                        GLBaseSceneObject: TGLBaseSceneObject;
                        ObjAnimations: TObjAnimations;
                        AvecPBar: boolean);
var
  i, j: integer;
  MemoryStream: TMemoryStream;
  s: Longint;
  a: TNomFichier;
  Component: TComponent;
  Vector: TVector;
  VersionFichier: string;
  FileXML: TGmXML;
  GmXmlNode: TGmXmlNode;
  ss1: string;
  XML: TStringStream;
begin
if Debug then showmessage('OuvreFichier2');
  FileXML:= TGmXml.create(application);
  try
    ChDir(ExtractFilePath(FileName));

    if AvecPBar then begin
      if GmXMLLangue <> nil
        then FPBar.Label1.caption:= GmXMLLangue.GetStringByPath('Divers\File')
        else FPBar.Label1.caption:= '';
      FPBar.ProgressBar1.Position:= 30;
      end;

    FileXML.LoadFromFile(FileName);
    VersionFichier:= FileXML.GetStringByPath('Version');

    //MyMaterialLibrary :
 {   GmXmlNode:= FileXML.GetNodeByName('MaterialLibrary');
        ss1:= XML_SPECIFICATION + #13#10;
        FileXML.NodeToString(ss1, GmXmlNode.Children.Node[0]);
        XML:= TStringStream.Create(ss1);
        MemoryStream:= TMemoryStream.Create;
        try
          ObjectXML2Binary(XML, MemoryStream);
          Application.ProcessMessages;
          MemoryStream.Position:= 0;
          try
            Component:= MemoryStream.ReadComponent(nil);
            //MyMaterialLibrary..LoadFromStream(MemoryStream);
          except
            end;
        finally
          MemoryStream.Free;
          XML.Free;
          end;
     }





    //Les objets :
    if AvecPBar then begin
      if GmXMLLangue <> nil
        then FPBar.Label1.caption:= GmXMLLangue.GetStringByPath('Divers\Objects')
        else FPBar.Label1.caption:= '';
      FPBar.ProgressBar1.Position:= 60;
      end;
    i:= strtoint(FileXML.GetStringByPath('NbObjets'));
    GmXmlNode:= FileXML.GetNodeByName('Objets');
    if i > 0 then
      for j:= 0 to i - 1 do begin
        ss1:= XML_SPECIFICATION + #13#10;
        FileXML.NodeToString(ss1, GmXmlNode.Children.Node[j]);

        XML:= TStringStream.Create(ss1);
        MemoryStream:= TMemoryStream.Create;
        try
          ObjectXML2Binary(XML, MemoryStream);
          MemoryStream.Position:= 0;
          try
            Component:= MemoryStream.ReadComponent(nil);
          except
            end;
          CreeNomUnique(World, Component, Component.Name);
          GLBaseSceneObject.AddChild(TGLBaseSceneObject(Component));
        finally
          MemoryStream.Free;
          XML.Free;
          end;
        end;
    ChargeObjetFreeForm(GLBaseSceneObject);

    //Pour un Monde :
    if IsMonde then begin
      //Le Terrain :
      a:= FileXML.GetStringByPath('Terrain\NomFichier');
      if FileExists(a)
        then begin
          FichierTerrain:= a;
          if Sol is TGLHeightField
            then begin
              Picture.LoadFromFile(FichierTerrain);
              CalculeDecalageVerticalTerrain(Picture);
              end;
          end
        else showmessage(Texte_PbFichier + #13 + a);
      a:= FileXML.GetStringByPath('Terrain\Couleur');
      Vector:= String2Vector(a);
      //if YAUneCouleur then begin
        Sol.Material.Texture.disabled:= False;
        Sol.Material.FrontProperties.Ambient.Color:= clrGray20;
        Sol.Material.FrontProperties.Diffuse.Color:= Vector;
        Sol.Material.FrontProperties.Emission.Color:= clrBlack;
        Sol.StructureChanged;
        //end;

      //Le Ciel :
      try a:= FileXML.GetStringByPath('Ciel\Genre') except end;
      if a = ''
        then i:= 1
        else i:= strtoint(a);
      if i < 1 then i:= 1;
      GenreCiel:= i;
      end;

  a:= ChangeFileExt(FileName, '.gll');
  if FileExists(a) then begin
    MyMaterialLibrary.Materials.Clear;
    MyMaterialLibrary.LoadFromFile(a);
    end;

    //Si animations :
    if AvecPBar then begin
      if GmXMLLangue <> nil
        then FPBar.Label1.caption:= GmXMLLangue.GetStringByPath('Divers\Animations')
        else FPBar.Label1.caption:= '';
      FPBar.ProgressBar1.Position:= 90;
      end;
    if ObjAnimations <> nil then
      ObjAnimations.LoadFromXML(FileXML);

  finally
    FileXML.Free;
    end;
end;






procedure ListerFichiers(World: TGLBaseSceneObject; CheminRef: string);

  procedure Recursion(GLBaseSceneObject: TGLBaseSceneObject);
  var
    j: Integer;
    Temp: TGLBaseSceneObject;
    a: string;
  begin
    if GLBaseSceneObject is TMyFreeForm then begin
      a:= TMyFreeForm(GLBaseSceneObject).NomFichierComplet;
      CopieFichier(a, CheminRef + ExtractFileName(a), True);
      a:= ChangeFileExt(a, '.gll');
      CopieFichier(a, CheminRef + ExtractFileName(a), True);
      end;

    if GLBaseSceneObject.Count > 0 then
      for j:= GLBaseSceneObject.Count - 1 downto 0 do begin
        Temp:= GLBaseSceneObject.Children[j];
        Recursion(Temp);
        end;
  end;

begin
  //Les noms doivent tre uniques :
  Recursion(World);
end;



procedure SauveFichier(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                       IsMonde: boolean;
                       const FileName : string;
                       ObjAnimations: TObjAnimations);

var
  MemoryStream: TMemoryStream;
  i: integer;
  s: Longint;
  a: TNomFichier;
  CheminRef: string;
  ListeObjets: TList;

  FileXML: TGmXML;
  //SaveSeparator: Char;
  ScreenCursorEx: TCursor;
begin
  //SaveSeparator:= DecimalSeparator;
  //DecimalSeparator:= '.';
  ScreenCursorEx:= Screen.Cursor;
  Screen.Cursor:= crHourGlass;
  CheminRef:= ExtractFilePath(FileName);
  ListerFichiers(World, CheminRef);

  ListeObjets:= TList.create;
  FileXML:= TGmXml.create(application);
  try
    FileXML.Nodes.AddOpenTag('FichierEdob3D');
    FileXML.Nodes.AddOpenTag('Version').AsString:= AppVersion; FileXML.Nodes.AddCloseTag;

    //On met les objets dans ListeObjets :
    if World.Count > 0 then
      for i:= 0 to World.Count - 1 do
        ListeObjets.add(World.Children[i]);
    //Nombre d'objets :
    i:= ListeObjets.count;
    FileXML.Nodes.AddOpenTag('NbObjets').AsInteger:= i; FileXML.Nodes.AddCloseTag;

    //MyMaterialLibrary :
    FileXML.Nodes.AddOpenTag('MaterialLibrary');
    MemoryStream:= TMemoryStream.Create;
    try
      MemoryStream.WriteComponent(TComponent(MyMaterialLibrary));
      MemoryStream.Position:= 0;
      ObjectBinary2GmXML(MemoryStream, FileXML);
    finally
      MemoryStream.Free;
      end;
    FileXML.Nodes.AddCloseTag;

    //Les objets :
    FileXML.Nodes.AddOpenTag('Objets');
    if ListeObjets.Count > 0 then
      for i:= 0 to ListeObjets.Count - 1 do begin
        MemoryStream:= TMemoryStream.Create;
        try
          MemoryStream.WriteComponent(TComponent(ListeObjets[i]));
          MemoryStream.Position:= 0;
          ObjectBinary2GmXML(MemoryStream, FileXML);
        finally
          MemoryStream.Free;
          end;
        end;
    FileXML.Nodes.AddCloseTag;

    //Pour un Monde :
    if IsMonde then begin
      //Le Terrain :
      copieFichier(FichierTerrain, CheminRef + ExtractFileName(FichierTerrain), True);
      a:= ExtractFileName(FichierTerrain);//ExtractRelativePath(CheminRef, FichierTerrain);
      FileXML.Nodes.AddOpenTag('Terrain');
      FileXML.Nodes.AddOpenTag('NomFichier').AsString:= a; FileXML.Nodes.AddCloseTag;
      FileXML.Nodes.AddOpenTag('Couleur').AsString:= Vector2String(Sol.Material.FrontProperties.Diffuse.Color); FileXML.Nodes.AddCloseTag;
      FileXML.Nodes.AddCloseTag;
      //Le Ciel :
      FileXML.Nodes.AddOpenTag('Ciel');
      FileXML.Nodes.AddOpenTag('Genre').AsInteger:= GenreCiel; FileXML.Nodes.AddCloseTag;
      FileXML.Nodes.AddCloseTag;
      end;

    //On enregistre les Animations :
    if ObjAnimations <> nil then ObjAnimations.SaveToXML(FileXML);

    FileXML.Nodes.AddCloseTag;
    FileXML.SaveToFile(FileName);
  finally
    FileXML.Nodes.Clear;
    FileXML.Free;

    if ListeObjets.Count > 0 then
      for i:= ListeObjets.Count - 1 downto 0 do
        ListeObjets[i]:= nil;
    ListeObjets.free;
    Screen.Cursor:= ScreenCursorEx;
    //DecimalSeparator := SaveSeparator;
    end;
end;

procedure SauveFichierEx(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                         IsMonde: boolean;
                         const FileName : string;
                         ObjAnimations: TObjAnimations);
var
  FileStream: TFileStream;
  MemoryStream: TMemoryStream;
  i: integer;
  s: Longint;
  a: TNomFichier;
  CheminRef: string;
  ListeObjets: TList;
  ScreenCursorEx: TCursor;
begin
  ScreenCursorEx:= Screen.Cursor;
  Screen.Cursor:= crHourGlass;
  CheminRef:= ExtractFilePath(FileName);
  ListeObjets:= TList.create;
  FileStream:= TFileStream.Create(FileName, fmCreate);
  try
    //Version :
    i:= - 9;
    FileStream.Write(i, SizeOf(i));

    //On met les objets dans ListeObjets :
    if World.Count > 0 then
      for i:= 0 to World.Count - 1 do
        ListeObjets.add(World.Children[i]);
    //Nombre d'objets :
    i:= ListeObjets.count;
    FileStream.Write(i, SizeOf(i));

    //Les objets :
    if ListeObjets.Count > 0 then
      for i:= 0 to ListeObjets.Count - 1 do begin
        MemoryStream:= TMemoryStream.Create;
        try
          MemoryStream.WriteComponent(TComponent(ListeObjets[i]));
          s:= MemoryStream.size;
          FileStream.Write(s, SizeOf(s));
          MemoryStream.Position:= 0;
          FileStream.CopyFrom(MemoryStream, s);
        finally
          MemoryStream.Free;
          end;
        end;

    //Les fichiers 3ds (pour compatibilit) :
    i:= 0;
    FileStream.Write(i, SizeOf(i));
    //Pour un Monde :
    if IsMonde then begin
      //Le Terrain :
      a:= ExtractRelativePath(CheminRef, FichierTerrain);
      FileStream.Write(a, SizeOf(TNomFichier));
      FileStream.Write(Sol.Material.FrontProperties.Diffuse.Color, SizeOf(TVector));
      end;
    //On enregistre les Animations :
    ObjAnimations.SaveToStream(FileStream);

  finally
    FileStream.Free;

    if ListeObjets.Count > 0 then
      for i:= ListeObjets.Count - 1 downto 0 do
        ListeObjets[i]:= nil;
    ListeObjets.free;
    Screen.Cursor:= ScreenCursorEx;
    end;
end;

procedure ChargeObjetFreeForm(GLBaseSceneObject: TGLBaseSceneObject);
var
  i: Integer;
  Temp, Remplacement, Ex: TGLBaseSceneObject;
  a: string;
begin
  if GLBaseSceneObject.Count > 0 then
    for i:= GLBaseSceneObject.Count - 1 downto 0 do begin
      Temp:= GLBaseSceneObject.Children[i];
      ChargeObjetFreeForm(Temp);
      end;

  if GLBaseSceneObject is TObjet3ds then begin
    TObjet3ds(GLBaseSceneObject).LoadFromFile(TObjet3ds(GLBaseSceneObject).NomFichier);

    Ex:= GLBaseSceneObject;
    a:= Ex.Name;
    Remplacement:= GLBaseSceneObject.Parent.AddNewChild(TMyFreeForm);
    with TMyFreeForm(Remplacement) do begin
      //CreeNomUnique(World, Remplacement, 'aaaaaaaaaa');
      //ShowAxes:= True;
      //if ExtractFileExt(OpenDialog1.FileName) = '.3ds' then
      MaterialLibrary:= MyMaterialLibrary;
      LoadFromFile(TObjet3ds(GLBaseSceneObject).NomFichier);
      PitchAngle:=   Ex.PitchAngle;

      Position:=     Ex.Position;
      Direction:=    Ex.Direction;
      Up:=           Ex.Up;
      Scale:=        Ex.Scale;
      Tag:=          TObjet3ds(Ex).Encadrement.Tag;

      if Ex is TGLCustomSceneObject
        then begin
          //Couleur:=      TGLCustomSceneObject(Ex).Material.FrontProperties.Diffuse.Color;
          //Transparence:= TGLCustomSceneObject(Ex).Material.FrontProperties.Diffuse.Alpha;
          //TextureDisabled:= TGLCustomSceneObject(Ex).Material.Texture.disabled;
          end;

      end;
    GLBaseSceneObject:= Remplacement;
    Ex.Free;
    Remplacement.Name:= a;
    end;

  if GLBaseSceneObject is TMyFreeForm then begin
    ////TMyFreeForm(GLBaseSceneObject).Html2String;
    TMyFreeForm(GLBaseSceneObject).MaterialLibrary:= MyMaterialLibrary;
    TMyFreeForm(GLBaseSceneObject).LoadFromFile(TMyFreeForm(GLBaseSceneObject).NomFichier);
    end;
end;

procedure ExportMesh(World: TGLDummyCube; var FreeForm: TGLFreeForm; const FileName : string);
      procedure Recursion(GLBaseSceneObject: TGLBaseSceneObject);
      var
        i: Integer;
        Temp: TGLBaseSceneObject;
        GLSceneObject: TGLSceneObject;
      begin




        if GLBaseSceneObject is TGLSceneObject then begin
          GLSceneObject:= TGLSceneObject(GLBaseSceneObject);
          if GLSceneObject is TGLCube then AddToFreeForm(GLSceneObject, FreeForm)
          else if GLSceneObject is TGLSphere then AddToFreeForm(GLSceneObject, FreeForm)
          else if GLSceneObject is TGLCylinder then AddToFreeForm(GLSceneObject, FreeForm)
          else if GLSceneObject is TGLCone then AddToFreeForm(GLSceneObject, FreeForm)
          else if GLSceneObject is TGLTorus then AddToFreeForm(GLSceneObject, FreeForm)
          else if GLSceneObject is TGLDodecahedron then AddToFreeForm(GLSceneObject, FreeForm)
          //else if GLSceneObject is TGLTeapot then AddToFreeForm(GLSceneObject, FreeForm)

          else if GLSceneObject is tglplane then AddToFreeForm(GLSceneObject, FreeForm)
          //else if GLSceneObject is tglfrustrum then AddToFreeForm(GLSceneObject, FreeForm)
          else if GLSceneObject is TGLdisk then AddToFreeForm(GLSceneObject, FreeForm);
          end;

        if GLBaseSceneObject.Count > 0 then
          for i:= GLBaseSceneObject.Count - 1 downto 0 do begin
            Temp:= GLBaseSceneObject.Children[i];
            Recursion(Temp);
            end;
      end;
begin
  with FreeForm do begin
    MaterialLibrary:= MyMaterialLibrary;
    UseMeshMaterials:= True;
    end;
  FreeForm.MaterialLibrary.Materials.Clear;
  Recursion(World);
  FreeForm.StructureChanged;
  if FileName <> '' then begin
    FreeForm.SaveToFile(FileName);
    FreeForm.MaterialLibrary.SaveToFile(ChangeFileExt(FileName, '.gll'));
    end;
end;


procedure ExportPOV(World: TGLDummyCube;// Picture: TPicture; Sol: TGLSceneObject;
                    GLCamera: TGLCamera; GLLightSource: TGLLightSource; CouleurFond: TColor;
                    IsMonde: boolean;
                    const FileName : string//;
                    //ObjAnimations: TObjAnimations
                    );
const
  LineBreak = #13#10;
var
  i: integer;
  s: Longint;
  a: TNomFichier;
  CheminRef: string;
  ListeObjets: TList;
  FichierPOV: TStringList;
  ScreenCursorEx: TCursor;

  R, G, B, F: single;
  RA, TA, PA: single;
  initial_comment, include_text, custom_text, pyramid_def: string;
  ambient_template,
  background_template,
  light_template,
  camera_template: string;


  procedure RetrouveAnglesPourPov(GLBaseSceneObject: TGLBaseSceneObject;
                                  var rx, ry, rz: single);
  var
    ii, jj: TVector;
    cx, cy, cz, sx, sy, sz: single;
  begin
    ii:= GLBaseSceneObject.AbsoluteRight;
    jj:= GLBaseSceneObject.AbsoluteUp;

    if abs(ii[0]) > 0.001
      then rz:= arctan(ii[1]/ii[0])
      else begin
        if abs(ii[1]) > 0.001
          then rz:= pi/2
          else rz:= 0;
        end;
    SinCos(rz, sz, cz);

    cy:= cz * ii[0] + sz * ii[1];
    sy:= ii[2];
    if cy > 0.001
      then begin
        if cy > 0
          then ry:= arctan(sy/cy)
          else ry:= arctan(sy/cy) + pi;
        end
      else begin
        if sy > 0
          then ry:= pi/2
          else ry:= - pi/2;
        end;

    cx:= - sz * jj[0] + cz * jj[1];
    sx:= - sy * cz * jj[0] - sy * sz * jj[1] + cy * jj[2];
    if cx > 0.001
      then begin
        if cx > 0
          then rx:= arctan(sx/cx)
          else rx:= arctan(sx/cx) + pi;
        end
      else begin
        if sx > 0
          then rx:= pi/2
          else rx:= - pi/2;
        end;

    rx:= - radtodeg(rx);
    ry:= radtodeg(ry);
    rz:= radtodeg(rz);
  end;



  procedure Recursion(GLBaseSceneObject: TGLBaseSceneObject; ScaleGroupe: TVector);
  var
    j: Integer;
    Temp: TGLBaseSceneObject;
    object_template: string;
    AbsDir: TVector;
    Object_OK: boolean;
    AbsScale: TGLCoordinates;
    Tran: TTransformations;
    NewScaleGroupe: TVector;
  begin
    if GLBaseSceneObject <> World then begin
      Object_OK:= True;

      object_template:= '#declare ' + GLBaseSceneObject.Name + ' =' + LineBreak;

      if GLBaseSceneObject is TGLCube then
        object_template:= object_template + 'box { <-0.5, -0.5, -0.5> <0.5, 0.5, 0.5>'
      else if GLBaseSceneObject is TGLsphere then
        object_template:= object_template + 'sphere { <0, 0, 0>, 0.5'
      else if GLBaseSceneObject is TGLCylinder then
        object_template:= object_template + 'cylinder { <-0.5, 0, 0>, <0.5, 0, 0>, 0.5 rotate <0, 0, 90>'
      else if GLBaseSceneObject is TGLCone then
        object_template:= object_template + 'cone { <0, 0.5, 0>, 0.0, <0, -0.5, 0>, 0.5'
      else if GLBaseSceneObject is TGLTorus then
        object_template:= object_template + 'torus { 0.4, 0.1 rotate <90, 0, 0>'

{
      else if GLBaseSceneObject is TGLCube then
        object_template:= object_template + 'box { <-0.5, -0.5, -0.5> <0.5, 0.5, 0.5>'
}
      else Object_OK:= False;

      if Object_OK then begin
        object_template:= object_template + LineBreak +
                          '  pigment { color rgbf <%f, %f, %f, %f> }' + LineBreak +
                          '  scale <%.3f, %.3f, %.3f>' + LineBreak +
                          '  rotate <%.0f, %.0f, %.0f>' + LineBreak +
                          //'  rotate <0, 0, %.0f>' + LineBreak +
                          //'  rotate <0, %.0f, 0>' + LineBreak +
                          //'  rotate <%.0f, 0, 0>' + LineBreak +
                          '  translate <%.3f, %.3f, %.3f>' + LineBreak +
                          '}' + LineBreak +
                          GLBaseSceneObject.Name;
        if GLBaseSceneObject is TGLCustomSceneObject then
          with GLBaseSceneObject as TGLCustomSceneObject do begin
            R:= Material.FrontProperties.Diffuse.Color[0];
            G:= Material.FrontProperties.Diffuse.Color[1];
            B:= Material.FrontProperties.Diffuse.Color[2];
            F:= 1 - Material.FrontProperties.Diffuse.Alpha;

            RA:= RollAngle;
            TA:= TurnAngle;
            PA:= PitchAngle;
            RetrouveAnglesPourPov(GLBaseSceneObject, RA, TA, PA);

            FichierPOV.Add(Format(object_template,
                           [R, G, B, F,
                            //Scale.X, Scale.Y, Scale.Z,
                            //RA, TA, PA,
                            //Position.X, Position.Y, - Position.Z]));

                            Scale.X,
                            //ScaleGroupe[0]*Scale.X,
                            Scale.Y,
                            //ScaleGroupe[1]*Scale.Y,
                            Scale.Z,
                            //ScaleGroupe[2]*Scale.Z,

                            RA, TA, PA,
                            AbsolutePosition[0], AbsolutePosition[1], - AbsolutePosition[2]]));
            end;
        FichierPOV.Add(LineBreak + LineBreak);
        end;

      end;
    if GLBaseSceneObject.Count > 0 then
      for j:= GLBaseSceneObject.Count - 1 downto 0 do begin
        Temp:= GLBaseSceneObject.Children[j];
        NewScaleGroupe:= ScaleGroupe;
        if Temp is TGLDummyCube
          then ScaleVector(NewScaleGroupe, Temp.Scale.AsVector);
        Recursion(Temp, NewScaleGroupe);
        end;
  end;

begin
  ScreenCursorEx:= Screen.Cursor;
  Screen.Cursor:= crHourGlass;
  CheminRef:= ExtractFilePath(FileName);
  //ListeObjets:= TList.create;
  FichierPOV:= TStringList.create;
  try
    initial_comment:= '// povray code generated by povexport.py' + LineBreak;
    include_text:= '#include "colors.inc"' + LineBreak;
    FichierPOV.Add(initial_comment + include_text + custom_text + pyramid_def );
    FichierPOV.Add(LineBreak + LineBreak);

    ambient_template:= 'global_settings { ambient_light rgb <%f, %f, %f> }';
    FichierPOV.Add(Format(ambient_template, [1.0, 1.0, 1.0]) +LineBreak);
    FichierPOV.Add(LineBreak + LineBreak);

    R:= GetRValue( ColorToRGB(CouleurFond)) / 255;
    G:= GetGValue( ColorToRGB(CouleurFond)) / 255;
    B:= GetBValue( ColorToRGB(CouleurFond)) / 255;

    background_template:= 'background { color rgb <%f, %f, %f> }';
    FichierPOV.Add(Format(background_template, [R, G, B]) + LineBreak);
    FichierPOV.Add(LineBreak + LineBreak);

    light_template:= 'light_source { <%.3f, %.3f, %.3f>' + LineBreak + ' color rgb <%f, %f, %f>' + LineBreak + '}';
    with GLLightSource do
      FichierPOV.Add(Format(light_template, [AbsolutePosition[0], AbsolutePosition[1], - AbsolutePosition[2],
                                             Diffuse.Red, Diffuse.Green, Diffuse.Blue]) + LineBreak);
    with GLLightSource do
      FichierPOV.Add(Format(light_template, [AbsolutePosition[0], AbsolutePosition[1], - AbsolutePosition[2],
                                             Diffuse.Red, Diffuse.Green, Diffuse.Blue]) + LineBreak);
    FichierPOV.Add(LineBreak + LineBreak);

    camera_template:= 'camera { location <%.3f, %.3f, %.3f>' + LineBreak + ' look_at <%.3f, %.3f, %.3f>' + LineBreak + '}';
    with GLCamera do
      FichierPOV.Add(Format(camera_template, [Position.X, Position.Y, - Position.Z,
                                              Direction.X, Direction.Y, - Direction.Z]) + LineBreak);
    FichierPOV.Add(LineBreak + LineBreak);


    Recursion(World, World.Scale.AsVector);







    //On met les objets dans ListeObjets :
  {  if World.Count > 0 then
      for i:= 0 to World.Count - 1 do
        ListeObjets.add(World.Children[i]);     }
    //Entte :
    //FichierPOV.Add('#VRML V2.0 utf8');
    //FichierPOV.Add('');
    //Les objets :
   { if ListeObjets.Count > 0 then
      for i:= 0 to ListeObjets.Count - 1 do begin   }
        {
        MemoryStream:= TMemoryStream.Create;
        try
          MemoryStream.WriteComponent(TComponent(ListeObjets[i]));
          s:= MemoryStream.size;
          FileStream.Write(s, SizeOf(s));
          MemoryStream.Position:= 0;
          FileStream.CopyFrom(MemoryStream, s);
        finally
          MemoryStream.Free;
          end;
        }
      {  end;     }
    //Pour un Monde :
   { if IsMonde then begin
      //Le Terrain :
      a:= ExtractRelativePath(CheminRef, FichierTerrain);
      //FileStream.Write(a, SizeOf(TNomFichier));
      //FileStream.Write(Sol.Material.FrontProperties.Diffuse.Color, SizeOf(TVector));
      end;  }
    //On enregistre les Animations :
    //ObjAnimations.SaveToStream(FileStream);
    FichierPOV.SaveToFile(FileName);
  finally
    FichierPOV.Free;
  {  if ListeObjets.Count > 0 then
      for i:= ListeObjets.Count - 1 downto 0 do
        ListeObjets[i]:= nil;
    ListeObjets.free;    }
    Screen.Cursor:= ScreenCursorEx;
    end;
end;

procedure ExportVRML(World: TGLDummyCube; Picture: TPicture; Sol: TGLSceneObject;
                     IsMonde: boolean;
                     const FileName : string;
                     ObjAnimations: TObjAnimations);
var
  i: integer;
  s: Longint;
  a: TNomFichier;
  CheminRef: string;
  ListeObjets: TList;
  FichierVRML: TStringList;
  ScreenCursorEx: TCursor;
begin
  ScreenCursorEx:= Screen.Cursor;
  Screen.Cursor:= crHourGlass;
  CheminRef:= ExtractFilePath(FileName);
  ListeObjets:= TList.create;
  FichierVRML:= TStringList.create;
  try
    //On met les objets dans ListeObjets :
    if World.Count > 0 then
      for i:= 0 to World.Count - 1 do
        ListeObjets.add(World.Children[i]);
    //Entte :
    FichierVRML.Add('#VRML V2.0 utf8');
    FichierVRML.Add('');
    //Les objets :
    if ListeObjets.Count > 0 then
      for i:= 0 to ListeObjets.Count - 1 do begin
        {
        MemoryStream:= TMemoryStream.Create;
        try
          MemoryStream.WriteComponent(TComponent(ListeObjets[i]));
          s:= MemoryStream.size;
          FileStream.Write(s, SizeOf(s));
          MemoryStream.Position:= 0;
          FileStream.CopyFrom(MemoryStream, s);
        finally
          MemoryStream.Free;
          end;
        }
        end;
    //Pour un Monde :
    if IsMonde then begin
      //Le Terrain :
      a:= ExtractRelativePath(CheminRef, FichierTerrain);
      //FileStream.Write(a, SizeOf(TNomFichier));
      //FileStream.Write(Sol.Material.FrontProperties.Diffuse.Color, SizeOf(TVector));
      end;
    //On enregistre les Animations :
    //ObjAnimations.SaveToStream(FileStream);
    FichierVRML.SaveToFile(FileName);
  finally
    FichierVRML.Free;
    if ListeObjets.Count > 0 then
      for i:= ListeObjets.Count - 1 downto 0 do
        ListeObjets[i]:= nil;
    ListeObjets.free;
    Screen.Cursor:= ScreenCursorEx;
    end;
end;




//*****************************************************************************
procedure CreeNomUnique(World: TGLBaseSceneObject;
                        Objet: TComponent; Nom: string);
var
  i: Integer;
  BaseName, TempName: string;
begin
  Objet.Name:= '';
  BaseName:= Nom;
  if BaseName = '' then BaseName:= 'SansNom';
  if World.FindChild(BaseName, False) = nil then begin
    Objet.Name:= BaseName;
    exit;
    end;

  while BaseName[length(BaseName)]
    in ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'] do
      BaseName:= Copy(BaseName, 1, Length(BaseName) - 1);
  TempName:= BaseName;

  i:= 0;
  while World.FindChild(TempName, False) <> nil do begin
    i:= i + 1;
    TempName:= Format('%s%d', [BaseName, i]);
    end;
  Objet.Name:= TempName;
end;

procedure VerifierNoms(World: TGLBaseSceneObject);

  procedure Recursion(GLBaseSceneObject: TGLBaseSceneObject);
  var
    j: Integer;
    Temp: TGLBaseSceneObject;
  begin
    if GLBaseSceneObject <> World then
      CreeNomUnique(World, TComponent(GLBaseSceneObject), GLBaseSceneObject.Name);
    if GLBaseSceneObject.Count > 0 then
      for j:= GLBaseSceneObject.Count - 1 downto 0 do begin
        Temp:= GLBaseSceneObject.Children[j];
        Recursion(Temp);
        end;
  end;

begin
  //Les noms doivent tre uniques :
  Recursion(World);
end;





function ComponentToString(Component: TComponent): string;
var
  BinStream: TMemoryStream;
  StrStream: TStringStream;
  s: string;
begin
  BinStream:= TMemoryStream.Create;
  try
    StrStream:= TStringStream.Create(s);
    try
      BinStream.WriteComponent(Component);
      BinStream.Seek(0, soFromBeginning);
      ObjectBinaryToText(BinStream, StrStream);
      StrStream.Seek(0, soFromBeginning);
      Result:= StrStream.DataString;
    finally
      StrStream.Free;
      end;
  finally
    BinStream.Free;
    end;
end;



function StringToComponent(Value: string): TComponent;
var
  StrStream: TStringStream;
  BinStream: TMemoryStream;
begin
  StrStream:= TStringStream.Create(Value);
  try
    BinStream:= TMemoryStream.Create;
    try
      ObjectTextToBinary(StrStream, BinStream);
      BinStream.Seek(0, soFromBeginning);
      Result:= BinStream.ReadComponent(nil);
    finally
      BinStream.Free;
      end;
  finally
    StrStream.Free;
    end;
end;


function Vector2String(Vector: TVector): string;
var
  r: string;
  i: integer;
begin
  r:= FloatToStr(Vector[0]);
  for i:= 1 to 3 do
    r:= r + '|' + FloatToStr(Vector[i]);
  Result:= r;
end;

function String2Vector(MyString: string): TVector;
var
  a, b: string;
  x, y, z: double;
  v: TVector;
begin
  a:= MyString;
  b:= TokTok('|', a);
  x:= StrToFloat(b);
  b:= TokTok('|', a);
  y:= StrToFloat(b);
  b:= TokTok('|', a);
  z:= StrToFloat(b);
  SetVector(v, x, y, z);
  Result:= v;
end;


/////////////////////////////////////////////////
/////////////////////////////////////////////////
//                  Divers
/////////////////////////////////////////////////
/////////////////////////////////////////////////

procedure SupprimerLignesVides(var StringList: TStringList);
var
  i: integer;
begin
  if StringList.count > 0 then
    for i:= StringList.count - 1 downto 0 do
      if StringList[i] = '' then
        StringList.Delete(i);
end;

procedure AfficheListe(Strings: TStrings);
var
  i: integer;
  a: string;
begin
  if Strings.count > 0 then
    for i:= 0 to Strings.count - 1 do
      a:= a + Strings[i] + #13;
  showmessage(a);
end;

procedure AfficheMemoryStream(Stream: TStream);
var
  Strings: TStringStream;
  ss1: string;
begin
  Strings:= TStringStream.Create(ss1);
  try
    Stream.Position:= 0;
    ObjectBinaryToText(Stream, Strings);
    showmessage(Strings.DataString);
  finally
    Strings.Free;
    end;
end;

procedure ChangeCouleur(World: TGLBaseSceneObject;
                        ColorEx, ColorNew: TColor);
      procedure Recursion(GLBaseSceneObject: TGLBaseSceneObject);
      var
        i: Integer;
        Temp: TGLBaseSceneObject;
        Color: TColor;
      begin
        if GLBaseSceneObject is TGLCustomSceneObject then
          with GLBaseSceneObject as TGLCustomSceneObject do begin
            Color:= ConvertColorVector(Material.FrontProperties.Diffuse.Color);
            if color = ColorEx then begin
              color:= ColorNew;
              Material.FrontProperties.Diffuse.Color:= ConvertWinColor(Color, 1);
              end;
            end;
        if GLBaseSceneObject.Count > 0 then
          for i:= GLBaseSceneObject.Count - 1 downto 0 do begin
            Temp:= GLBaseSceneObject.Children[i];
            Recursion(Temp);
            end;
      end;
begin
    Recursion(World);
end;

procedure ScaleAll(World: TGLBaseSceneObject; ScaleValue: single);
var
  i: integer;
begin
  if World.Count > 0 then
    for i:= 0 to World.Count - 1 do begin
      World.Children[i].Scale.Scale(ScaleValue);     //0.05
      World.Children[i].Position.Scale(ScaleValue);  //0.05
      end;
end;


end.
