unit UtilsSelect;

interface

uses
  SysUtils,
  Classes,
  Controls,
  Forms,
  Dialogs,
  ExtDlgs,
  StdCtrls,
  Menus,

  GLScene,
  GLObjects,
  GLGeomObjects,
  GLWin32Viewer,
  GLTexture,
  VectorGeometry,
  GLVectorFileObjects,

  glMyFreeForm,
  Utils,
  UTrackBar,
  USpinEdit,
  Animations;

type
  TMyProcedure = procedure(Sender: TObject) of object;
  TMyProcedureStyle = (mpsTrans, mpsMinorRadius, mpsScaleAll);


var

  TheWorld: TGLDummyCube;
  ObjetCourant: TGLBaseSceneObject;
  ListObjetsCourants, ListNoPick: TList;
  SelectionMultiple: boolean;
  GroupeCourant: TGLDummyCube;
  UtilsSelect_ObjAnimations: TObjAnimations;

  MyProcedure_OnShow, MyProcedure_OnChange: TMyProcedure;
  MyProcedureStyle: TMyProcedureStyle;


  Clic: boolean;

  mx, my : Integer;
  lastMouseWorldPos: TVector;
  YAAColler, BougeCamera: boolean;
  MemoryStreamAColler: TMemoryStream;
  NbObjetsAColler: integer;


  ComboBox_UtilsSelect: TComboBox;

  PopupMenu_UtilsSelect:    TPopupMenu;
    mnProperties:       TMenuItem;
    mnCouleurObjet:     TMenuItem;
    mnTextureObjet:     TMenuItem;
    mnTextureTrans:     TMenuItem;
    mnTransparence:     TMenuItem;
    mnMinorRadius:      TMenuItem;

    mnReNommer:         TMenuItem;

    mnCopier:           TMenuItem;
    mnColler:           TMenuItem;
    mnSupprimer:        TMenuItem;
    mnToutSelectionner: TMenuItem;

    mnGrouper:          TMenuItem;
    mnDeGrouper:        TMenuItem;
    mnDeGrouperTout:    TMenuItem;
    mnEntrerDansGroupe: TMenuItem;
    mnSortirDuGroupe:   TMenuItem;
    mnScaleAll:         TMenuItem;

  ColorDialog: TColorDialog;
  OpenPictureDialog: TOpenPictureDialog;


function MouseWorldPos(GLSceneViewer: TGLSceneViewer; x, y : Integer): TVector;
procedure AfficheAxes(Affiche: boolean);

procedure MettreAJourComboBox;

procedure TrouveSelection(GLSceneViewer: TGLSceneViewer);
procedure DeSelectionne;
procedure Selectionne(Objet: TGLBaseSceneObject; Seul: boolean);




procedure MetAJourInterface;

procedure CreerPopupMenu_UtilsSelect(MyPopupMenuClick,
                                     My_OnShow,
                                     My_OnChange: TMyProcedure);
procedure MyProcedure_DoShow(Sender: TObject);
procedure MyProcedure_DoChange(Sender: TObject);

procedure MetAJourMenuPopUp;
procedure PopupMenu_UtilsSelectClick(Sender: TObject);
procedure mnPropertiesClick(Sender: TObject);
procedure mnCouleurObjetClick(Sender: TObject);
procedure mnTextureObjetClick(Sender: TObject);
procedure mnTextureTransClick(Sender: TObject);
procedure mnTransparenceClick(Sender: TObject);
procedure mnMinorRadiusClick(Sender: TObject);
procedure mnReNommerClick(Sender: TObject);
procedure mnCopierClick(Sender: TObject);
procedure CopierComponent(Component: TComponent; Vider: Boolean);
procedure mnCollerClick(Sender: TObject);
function CollerComponent: TComponent;
procedure mnSupprimerClick(Sender: TObject);
procedure mnToutSelectionnerClick(Sender: TObject);
procedure mnGrouperClick(Sender: TObject);
procedure mnDeGrouperClick(Sender: TObject);
procedure mnDeGrouperToutClick(Sender: TObject);
procedure mnEntrerDansGroupeClick(Sender: TObject);
procedure mnSortirDuGroupeClick(Sender: TObject);
procedure mnScaleAllClick(Sender: TObject);



procedure MyGLSceneViewerMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
procedure MyGLSceneViewerMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

implementation

uses UProperties;

procedure MyGLSceneViewerMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  GLSceneViewer: TGLSceneViewer;
begin
  if Attendre then exit;
  Clic:= True;
  //PopupMenu_Scene.AutoPopUp:= True;
  GLSceneViewer:= TGLSceneViewer(Sender);
  mx:= X;
  my:= Y;
  if Assigned(ObjetCourant) or BougeCamera then
    lastMouseWorldPos:= MouseWorldPos(GLSceneViewer, mx, my);
end;

procedure MyGLSceneViewerMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  GLSceneViewer: TGLSceneViewer;
begin
  if Attendre then exit;
  if Clic = False then exit;
  if (Button = mbLeft) then begin
    //PopupMenu_Scene.AutoPopUp:= False;
    GLSceneViewer:= TGLSceneViewer(Sender);
    TrouveSelection(GLSceneViewer);
    MetAJourMenuPopUp;
    end;
end;


procedure MetAJourInterface;
begin
  MettreAJourComboBox;
  MetAJourMenuPopUp;
end;



procedure CreerPopupMenu_UtilsSelect(MyPopupMenuClick,
                                     My_OnShow,
                                     My_OnChange: TMyProcedure);
var
  i, j: integer;
  a, NomCourt, NomLong: string;
  MenuItem: TMenuItem;
begin
  MyProcedure_OnShow:= My_OnShow;
  MyProcedure_OnChange:= My_OnChange;


  //PopupMenu_UtilsSelect.Items.Clear;

  //MenuItem:= TMenuItem.Create(application);
  //MenuItem.caption:= 'aaaaaaaaaaaaaaaaaaaa';
  //PopupMenu_UtilsSelect.Items.Add(MenuItem);

  MenuItem:= TMenuItem.Create(application);
  MenuItem.caption:= '-';
  PopupMenu_UtilsSelect.Items.Add(MenuItem);

  mnProperties:= TMenuItem.Create(application);
  with mnProperties do begin
    caption:= GmXMLLangue.GetStringByPath('popup\Properties');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnProperties);

  mnCouleurObjet:= TMenuItem.Create(application);
  with mnCouleurObjet do begin
    caption:= GmXMLLangue.GetStringByPath('popup\ObjectColor');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnCouleurObjet);

  mnTextureObjet:= TMenuItem.Create(application);
  with mnTextureObjet do begin
    caption:= GmXMLLangue.GetStringByPath('popup\ObjectTexture');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnTextureObjet);

  mnTextureTrans:= TMenuItem.Create(application);
  with mnTextureTrans do begin
    caption:= GmXMLLangue.GetStringByPath('popup\TransparentTexture');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnTextureTrans);

  mnTransparence:= TMenuItem.Create(application);
  with mnTransparence do begin
    caption:= GmXMLLangue.GetStringByPath('popup\Transparency');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnTransparence);

  mnMinorRadius:= TMenuItem.Create(application);
  with mnMinorRadius do begin
    caption:= GmXMLLangue.GetStringByPath('popup\ToreMinorRadius');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnMinorRadius);

  MenuItem:= TMenuItem.Create(application);
  MenuItem.caption:= '-';
  PopupMenu_UtilsSelect.Items.Add(MenuItem);

  mnCopier:= TMenuItem.Create(application);
  with mnCopier do begin
    caption:= GmXMLLangue.GetStringByPath('popup\Copy');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnCopier);

  mnColler:= TMenuItem.Create(application);
  with mnColler do begin
    caption:= GmXMLLangue.GetStringByPath('popup\Paste');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnColler);

  mnSupprimer:= TMenuItem.Create(application);
  with mnSupprimer do begin
    caption:= GmXMLLangue.GetStringByPath('popup\Delete');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnSupprimer);

  mnReNommer:= TMenuItem.Create(application);
  with mnReNommer do begin
    caption:= GmXMLLangue.GetStringByPath('popup\Rename');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnReNommer);

  MenuItem:= TMenuItem.Create(application);
  MenuItem.caption:= '-';
  PopupMenu_UtilsSelect.Items.Add(MenuItem);

  mnGrouper:= TMenuItem.Create(application);
  with mnGrouper do begin
    caption:= GmXMLLangue.GetStringByPath('popup\Group');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnGrouper);

  mnDeGrouper:= TMenuItem.Create(application);
  with mnDeGrouper do begin
    caption:= GmXMLLangue.GetStringByPath('popup\Ungroup');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnDeGrouper);

  mnDeGrouperTout:= TMenuItem.Create(application);
  with mnDeGrouperTout do begin
    caption:= GmXMLLangue.GetStringByPath('popup\UngroupAll');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnDeGrouperTout);

  mnEntrerDansGroupe:= TMenuItem.Create(application);
  with mnEntrerDansGroupe do begin
    caption:= GmXMLLangue.GetStringByPath('popup\JoinGroup');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnEntrerDansGroupe);

  mnSortirDuGroupe:= TMenuItem.Create(application);
  with mnSortirDuGroupe do begin
    caption:= GmXMLLangue.GetStringByPath('popup\SeparateFromGroup');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnSortirDuGroupe);

  MenuItem:= TMenuItem.Create(application);
  MenuItem.caption:= '-';
  PopupMenu_UtilsSelect.Items.Add(MenuItem);

  mnToutSelectionner:= TMenuItem.Create(application);
  with mnToutSelectionner do begin
    caption:= GmXMLLangue.GetStringByPath('popup\SelectAll');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnToutSelectionner);

  mnScaleAll:= TMenuItem.Create(application);
  with mnScaleAll do begin
    caption:= GmXMLLangue.GetStringByPath('popup\ScaleAll');
    OnClick:= MyPopupMenuClick;
    end;
  PopupMenu_UtilsSelect.Items.Add(mnScaleAll);

end;

procedure MyProcedure_DoShow(Sender: TObject);
begin
  if MyProcedureStyle = mpsTrans then begin
    FTrackBar.ValeurInitiale:= 1;
    if ObjetCourant is TGLCustomSceneObject then
      with ObjetCourant as TGLCustomSceneObject do begin
        Material.BlendingMode:= bmTransparency;
        FTrackBar.ValeurInitiale:= Material.FrontProperties.Diffuse.Alpha;
        end;
    FTrackBar.TrackBar1.Position:= trunc(FTrackBar.ValeurInitiale * 100);
    end
  else if MyProcedureStyle = mpsMinorRadius then begin
    FTrackBar.ValeurInitiale:= 0.1;
    if ObjetCourant is TGLTorus then
      with TGLTorus(ObjetCourant) do
        FTrackBar.ValeurInitiale:= MinorRadius;
    FTrackBar.TrackBar1.Position:= trunc(FTrackBar.ValeurInitiale * 100) - 1;
    end
  else if MyProcedureStyle = mpsScaleAll then begin
    FSpinEdit.ValeurInitiale:= 1;
    FSpinEdit.ValeurActuelle:= 1;
    //FSpinEdit.FloatSpinEdit1.MinValue:= 0.01;
    FSpinEdit.FloatSpinEdit1.text:= floattostr(FSpinEdit.ValeurInitiale);
    end;
  MyProcedure_DoChange(Sender);
end;

procedure MyProcedure_DoChange(Sender: TObject);
var
  i: integer;
  s: double;
  Objet: TGLBaseSceneObject;

  procedure AppliqueTransparence(GLBaseSceneObject: TGLBaseSceneObject);
  var
    j: Integer;
    Temp: TGLBaseSceneObject;
  begin
    if GLBaseSceneObject is TGLCustomSceneObject then
      with GLBaseSceneObject as TGLCustomSceneObject do begin
        Material.BlendingMode:= bmTransparency;
        Material.FrontProperties.Diffuse.Alpha:= s;
        end;
    if GLBaseSceneObject is TGLFreeForm then exit;
    if GLBaseSceneObject.Count > 0 then
      for j:= GLBaseSceneObject.Count - 1 downto 0 do begin
        Temp:= GLBaseSceneObject.Children[j];
        AppliqueTransparence(Temp);
        end;
  end;

begin
  if MyProcedureStyle = mpsTrans then begin
    FTrackBar.Label1.caption:= inttostr(FTrackBar.TrackBar1.Position) + ' %';
    s:= FTrackBar.TrackBar1.Position / 100;
    for i:= 0 to ListObjetsCourants.Count - 1 do begin
      Objet:= TGLBaseSceneObject(ListObjetsCourants[i]);
      AppliqueTransparence(Objet);
      end;
    end
  else if MyProcedureStyle = mpsMinorRadius then begin
    s:= (1 + FTrackBar.TrackBar1.Position) / 100;
    FTrackBar.Label1.caption:= Format('%.2f', [s]);
    with TGLTorus(ObjetCourant) do
      MinorRadius:= s;
    end
  else if MyProcedureStyle = mpsScaleAll then begin
    s:= strtofloatdef(FSpinEdit.FloatSpinEdit1.text,0);
    ScaleAll(TheWorld, s/FSpinEdit.ValeurActuelle);
    FSpinEdit.ValeurActuelle:= s;
    end;
end;

procedure PopupMenu_UtilsSelectClick(Sender: TObject);
begin
  if Sender = mnProperties then mnPropertiesClick(Sender)
  else if Sender = mnCouleurObjet then mnCouleurObjetClick(Sender)
  else if Sender = mnTextureObjet then mnTextureObjetClick(Sender)
  else if Sender = mnTextureTrans then mnTextureTransClick(Sender)
  else if Sender = mnTransparence then mnTransparenceClick(Sender)
  else if Sender = mnMinorRadius then mnMinorRadiusClick(Sender)

  else if Sender = mnCopier then mnCopierClick(Sender)
  else if Sender = mnColler then mnCollerClick(Sender)
  else if Sender = mnSupprimer then mnSupprimerClick(Sender)
  else if Sender = mnReNommer then mnReNommerClick(Sender)

  else if Sender = mnGrouper then mnGrouperClick(Sender)
  else if Sender = mnDeGrouper then mnDeGrouperClick(Sender)
  else if Sender = mnDeGrouperTout then mnDeGrouperToutClick(Sender)
  else if Sender = mnEntrerDansGroupe then mnEntrerDansGroupeClick(Sender)
  else if Sender = mnSortirDuGroupe then mnSortirDuGroupeClick(Sender)

  else if Sender = mnToutSelectionner then mnToutSelectionnerClick(Sender)
  else if Sender = mnScaleAll then mnScaleAllClick(Sender)
  {
  else if Sender = mnAAA then mnAAAClick(Sender)
  else if Sender = mnAAA then mnAAAClick(Sender)
  else if Sender = mnAAA then mnAAAClick(Sender)
  }
  else showmessage('Pas fait !!!!!!!!!!!!!!!!!');
end;

procedure MetAJourMenuPopUp;
var
  i: integer;
begin
  i:= ListObjetsCourants.Count;
  if i > 1 then i:= 3;
  if i = 1 then
    if ObjetCourant.count > 0 then i:= 2;
  case i of
    0 : begin //pas de slection
          mnProperties.Visible:=        False;
          mnCouleurObjet.Visible:=      False;
          mnTextureObjet.Visible:=      False;
          mnTextureTrans.Visible:=      False;
          mnTransparence.Visible:=      False;
          mnMinorRadius.Visible:=       False;

          mnCopier.Visible:=            False;
          mnColler.Visible:=            YAAColler;
          mnSupprimer.Visible:=         False;
          mnReNommer.Visible:=          False;

          mnGrouper.Visible:=           False;
          mnDeGrouper.Visible:=         False;
          mnDeGrouperTout.Visible:=     False;
          mnEntrerDansGroupe.Visible:=  False;
          mnSortirDuGroupe.Visible:=    not(GroupeCourant = TheWorld);

          mnToutSelectionner.Visible:=  True;
          mnScaleAll.Visible:=          True;
          end;
    1 : begin //slection d'un objet simple
          mnProperties.Visible:=        True;
          mnCouleurObjet.Visible:=      True;
          mnTextureObjet.Visible:=      True;
          mnTextureTrans.Visible:=      True;
          mnTransparence.Visible:=      True;
          if ObjetCourant is TGLTorus
            then mnMinorRadius.Visible:=  True
            else mnMinorRadius.Visible:=  False;

          mnCopier.Visible:=            True;
          mnColler.Visible:=            YAAColler;
          mnSupprimer.Visible:=         True;
          mnReNommer.Visible:=          True;

          mnGrouper.Visible:=           False;
          mnDeGrouper.Visible:=         False;
          mnDeGrouperTout.Visible:=     False;
          mnEntrerDansGroupe.Visible:=  False;
          mnSortirDuGroupe.Visible:=    not(GroupeCourant = TheWorld);

          mnToutSelectionner.Visible:=  True;
          mnScaleAll.Visible:=          True;
          end;
    2 : begin //slection d'un groupe
          mnProperties.Visible:=        True;
          mnCouleurObjet.Visible:=      True;
          mnTextureObjet.Visible:=      True;
          mnTextureTrans.Visible:=      True;
          mnTransparence.Visible:=      True;
          mnMinorRadius.Visible:=       False;

          mnCopier.Visible:=            True;
          mnColler.Visible:=            YAAColler;
          mnSupprimer.Visible:=         True;
          mnReNommer.Visible:=          True;

          mnGrouper.Visible:=           False;
          mnDeGrouper.Visible:=         True;
          mnDeGrouperTout.Visible:=     True;
          mnEntrerDansGroupe.Visible:=  True;
          mnSortirDuGroupe.Visible:=    not(GroupeCourant = TheWorld);

          mnToutSelectionner.Visible:=  True;
          mnScaleAll.Visible:=          True;
          end;
    3 : begin //slection multiple
          mnProperties.Visible:=        False;
          mnCouleurObjet.Visible:=      True;
          mnTextureObjet.Visible:=      True;
          mnTextureTrans.Visible:=      True;
          mnTransparence.Visible:=      True;
          mnMinorRadius.Visible:=       False;

          mnCopier.Visible:=            True;
          mnColler.Visible:=            YAAColler;
          mnSupprimer.Visible:=         True;
          mnReNommer.Visible:=          True;

          mnGrouper.Visible:=           True;
          mnDeGrouper.Visible:=         False;
          mnDeGrouperTout.Visible:=     False;
          mnEntrerDansGroupe.Visible:=  False;
          mnSortirDuGroupe.Visible:=    not(GroupeCourant = TheWorld);

          mnToutSelectionner.Visible:=  True;
          mnScaleAll.Visible:=          True;
          end;
    end;
end;

procedure mnPropertiesClick(Sender: TObject);
begin
  if Attendre then exit;
  if ObjetCourant = nil then exit;

  Application.CreateForm(TFProperties, FProperties);
  try
    with FProperties do begin
      caption:= GmXMLLangue.GetStringByPath('popup\Properties');

      Noms[1]:= GmXMLLangue.GetStringByPath('PropertiesWindow\PitchAngle');
      Noms[2]:= GmXMLLangue.GetStringByPath('PropertiesWindow\TurnAngle');
      Noms[3]:= GmXMLLangue.GetStringByPath('PropertiesWindow\RollAngle');
      ButtonResetRotations.caption:= GmXMLLangue.GetStringByPath('PropertiesWindow\ResetRotations');

      Label4.caption:= GmXMLLangue.GetStringByPath('PropertiesWindow\PositionX');
      Label5.caption:= GmXMLLangue.GetStringByPath('PropertiesWindow\PositionY');
      Label6.caption:= GmXMLLangue.GetStringByPath('PropertiesWindow\PositionZ');

      Label7.caption:= GmXMLLangue.GetStringByPath('PropertiesWindow\ScaleX');
      Label8.caption:= GmXMLLangue.GetStringByPath('PropertiesWindow\ScaleY');
      Label9.caption:= GmXMLLangue.GetStringByPath('PropertiesWindow\ScaleZ');

      Label10.caption:= GmXMLLangue.GetStringByPath('PropertiesWindow\DimX');
      Label11.caption:= GmXMLLangue.GetStringByPath('PropertiesWindow\DimY');
      Label12.caption:= GmXMLLangue.GetStringByPath('PropertiesWindow\DimZ');

      if ShowModal = mrCancel then begin
        ObjetCourant.PitchAngle:= ValeursInitiales[1];
        ObjetCourant.TurnAngle:= ValeursInitiales[2];
        ObjetCourant.RollAngle:= ValeursInitiales[3];

        ObjetCourant.Position.X:= ValeursInitiales[4];
        ObjetCourant.Position.Y:= ValeursInitiales[5];
        ObjetCourant.Position.Z:= ValeursInitiales[6];

        ObjetCourant.Scale.X:= ValeursInitiales[7];
        ObjetCourant.Scale.Y:= ValeursInitiales[8];
        ObjetCourant.Scale.Z:= ValeursInitiales[9];
        end;

      end;
  finally
    FProperties.free;
    end;

end;

procedure mnCouleurObjetClick(Sender: TObject);
var
  i: integer;
  Objet: TGLBaseSceneObject;

  procedure AppliqueCouleur(GLBaseSceneObject: TGLBaseSceneObject;
                            Couleur: TVector);
  var
    j: Integer;
    Temp: TGLBaseSceneObject;
  begin
    if GLBaseSceneObject is TGLCustomSceneObject then
      with GLBaseSceneObject as TGLCustomSceneObject do begin
        Material.FrontProperties.Ambient.Color:= clrGray20;
        Material.FrontProperties.Diffuse.Color:= Couleur;//clrGray80
        Material.FrontProperties.Emission.Color:= clrBlack;
        TGLPersistentImage(Material.Texture.Image).Picture.Graphic:= nil;
        Material.Texture.disabled:= True;
        if GLBaseSceneObject is TMyFreeForm then TMyFreeForm(GLBaseSceneObject).MaterialLibrary:= nil;
        end;
    if GLBaseSceneObject.Count > 0 then
      for j:= GLBaseSceneObject.Count - 1 downto 0 do begin
        Temp:= GLBaseSceneObject.Children[j];
        AppliqueCouleur(Temp, Couleur);
        end;
  end;

begin
  if ListObjetsCourants.Count < 1 then exit;
  ColorDialog:= TColorDialog.Create(Application);
  try
    if ObjetCourant is TGLCustomSceneObject then
      with ObjetCourant as TGLCustomSceneObject do
        ColorDialog.Color:= ConvertColorVector(Material.FrontProperties.Diffuse.Color);
    if ColorDialog.Execute then
      for i:= 0 to ListObjetsCourants.Count - 1 do begin
        Objet:= TGLBaseSceneObject(ListObjetsCourants[i]);
        AppliqueCouleur(Objet, ConvertWinColor(ColorDialog.Color, 1));
        end;
  finally
    ColorDialog.Free;
    end;
end;

procedure mnTextureObjetClick(Sender: TObject);
var
  i: integer;
  Objet: TGLBaseSceneObject;

  procedure AppliqueTexture(GLBaseSceneObject: TGLBaseSceneObject;
                            FileName: string);
  var
    j: Integer;
    Temp: TGLBaseSceneObject;
  begin
    if GLBaseSceneObject is TGLCustomSceneObject then
      with GLBaseSceneObject as TGLCustomSceneObject do begin
        Material.Texture.disabled:= False;
        Material.Texture.Image.LoadFromFile(FileName);
        if GLBaseSceneObject is TMyFreeForm then TMyFreeForm(GLBaseSceneObject).MaterialLibrary:= nil;
        end;
    if GLBaseSceneObject.Count > 0 then
      for j:= GLBaseSceneObject.Count - 1 downto 0 do begin
        Temp:= GLBaseSceneObject.Children[j];
        AppliqueTexture(Temp, FileName);
        end;
  end;

begin
  if ListObjetsCourants.Count < 1 then exit;
  OpenPictureDialog:= TOpenPictureDialog.Create(Application);
  try
    OpenPictureDialog.InitialDir:= CheminFichiers;
    OpenPictureDialog.Filter:= GmXMLLangue.GetStringByPath('Boites\All') + ' (*.dib;*.gif;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.dib;*.gif;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf';
    OpenPictureDialog.FileName:= '';
    if OpenPictureDialog.Execute then begin
      Attendre:= True;
      Screen.Cursor:= crHourGlass;
      for i:= 0 to ListObjetsCourants.Count - 1 do begin
        Objet:= TGLBaseSceneObject(ListObjetsCourants[i]);
        AppliqueTexture(Objet, OpenPictureDialog.FileName);
        end;
      Attendre:= False;
      Screen.Cursor:= crDefault;
      end;
  finally
    OpenPictureDialog.Free;
    end;
end;

procedure mnTextureTransClick(Sender: TObject);
var
  i: integer;
  Objet: TGLBaseSceneObject;

  procedure AppliqueTexture(GLBaseSceneObject: TGLBaseSceneObject;
                            FileName: string);
  var
    j: Integer;
    Temp: TGLBaseSceneObject;
  begin
    if GLBaseSceneObject is TGLCustomSceneObject then
      with GLBaseSceneObject as TGLCustomSceneObject do begin
        Material.Texture.disabled:= False;
        Material.Texture.Image.LoadFromFile(FileName);
        Material.blendingmode := bmTransparency;
        Material.Texture.texturemode   := tmReplace;{tmModulate;}
        Material.Texture.imageAlpha    := tiaTopLeftPointColorTransparent;//tiaSuperBlackTransparent;
        end;
    if GLBaseSceneObject.Count > 0 then
      for j:= GLBaseSceneObject.Count - 1 downto 0 do begin
        Temp:= GLBaseSceneObject.Children[j];
        AppliqueTexture(Temp, FileName);
        end;
  end;

begin
  if ListObjetsCourants.Count < 1 then exit;
  OpenPictureDialog:= TOpenPictureDialog.Create(Application);
  try
    OpenPictureDialog.InitialDir:= CheminFichiers;
    OpenPictureDialog.Filter:= GmXMLLangue.GetStringByPath('Boites\All') + ' (*.dib;*.gif;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.dib;*.gif;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf';
    OpenPictureDialog.FileName:= '';
    if OpenPictureDialog.Execute then begin
      Attendre:= True;
      Screen.Cursor:= crHourGlass;
      for i:= 0 to ListObjetsCourants.Count - 1 do begin
        Objet:= TGLBaseSceneObject(ListObjetsCourants[i]);
        AppliqueTexture(Objet, OpenPictureDialog.FileName);
        end;
      Attendre:= False;
      Screen.Cursor:= crDefault;
      end;
  finally
    OpenPictureDialog.Free;
    end;
end;

procedure mnTransparenceClick(Sender: TObject);
begin
  if ListObjetsCourants.Count < 1 then exit;
  MyProcedureStyle:= mpsTrans;
  Application.CreateForm(TFTrackBar, FTrackBar);
  try
    with FTrackBar do begin
      OnShow:= MyProcedure_OnShow;
      TrackBar1.OnChange:= MyProcedure_OnChange;
      caption:= GmXMLLangue.GetStringByPath('popup\Transparency');
      showmodal;
      end;
  finally
    FTrackBar.free;
    end;
end;

procedure mnMinorRadiusClick(Sender: TObject);
begin
  if ListObjetsCourants.Count < 1 then exit;
  MyProcedureStyle:= mpsMinorRadius;
  Application.CreateForm(TFTrackBar, FTrackBar);
  try
    with FTrackBar do begin
      OnShow:= MyProcedure_OnShow;
      TrackBar1.OnChange:= MyProcedure_OnChange;
      caption:= GmXMLLangue.GetStringByPath('popup\ToreMinorRadius');
      showmodal;
      end;
  finally
    FTrackBar.free;
    end;
end;

procedure mnReNommerClick(Sender: TObject);
var
  a: string;
begin
  a:= InputBox(GmXMLLangue.GetStringByPath('Divers\RenameObject'),
               GmXMLLangue.GetStringByPath('Divers\EditNewName'),
               ObjetCourant.Name);
  CreeNomUnique(TheWorld, ObjetCourant, a);
  MetAJourInterface;
end;

procedure mnCopierClick(Sender: TObject);
var
  i: integer;
  l: TStringList;
begin
  if ObjetCourant = nil then exit;
  AfficheAxes(False);
  for i:= 0 to ListObjetsCourants.Count - 1 do
    if i = 0
      then CopierComponent(TComponent(ListObjetsCourants[i]), True)
      else CopierComponent(TComponent(ListObjetsCourants[i]), False);
  AfficheAxes(True);
end;

procedure CopierComponent(Component: TComponent; Vider: Boolean);
var
  s: Longint;
  MemoryStream: TMemoryStream;
begin
  if Vider then begin
    MemoryStreamAColler.clear;
    MemoryStreamAColler.Position:= 0;
    NbObjetsAColler:= 0;
    end;
  NbObjetsAColler:= NbObjetsAColler + 1;
  MemoryStream:= TMemoryStream.Create;
  try
    MemoryStream.WriteComponent(Component);
    s:= MemoryStream.size;
    MemoryStreamAColler.Write(s, SizeOf(s));
    MemoryStream.Position:= 0;
    MemoryStreamAColler.CopyFrom(MemoryStream, s);
  finally
    MemoryStream.Free;
    end;
  YAAColler:= True;
end;

procedure mnCollerClick(Sender: TObject);
var
  i: integer;
  Component: TComponent;
begin
  if YAAColler = False then exit;
  YAAColler:= False;
  try
    MemoryStreamAColler.Position:= 0;
    for i:= 0 to NbObjetsAColler - 1 do begin
      Component:= CollerComponent;
      if i = 0
        then Selectionne(TGLBaseSceneObject(Component), True)
        else Selectionne(TGLBaseSceneObject(Component), False);
      end;
    VerifierNoms(TheWorld);
    MetAJourInterface;
  finally
    sleep(1000);
    YAAColler:= True;
    end;
end;

function CollerComponent: TComponent;
var
  s: Longint;
  Component: TComponent;
  MemoryStream: TMemoryStream;
begin
  Result:= nil;
  if NbObjetsAColler = 0 then exit;
  MemoryStream:= TMemoryStream.Create;
  try
    MemoryStreamAColler.Read(s, SizeOf(s));
    MemoryStream.CopyFrom(MemoryStreamAColler, s);
    MemoryStream.Position:= 0;
    Component:= MemoryStream.ReadComponent(nil);
    CreeNomUnique(TheWorld, Component, Component.Name);
    GroupeCourant.AddChild(TGLBaseSceneObject(Component));
    ChargeObjetFreeForm(TGLBaseSceneObject(Component));
    Application.ProcessMessages;
    Result:= Component;
  finally
    MemoryStream.Free;
    end;
end;

procedure mnSupprimerClick(Sender: TObject);
var
  i: integer;
begin
  if Assigned(ObjetCourant) then
    if MessageDlg(GmXMLLangue.GetStringByPath('Divers\DeleteSelectedObject'),
                  mtConfirmation,
                  [mbYes, mbNo],
                  0) = mrYes then begin
      for i:= ListObjetsCourants.Count - 1 downto 0 do begin
        if UtilsSelect_ObjAnimations <> nil then
          UtilsSelect_ObjAnimations.SupprimeComponent(TGLBaseSceneObject(ListObjetsCourants[i]));
        TGLBaseSceneObject(ListObjetsCourants[i]).free;
        ListObjetsCourants.Delete(i);
        end;
      ListObjetsCourants.Clear;
      ObjetCourant:= nil;
      MetAJourInterface;
      end;
end;

procedure mnToutSelectionnerClick(Sender: TObject);
var
  i: integer;
begin
  if GroupeCourant.Count > 0 then
    for i:= 0 to GroupeCourant.Count - 1 do
      if i = 0
        then Selectionne(GroupeCourant.Children[i], True)
        else Selectionne(GroupeCourant.Children[i], False);
  MetAJourInterface;
end;

procedure mnGrouperClick(Sender: TObject);
var
  i: integer;
  Groupe, Objet: TGLBaseSceneObject;
begin
  if ListObjetsCourants.Count < 1 then exit;
  AfficheAxes(False);
  Groupe:= TGLDummyCube(GroupeCourant.AddNewChild(TGLDummyCube));
  for i:= ListObjetsCourants.Count - 1 downto 0 do begin
    Objet:= TGLBaseSceneObject(ListObjetsCourants[i]);
    Objet.MoveTo(Groupe);
    end;
  Deselectionne;
  Selectionne(Groupe, True);
  CreeNomUnique(TheWorld, Groupe, 'Groupe');
  MetAJourInterface;
end;

procedure mnDeGrouperClick(Sender: TObject);
var
  ScaleGroupe: TVector;

  procedure AppliqueDeGrouper(DummyCube: TGLDummyCube);
  var
    i, j: Integer;
    Temp, NewTemp: TGLBaseSceneObject;
    p, d, s, u: TVector;
  begin
    if DummyCube.Count > 0 then
      for i:= DummyCube.Count - 1 downto 0 do begin
        Temp:= DummyCube.Children[i];
        p:= Temp.AbsolutePosition;
        d:= Temp.AbsoluteDirection;
        s:= Temp.Scale.AsVector;
        for j:= 0 to 3 do
          s[j]:= s[j] * ScaleGroupe[j];
        u:= Temp.AbsoluteUp;
        CopierComponent(TComponent(Temp), True);
        MemoryStreamAColler.Position:= 0;
        NewTemp:= TGLBaseSceneObject(CollerComponent);
        with NewTemp do begin
          Position.AsVector:= p;
          Direction.AsVector:= d;
          Scale.AsVector:= s;
          Up.AsVector:= u;
          end;
        end;
  end;

var
  Groupe: TGLDummyCube;
begin
  if not (ObjetCourant is TGLDummyCube) then exit;
  Groupe:= TGLDummyCube(ObjetCourant);
  ScaleGroupe:= Groupe.Scale.AsVector;
  AppliqueDeGrouper(Groupe);
  DeSelectionne;
  Groupe.Free;
  MetAJourInterface;
end;

procedure mnDeGrouperToutClick(Sender: TObject);

  procedure AppliqueDeGrouper(DummyCube: TGLDummyCube; ScaleGroupe: TVector);
  var
    i, j: Integer;
    Temp, NewTemp: TGLBaseSceneObject;
    p, d, s, u: TVector;
  begin
    if DummyCube.Count > 0 then
      for i:= DummyCube.Count - 1 downto 0 do begin
        Temp:= DummyCube.Children[i];
        p:= Temp.AbsolutePosition;
        d:= Temp.AbsoluteDirection;
        s:= Temp.Scale.AsVector;
        for j:= 0 to 3 do
          s[j]:= s[j] * ScaleGroupe[j];
        u:= Temp.AbsoluteUp;
        CopierComponent(TComponent(Temp), True);
        MemoryStreamAColler.Position:= 0;
        NewTemp:= TGLBaseSceneObject(CollerComponent);
        with NewTemp do begin
          Position.AsVector:= p;
          Direction.AsVector:= d;
          Scale.AsVector:= s;
          Up.AsVector:= u;
          end;
        end;
  end;

var
  Groupe, TempGroupe: TGLDummyCube;
  i: integer;
begin
  DeSelectionne;

  Groupe:= nil;
  if TheWorld.Count > 0 then
    for i:= TheWorld.Count - 1 downto 0 do
      if TheWorld.Children[i] is TGLDummyCube then
        Groupe:= TGLDummyCube(TheWorld.Children[i]);
  while Groupe <> nil do begin
    AppliqueDeGrouper(Groupe, Groupe.Scale.AsVector);
    Groupe.Free;
    Groupe:= nil;
    if TheWorld.Count > 0 then
      for i:= TheWorld.Count - 1 downto 0 do
        if TheWorld.Children[i] is TGLDummyCube then
          Groupe:= TGLDummyCube(TheWorld.Children[i]);
    end;

  //AppliqueDeGrouper(Groupe, Groupe.Scale.AsVector);
  //Groupe.Free;
  MetAJourInterface;
  showmessage('aa');
end;

procedure mnEntrerDansGroupeClick(Sender: TObject);
begin
  if not (ObjetCourant is TGLDummyCube) then exit;
  GroupeCourant:= TGLDummyCube(ObjetCourant);
  DeSelectionne;
  MetAJourInterface;
end;

procedure mnSortirDuGroupeClick(Sender: TObject);
begin
  GroupeCourant:= TheWorld;
  DeSelectionne;
  MetAJourInterface;
end;

procedure mnScaleAllClick(Sender: TObject);
begin
  MyProcedureStyle:= mpsScaleAll;
  Application.CreateForm(TFSpinEdit, FSpinEdit);
  try
    with FSpinEdit do begin
      OnShow:= MyProcedure_OnShow;
      FloatSpinEdit1.OnChange:= MyProcedure_OnChange;
      caption:= GmXMLLangue.GetStringByPath('popup\ScaleAll');
      Label1.caption:= GmXMLLangue.GetStringByPath('popup\ScaleAllText');
      BitBtn1.caption:= GmXMLLangue.GetStringByPath('Hints\OK');
      BitBtn2.caption:= GmXMLLangue.GetStringByPath('Hints\Cancel');
      if ShowModal = mrCancel then ScaleAll(TheWorld, 1/FSpinEdit.ValeurActuelle);
      end;
  finally
    FSpinEdit.free;
    end;
end;

























































function MouseWorldPos(GLSceneViewer: TGLSceneViewer; x, y: Integer): TVector;
var
  v: TVector;
begin
  if Assigned(ObjetCourant) or BougeCamera
    then begin
      y:= GLSceneViewer.Height - y;
      SetVector(v, x, y, 0);
      Result:= GLSceneViewer.Buffer.ScreenToWorld(v);
      end
    else SetVector(Result, NullVector);
end;


procedure AfficheAxes(Affiche: boolean);
var
  i: integer;
begin
  if ListObjetsCourants.Count > 0 then
    for i:= ListObjetsCourants.Count - 1 downto 0 do
      TGLBaseSceneObject(ListObjetsCourants[i]).ShowAxes:= Affiche;
end;



procedure MettreAJourComboBox;
var
  i: Integer;
begin
  if ComboBox_UtilsSelect = nil then exit;
  ComboBox_UtilsSelect.Items.clear;
  for i:= 0 to GroupeCourant.Count - 1 do
    ComboBox_UtilsSelect.Items.addObject(GroupeCourant.Children[i].name, GroupeCourant.Children[i]);
  if ObjetCourant <> nil then
    ComboBox_UtilsSelect.ItemIndex:= ComboBox_UtilsSelect.Items.IndexOf(ObjetCourant.Name);
end;



procedure TrouveSelection(GLSceneViewer: TGLSceneViewer);
var
  Pick: TGLBaseSceneObject;
  Continue: boolean;
  i: integer;
begin
  Pick:= GLSceneViewer.Buffer.GetPickedObject(mx, my);
  if Assigned(Pick) then begin
    if Pick = TGLBaseSceneObject(GroupeCourant) then Pick:= nil
    else if ListNoPick.Count > 0 then
      for i:= 0 to ListNoPick.Count - 1 do
        if Pick = TGLBaseSceneObject(ListNoPick[i]) then Pick:= nil;
    end;

  if Assigned(Pick) then begin
    Continue:= True;
    while Continue do begin
      if Pick.Parent = GroupeCourant
        then Continue:= False
        else if Pick.Parent = TheWorld then begin
          Continue:= False;
          Pick:= nil;
          end;
      if Continue then Pick:= Pick.Parent;
      end;
    end;

  if SelectionMultiple
    then begin
      if Assigned(Pick)
        then begin
          Pick.ShowAxes:= not(Pick.ShowAxes);
          if Pick.ShowAxes
            then Selectionne(Pick, False)
            else begin
              ListObjetsCourants.Delete(ListObjetsCourants.IndexOf(Pick));
              if ListObjetsCourants.count < 1 then ObjetCourant:= nil;
              end;
          end
        else DeSelectionne;
      end
    else begin
      Selectionne(Pick, True);
      end;
end;

procedure Selectionne(Objet: TGLBaseSceneObject; Seul: boolean);
begin
  if Seul
    then begin
      DeSelectionne;
      ObjetCourant:= Objet;
      if Assigned(Objet)
        then begin
          Objet.ShowAxes:= True;
          ComboBox_UtilsSelect.ItemIndex:= ComboBox_UtilsSelect.Items.IndexOf(Objet.Name);
          ListObjetsCourants.Add(Objet);
          end
        else ComboBox_UtilsSelect.ItemIndex:= -1;
      end
    else begin
      if ListObjetsCourants.count < 1
        then Selectionne(Objet, True)
        else if Assigned(Objet) then begin
          Objet.ShowAxes:= True;
          ListObjetsCourants.Add(Objet);
          end;
      end;
end;

procedure DeSelectionne;
var
  i: integer;
begin
  AfficheAxes(False);
  if Assigned(ObjetCourant) then begin
    ObjetCourant:= nil;
    ComboBox_UtilsSelect.ItemIndex:= -1;
    end;
  if ListObjetsCourants.Count > 0 then
    for i:= ListObjetsCourants.Count - 1 downto 0 do
      ListObjetsCourants.Delete(i);
  ListObjetsCourants.Clear;
end;


end.
